<?php
namespace Backend\Controller;

use Backend\Controller\BackendController;
use Common\Aide\UpdateAide;

class BackupController extends BackendController{
	
	/**
	 * 网站设置的基本信息
	 * @时间: 2019年8月13日15:39:45
	 * @author: GuoPeng
	 */
	public function index(){
		$custom_info = WebSiteConfig(9);
		$added_files = json_decode($custom_info["added_files"],true);
		$added_files = $added_files ? $added_files : array();
		//获取备份所在的绝对目录
		$dir0 = "Backup/UserBackup";//一键备份目录
		$dir1 = "Backup/Databak";//SQL备份目录
		$dir2 = "Backup/Softwarebak";//程序备份目录
		$files1 = array();//SQL备份列表
		$files2 = array();//程序备份列表
		if($files = opendir($dir0)){
			while(($file = readdir($files)) !== false){
				if($file !== "." && $file !== ".."){
					if(is_file($dir0."/".$file)){
						$filetime = filemtime($dir0."/".$file);
						if(substr($file,-4) == ".sql"){
							$files1[] = array(
								"name"=>$file,
								"dir"=>$dir0,
								"type"=>"数据库备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}elseif(substr($file,-4) == ".zip"){
							$files2[] = array(
								"name"=>$file,
								"dir"=>$dir0,
								"type"=>"程序备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}
					}
				}
			}
			closedir($files);
		}
		if($files = opendir($dir1)){
			while(($file = readdir($files)) !== false){
				if($file !== "." && $file !== ".."){
					if(is_file($dir1."/".$file)){
						$filetime = filemtime($dir1."/".$file);
						if(substr($file,-4) == ".sql"){
							$files1[] = array(
								"name"=>$file,
								"dir"=>$dir1,
								"type"=>"数据库备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}elseif(substr($file,-4) == ".zip"){
							$files2[] = array(
								"name"=>$file,
								"dir"=>$dir1,
								"type"=>"程序备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}
					}
				}
			}
			closedir($files);
		}
		if($files = opendir($dir2)){
			while(($file = readdir($files)) !== false){
				if($file !== "." && $file !== ".."){
					if(is_file($dir2."/".$file)){
						$filetime = filemtime($dir2."/".$file);
						if(substr($file,-4) == ".sql"){
							$files1[] = array(
								"name"=>$file,
								"dir"=>$dir2,
								"type"=>"数据库备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}elseif(substr($file,-4) == ".zip"){
							$files2[] = array(
								"name"=>$file,
								"dir"=>$dir2,
								"type"=>"程序备份",
								"time"=>date("Y-m-d H:i:s",$filetime)
							);
						}
					}
				}
			}
			closedir($files);
		}
		$files = array_merge($files1,$files2);
		$times = array();
		foreach($files as $k=>$v){
			$times[$k] = strtotime($v["time"]);
		}
		array_multisort($times,SORT_DESC,SORT_NUMERIC,$files);
		$this->assign([
			'files' => $files,
			'added_files' => $added_files
		]);
		$this->display();
	}

	/**
	 * 备份目录设置
	 * @时间: 2019年8月29日14:26:26
	 * @author: GuoPeng
	 */
	public function bak_dir(){
		$custom_info = WebSiteConfig(9);
		$bak_dir = $custom_info["bak_dir"];
		if($bak_dir == ""){
			$bak_dir = array();
		}else{
			$bak_dir = json_decode($custom_info["bak_dir"],true);
		}
		$beizhu = array(
			"Application"=>"(主要文件目录)",
			"Backup"=>"(备份文件目录)",
			"Public"=>"(静态资源目录)",
			"ThinkPHP"=>"(框架核心目录)",
			"Uploads"=>"(上传文件目录)",
			"Update"=>"(下载文件目录)",
			"vendor"=>"(插件库目录)",
			".htaccess"=>"(伪静态规则)",
			"favicon.ico"=>"(网站图标)",
			"index.php"=>"(入口文件)",
			"install.php"=>"(安装入口文件)"
		);
		$dir = ".";//程序跟目录
		$files1 = array();//程序目录列表
		if($files = opendir($dir)){
			while(($file = readdir($files)) !== false){
				if($file !== "." && $file !== ".."){
					if(is_file($dir."/".$file)){
						$files1[] = array(
							"name"=>iconv("GB2312","UTF-8",$file),
							"beizhu" => $beizhu[$file]
						);
					}
					if(is_dir($dir."/".$file)){
						$files1[] = array(
							"name"=>iconv("GB2312","UTF-8",$file),
							"beizhu" => $beizhu[$file]
						);
					}
				}
			}
			closedir($files);
		}
		$bak_dirs = $files1;
		$this->assign(["bak_dirs" => $bak_dirs,"bak_dir" => $bak_dir]);
		$this->display();
	}

	/**
	 * 删除备份
	 * @时间: 2019年8月13日15:39:45
	 * @author: GuoPeng
	 */
	public function erase(){
		$data = request(true);
		$file = $data["name"];
		if(is_file($file)){
			if(substr($file,-4) == ".sql" || substr($file,-4) == ".zip"){
				if(unlink($file)){
					$this->success("删除成功！","",true);
				}else{
					$this->error("删除失败！","",true);
				}
			}else{
				$this->error("文件后缀错误！","",true);
			}
		}else{
			$this->error("备份文件不存在！","",true);
		}
	}

	/**
	 * 备份数据库
	 * @时间: 2019年8月13日15:39:45
	 * @author: GuoPeng
	 * @return bool
	 */
	public function bak_sql(){
		$updater = new UpdateAide();
		//备份数据
		$updater->mysql_backup_hander->setPath(C("BACKUP_PATH")."Databak");
		$res = $updater->mysql_backup_hander->backup();
		if($res){
			$msg = '备份成功，已经数据库备份在'.C('BACKUP_PATH').'Databak目录下，为了站点安全考虑，请下载后立即删除！';
			$this->success($msg,'',true);
		}else{
			$msg = !$res ? $updater->mysql_backup_hander->error() : $updater->info;
			$this->error($msg,'',true);
		}
	}

	/**
	 * 备份程序
	 * @时间: 2019年8月13日15:39:45
	 * @author: GuoPeng
	 * @return bool
	 */
	public function bak_program(){
		$updater = new UpdateAide();
		//设置备份目录
		$updater->mysql_backup_hander->setPath(C("BACKUP_PATH")."Softwarebak");
		//备份文件
		$res = $updater->Softwarebak(true,"UserBackup");
		if($res){
			$msg = '备份成功，已经程序备份在'.C('BACKUP_PATH').'Softwarebak目录下，为了站点安全考虑，请下载后立即删除！';
			$this->success($msg,'',true);
		}else{
			$msg = !$res ? $updater->mysql_backup_hander->error() : $updater->info;
			$this->error($msg,'',true);
		}
	}

	/**
	 * 一键备份
	 * @时间: 2019年8月13日15:39:45
	 * @author: GuoPeng
	 * @return bool
	 */
	public function one_touch_backup(){
		if(!is_callable("set_time_limit")){
			$msg = "set_time_limit()未开启，不支持一键备份！";
			$this->error($msg,'',true);
		}
		$updater = new UpdateAide();
		//备份数据
		$updater->mysql_backup_hander->setPath(C("BACKUP_PATH")."UserBackup");
		$res["data"] = $updater->mysql_backup_hander->backup();
		//备份文件
		$res["software"] = $updater->Softwarebak(true,"UserBackup");
		if($res){
			$msg = '备份成功，已经数据和程序备份在'.C('BACKUP_PATH').'UserBackup目录下，为了站点安全考虑，请下载后立即删除！';
			$this->success($msg,"",true);
		}else{
			$msg = !$res ? $updater->mysql_backup_hander->error() : $updater->info;
			$this->error($msg,"",true);
		}
	}
}