<?php
namespace Backend\Model;

use Think\Model;

/**
 * 定时任务模型类
 * @author: GuoPeng
 * @时间: 2019年4月18日14:55:59
 */
class TimingModel extends Model{
	//关联的表名
	protected $trueTableName = "agent_sys";

	const TIMING_BAR = 16;//定时任务配置

	/**
	 * 定时任务逻辑
	 * @时间: 2019年4月18日14:53:40
	 * @author: GuoPeng
	 * @return bool
	 */
	public function timing_task(){
		$timing = WebSiteConfig(16);
		$del_over = $timing["del_over"];
		$mail = $timing["mail"];
		$ptype_ids = $timing["ptype"] ? explode(",",$timing["ptype"]) : array();
		$product_names = array(7=>"国内主机",8=>"香港主机",15=>"织梦主机",16=>"美国主机",17=>"云虚拟主机",12=>"云空间",10=>"域名",1=>"VPS",13=>"快云VPS",18=>"快云服务器",20=>"SSL",22=>"快云数据库",23=>"快云存储",24=>"抗D");
		$product_types = array(7=>"host",8=>"hkhost",15=>"dedehost",16=>"usahost",17=>"cloudVirtual",12=>"cloudspace",10=>"domain",1=>"vps",13=>"fastcloudvps",18=>"cloudserver",20=>"ssl",22=>"clouddb",23=>"cloudstorage",24=>"cloudsafe");
		$sync_log = $mail_log = $del_log = "";
		if(empty($ptype_ids)){
			$sync_log = "未设置要同步的产品分类的业务！\n\r";
		}
		if($del_over != 1){
			$del_log = "未设置删除过期业务！\n\r";
		}
		if($mail != 1){
			$mail_log = "未设置发送到期提醒邮件！\n\r";
		}
		if(empty($ptype_ids) && $del_over != 1 && $mail != 1){
			$return["state"] = true;
			$return["info"] = $sync_log.$del_log.$mail_log;
			return $return;
		}
		$mail_config = WebSiteConfig(13);
		$from = $mail_config['mailaddress']; // 邮件发送者email地址
		$host = $mail_config['smtpaddress']; // 您的企业邮局域名
		$port = $mail_config['portaddress']; // 端口号
		$psd = $mail_config['mailpassword']; // 邮局密码
		if(!$from && !$host && !$port && !$psd){
			$mail_log = "后台发邮件邮箱设置错误，不可发邮件！\n\r";
			$mail = 0;
		}
		if(!empty($ptype_ids) || $del_over == 1 || $mail == 1){
			$members = M("member")->field("user_id,user_name")->select();
			$user_mails = array();
			foreach($members as $member){
				$user_mails[$member["user_id"]] = $member["user_mail"];
			}
			foreach($product_types as $k=>$v){
				$sync_ok = $sync_err = $sync_all = $del_ok = $del_err = $del_all = $mail_ok = $mail_err = $mail_all = $mail_yi = $mail_wu = 0;
				$pname = $product_names[$k];
				$ptype = $v;
				if($k == 7 || $k == 8 || $k == 15 || $k == 16 || $k == 17){
					//虚拟主机
					$model = new VirtualhostModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("business_id,access")->where(array("virtual_type" => ["eq",array_search($ptype,$model->internalPtype)]))->select();
						if(empty($datas)){
							if(in_array($k,$ptype_ids)){
								$sync_log .= "未获取到{$pname}业务！\n\r";
							}
						}else{
							$respository = new \Common\Respository\VirtualhostBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->VirtualhostBusinessSynchronizing($data["business_id"],$ptype,$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state")->where(array("virtual_type" => ["eq",array_search($ptype,$model->internalPtype)]))->select();
						if(empty($datas)){
							if($del_over == 1){
								$del_log .= "未获取到{$pname}业务！\n\r";
							}
						}else{
							foreach($datas as $data){
								if($data["state"] != 1){
									$del_all++;
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state,mail_state")->where(array("virtual_type" => ["eq",array_search($ptype,$model->internalPtype)]))->select();
						if(empty($datas)){
							if($mail == 1){
								$mail_log .= "未获取到{$pname}业务！\n\r";
							}
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))
														 ->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 12){
					//云空间
					$model = new CloudspaceModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("business_id,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\CloudspaceBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->CloudspaceBusinessSynchronizing($data["business_id"],$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif ($k == 1){
					//VPS
					$model = new VpsModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("business_id,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\VpsBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->VpsBusinessSynchronizing($data["business_id"],$ptype,$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))
														 ->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif ( $k == 13){
					//快云VPS
					$model = new FastVpsModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("business_id,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\VpsBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->VpsBusinessSynchronizing($data["business_id"],$ptype,$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))
														 ->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 9 || $k == 10){
					//域名
					$model = new DomainModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("api_bid,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\DomainRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->DomainBusinessSynchronizing($data["api_bid"],"api_bid",$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))
														 ->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 18){
					//快云服务器
					$model = new CloudserverModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("api_bid,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\CloudserverBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->CloudserverBusinessSynchronizing($data["api_bid"],"api_bid",$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 22){
					//快云数据库
					$model = new ClouddbModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("api_bid,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\ClouddbBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->ClouddbBusinessSynchronizing($data["api_bid"],"api_bid",$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 20){
					//SSL
					$model = new SslModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("business_id,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\SslRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->SslBusinessSynchronizing($data["business_id"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,business_id,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 23){
					//快云存储
					$model = new CloudstorageModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("api_bid,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\CloudstorageBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->CloudstorageBusinessSynchronizing($data["api_bid"],"api_bid",$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}elseif($k == 24){
					//云安全-抗D
					$model = new KangdModel();
					if(in_array($k,$ptype_ids)){
						$datas = $model->field("api_bid,access")->select();
						if(empty($datas)){
							$sync_log .= "未获取到{$pname}业务！\n\r";
						}else{
							$respository = new \Common\Respository\KangdBusinessRespository($model);
							foreach($datas as $data){
								$sync_all++;
								$result = $respository->BusinessSynchronizing($data["api_bid"],"api_bid",$data["access"]);
								if($result == false){
									$sync_err++;
								}else{
									$sync_ok++;
								}
							}
							$sync_log .= "共同步{$pname}业务{$sync_all}条，成功{$sync_ok}条，失败{$sync_err}条！\n\r";
						}
					}
					if($del_over == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state")->select();
						if(empty($datas)){
							$del_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								$del_all++;
								if($data["state"] == 3){
									$res = $model->where(array("id" => $data["id"]))->delete();
									if($res === false){
										$del_err++;
									}else{
										$del_ok++;
									}
								}
							}
							$del_log .= "共删除过期{$pname}业务{$del_all}条，成功{$del_ok}条，失败{$del_err}条！\n\r";
						}
					}
					if($mail == 1){
						$datas = $model->field("id,api_bid,user_id,overdue_time,state,mail_state")->select();
						if(empty($datas)){
							$mail_log .= "未获取到{$pname}业务！\n\r";
						}else{
							foreach($datas as $data){
								if($data["mail_state"] == 1){
									$mail_yi++;
								}else{
									$overdue_time = strtotime($data["overdue_time"]);
									$new = strtotime("+1 month");
									if($overdue_time < $new){
										$mail_all++;
										$data["product_type_id"] = $k;
										$data["business_name"] = $pname;
										if(empty($user_mails[$data["user_id"]])){
											$mail_wu++;
										}
										//组装邮件内容
										$mail_content = HTMLContentForEmail(1,$data,$members);
										//发送邮件
										$res = postOffice($user_mails[$data["user_id"]],$mail_content["subject"],$mail_content["body"],1);
										if($res["status"] == 1){
											$mail_err++;
										}else{
											$mail_ok++;
											$res = $model->where(array("id" => $data["id"]))->save(array("mail_state" => 1));
										}
									}
								}
							}
							$mail_log .= "共发现即将过期{$pname}业务{$mail_all}条，{$mail_yi}条业务已发送过邮件，{$mail_wu}条业务没有所属会员或所属会员无邮箱，成功发送邮件{$mail_ok}条，失败{$mail_err}条！\n\r";
						}
					}
				}else{}
				sleep(1);
			}
		}
		$return["state"] = true;
		$return["info"] = $sync_log.$del_log.$mail_log;
		return $return;
	}

}
