<?php
namespace Common\Aide;

date_default_timezone_set('PRC'); // 设置为中国时间
/**
 * 与景安SSL接口同步或操作的类
 * @author: GuoPeng
 * @date 2019年7月24日10:07:07
 */
class SslAide{
	//与景安SSL接口交互的类实例
	private $config = array(
		"api_url" => "http://wsafeapi.kuaiyun.cn/",//景安网络SSL证书API接口域名
		"access_key" => "34ce432e9a6afc3b63593e5a0be11522",//X-Auth-Timestamp调用者私钥，此私钥为我方提供
		"secret_key" => "078e49314a5d8ca758573ce656ee2054",//secret_key调用者秘钥，此秘钥为我方提供
		"user_id" => "152765",//景安站用户ID
	);

	/**
	 * 构造函数，初始化交易操作参数
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @throws GiantException
	 * SslAide constructor.
	 */
	public function __construct(){
		$config = $this->config;
		$user_id = $config["user_id"];
		$access_key = trim($config["access_key"]);
		if(empty($user_id)){
			throw new GiantException("用户ID不能为空！");
		}
		if(empty($access_key)){
			throw new GiantException("调用者私钥不能为空！");
		}
	}

	/**
	 * 初始化公共参数并发送CURL请求
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param array $par
	 * @return mixed
	 * @throws GiantException
	 */
	private function init_params_send($par){
		list($msec, $sec) = explode(' ', microtime());
		$msectime = (float)sprintf('%.0f', (floatval($msec) + floatval($sec)) * 1000);
		$config = $this->config;
		$date = $msectime;//接口调用时间戳，超过5分钟认为此次调用无效
		$nonce = time();//X-Auth-Nonce随机字符串，目前尚未启用验证，但建议传递该参数
		$gsig = md5($par["value"].$config["secret_key"]);//X-Auth-Sign签名,将调用参数以key=value&key=value进行排列后,与字符串secret_key进行拼接,进行MD5加密
		$url = $config["api_url"].$par["url"].$config["user_id"];
		unset($par["value"]);
		unset($par["url"]);
		$header = array(
			"Content-Type: application/json",
			"X-Auth-Access-Key:{$config["access_key"]}",
			"X-Auth-Timestamp:{$date}",
			"X-Auth-Nonce:{$nonce}",
			"X-Auth-Sign:{$gsig}"
		);
		$body = json_encode($par);
		$request = curl_init();
		curl_setopt($request,CURLOPT_URL,$url);
		curl_setopt($request,CURLOPT_HEADER,1);
		curl_setopt($request,CURLOPT_HTTPHEADER,$header);
		curl_setopt($request,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($request,CURLOPT_POST,1);
		curl_setopt($request,CURLOPT_POSTFIELDS,$body);  //$body (根据接口方处理数据类型传值：json、array等)  发送内容
		curl_setopt($request,CURLOPT_TIMEOUT,180);//超过这个时间，请求失败就中止，不至于报错
		curl_setopt($request,CURLOPT_HEADER,false);//不获取响应头  只返回正文
		$curl_errno = curl_errno($request);
		$curl_error = curl_error($request);
		$response = curl_exec($request);
		$httpCode = curl_getinfo($request,CURLINFO_HTTP_CODE);
		curl_close($request);
		if($curl_errno > 0){
			throw new GiantException("接口错误 {$curl_errno}:{$curl_error}");
		}else{
			if($httpCode == '200'){
				//返回信息
				return $response;
			}else{
				//返回错误信息
				throw new GiantException("接口错误{$response}");
			}
		}
	}

	/**
	 * 购买免费SSL证书
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param int $lbbh 产品类别编号
	 * @param int $cpbh 产品编号
	 * @param int $gmqx 购买期限（12/24），单位：月
	 * @throws GiantException
	 * @return string 接口返回值 json 或者 xml
	 */
	public function buy($lbbh,$cpbh,$gmqx){
		if(empty($cpbh)){
			throw new GiantException("产品编号不能为空！");
		}
		$par = array();
		$par["url"] = "restful/proxy/ssl/order_ssl/";
		$par["lbbh"] = $lbbh;
		$par["cpbh"] = $cpbh;
		$par["gmqx"] = $gmqx;
		$par["value"] = "lbbh={$lbbh}&cpbh={$cpbh}&gmqx={$gmqx}";
		return $this->init_params_send($par);
	}

	/**
	 * 免费SSL证书开通-保存信息
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param int $bdym 产品类别编号
	 * @param int $yzlx 验证类型（1：DNS验证，2：网站验证）
	 * @param string $email 邮箱
	 * @param string $tel 联系电话
	 * @param string $name 姓名
	 * @param int $cpbh 产品编号
	 * @param int $ddbh 订单编号
	 * @throws GiantException
	 * @return string 接口返回值 json 或者 xml
	 */
	public function save_ssl($bdym,$yzlx,$email,$tel,$name,$cpbh,$ddbh){
		if(empty($ddbh)){
			throw new GiantException("订单编号不能为空！");
		}
		$par = array();
		$par["url"] = "restful/proxy/ssl/save_ssl_info/";
		$par["bdym"] = $bdym;
		$par["yzlx"] = $yzlx;
		$par["email"] = $email;
		$par["tel"] = $tel;
		$par["name"] = $name;
		$par["cpbh"] = $cpbh;
		$par["ddbh"] = $ddbh;
		$par["value"] = "bdym={$bdym}&yzlx={$yzlx}&email={$email}&tel={$tel}&name={$name}&cpbh={$cpbh}&ddbh={$ddbh}";
		return $this->init_params_send($par);
	}

	/**
	 * 免费SSL证书开通-确认信息
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param int $cpbh 产品编号
	 * @param int $gid 购买信息ID
	 * @param int $ddbh 订单编号
	 * @throws GiantException
	 * @return string 接口返回值 json 或者 xml
	 */
	public function confirm_ssl($cpbh,$gid,$ddbh){
		if(empty($ddbh)){
			throw new GiantException("订单编号不能为空！");
		}
		$par = array();
		$par["url"] = "restful/proxy/ssl/confirm_ssl_info/";
		$par["cpbh"] = $cpbh;
		$par["gid"] = $gid;
		$par["ddbh"] = $ddbh;
		$par["value"] = "cpbh={$cpbh}&gid={$gid}&ddbh={$ddbh}";
		return $this->init_params_send($par);
	}

	/**
	 * 免费SSL证书开通-证书验证
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param int $cpbh 产品编号
	 * @param int $gid 购买信息ID
	 * @param int $pid 配置ID
	 * @throws GiantException
	 * @return string 接口返回值 json 或者 xml
	 */
	public function validate_ssl($cpbh,$gid,$pid){
		if(empty($pid)){
			throw new GiantException("配置编号不能为空！");
		}
		$par = array();
		$par["url"] = "restful/proxy/ssl/ssl_validate/";
		$par["cpbh"] = $cpbh;
		$par["gid"] = $gid;
		$par["pid"] = $pid;
		$par["value"] = "cpbh={$cpbh}&gid={$gid}&pid={$pid}";
		return $this->init_params_send($par);
	}

	/**
	 * 免费SSL证书-下载证书
	 * @author: GuoPeng
	 * @date 2019年7月24日10:07:07
	 * @param int $cpbh 产品编号
	 * @param int $pid 配置ID
	 * @throws GiantException
	 * @return string 接口返回值 json 或者 xml
	 */
	public function getdown_ssl($cpbh,$pid){
		if(empty($pid)){
			throw new GiantException("配置编号不能为空！");
		}
		$par = array();
		$par["url"] = "restful/proxy/ssl/ssl_getdown/";
		$par["cpbh"] = $cpbh;
		$par["pid"] = $pid;
		$par["value"] = "cpbh={$cpbh}&pid={$pid}";
		return $this->init_params_send($par);
	}
}

/**
 * Class GiantException 抛出错误信息类
 * @author: GuoPeng
 * @date 2019年7月24日10:07:07
 * @package Common\Aide
 */
class GiantException extends \Exception {
}