<?php
namespace Common\Controller;
use Think\Controller;

/**
 * -------------------------------------------------------
 * | 全局基础控制器
 * |@author: duanbin
 * |@时间: 2016年9月30日 上午10:35:44
 * |@version: 1.0
 * -------------------------------------------------------
 */
class BaseController extends Controller{

	//仓库管理员
	protected $respository = null;
	//数据模型
	protected $model = null;

	/**
	 * 空操作404
	 * @time 2019年8月23日10:24:47
	 */
	public function _empty(){
		$msg = "无法加载地址：".ACTION_NAME;
		$this->assign("error_info",$msg);
		$this->display('Empty/index');die;
	}

	/**
	 * 错误信息提醒
	 * @time 2019年8月23日10:24:47
	 * @author GuoPeng
	 * @param $msg
	 * @param string $url
	 */
	public function _error($msg,$url = "javascript:history.back();"){
		$this->assign("error_info",$msg);
		$this->assign("url",$url);
		$this->display("Empty/error_page");die;
	}

	/**
	 * 错误信息提醒
	 * @time 2019年8月23日10:24:47
	 * @author GuoPeng
	 * @param $msg
	 * @param string $url
	 */
	public function _mc_error($msg,$url = "javascript:history.back();"){
		$this->assign("error_info",$msg);
		$this->assign("url",$url);
		$this->display("Empty/mc_error_page");die;
	}
	
	public function _initialize(){
		$session_options = C('SESSION_OPTIONS');
		$session_options['name'] = 'user_id';
		$session_options['expire'] = 3600;
		C('SESSION_OPTIONS',$session_options);
		//5.4版本的php获取系统临时目录的bug的临时解决方案。
		if (!getenv('TMPDIR') && !getenv('TEMP') && !getenv('TMP') && !ini_get('sys_temp_dir')){
			$temp = TEMP_PATH;
 			/*if (PHP_OS == 'Windows' || PHP_OS == 'WIN32' || PHP_OS == 'WINNT'){
				$temp = TEMP_PATH;
 			}else {
 				$temp = '/tmp';
 			}*/
			$temp_dir = getenv('TMPDIR') ? getenv('TMPDIR'): $temp;
			putenv('TMPDIR='.$temp_dir);
			$temp_dir = getenv('TEMP') ? getenv('TEMP'): $temp;
			putenv('TEMP='.$temp_dir);
			$temp_dir = getenv('TMP') ? getenv('TMP'): $temp;
			putenv('TMP='.$temp_dir);
			ini_set("sys_temp_dir", $temp);
		}

	}

}
