<?php
namespace Common\Respository;

use Common\Respository\BaseRespository;

/**
 * 会员API仓储类
 * 可选择实现orderExtra()，whereExtra()，fieldsExtra()方法，
 * 为了有连表的情况出现，额外设置别名
 * @author: GuoPeng
 * @时间: 2019年8月2日17:02:53
 * @version: 1.0
 */
class ApiRespository extends BaseRespository{
	/**
	 * 扩充查询字段，在连表的情况下有别名使用
	 * @时间: 2019年8月2日17:02:53
	 * @author: GuoPeng
	 * @param $fields
	 * @return array
	 */
	protected function fieldsExtra($fields){
		return $fields;
	}
	
	/**
	 * 返回一个join数组
	 * 连表查询时，请实现此方法
	 * @时间: 2019年8月2日17:02:53
	 * @author: GuoPeng
	 * @return array
	 */
	protected function joinsExtra(){
		return [];
	}
	
	/**
	 * 额外的扩充条件，这里要增加一项
	 * product_id值得条件
	 * @时间: 2019年8月2日17:02:53
	 * @author: GuoPeng
	 * @param $where
	 * @return array
	 */
	protected function whereExtra($where){
		return $where;
	}

	/**
	 * 额外的扩充排序，这里要增加一项
	 * product_id值得条件
	 * @时间: 2019年8月2日17:02:53
	 * @author: GuoPeng
	 * @param $order
	 * @return string
	 */
	public function orderExtra($order){
		//增加默认排序规则
		if(empty($order)){
			//到期时间倒序
			$order = "user_id DESC";
		}
		return $order;
	}
	
}