<?php
namespace Common\Respository;

use Common\Aide\AgentAide;
use Common\Respository\BusinessRespository;
use Common\Data\GiantAPIParamsData as GD;


/**
 * 交易仓储类
 * 可选择实现orderExtra()，whereExtra()，fieldsExtra()方法，
 * 为了有连表的情况出现，额外设置别名
 * @author: GuoPeng
 * @时间: 2019年2月27日14:29:36
 */
class DomaintemplateRespository extends BusinessRespository{

	/**
	 * 同步域名模板的方法
	 * @时间: 2019年2月27日14:29:36
	 * @author: GuoPeng
	 * @param $template_id
	 * @return bool
	 */
	public function DomainTemplateSynchronizing($template_id){
		if(is_numeric($template_id)){
			$model = M("domain_template");
			//先获取本地域名模板信息
			$template_info_exists = $model->where(['id' => ['eq',$template_id]])->find();
			if(empty($template_info_exists)){
				return ['status' => false,'msg' => '该模板不存在！'];
			}else{
				$api_config = WebSiteConfig(2);//获取网站配置
				$api_access = $api_config["api_access"] + 0;
				$api_access = $api_access ? $api_access : 1;
				$agent = new AgentAide(1,$api_access);
				$transaction = $agent->servant;
				$uid = $save['user_id'] = session("user_id");
				$ptype = GD::PTYPE_DOMAIN;
				$pname = "getdomainmodellist";
				$tid = GD::TID_DOMAIN;
				$log_info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}";
				$template['modelid'] = $template_info_exists['contact_id'];
				$template['input_name'] = $template_info_exists['registry'];
				try{
					$result = $transaction->template_tb($template);
					api_log($uid,$log_info,$result,"域名模板同步成功");
				}catch(\Exception $e){
					api_log($uid,$log_info,$e->getMessage(),"域名模板同步失败");
					$return["msg"] = business_code(-9);
					$return["status"] = false;
					return $return;
				}
				$xstr = json_decode($result,true);
				if($xstr['code'] === 0){
					if($xstr['info']['showCount'] != 0){
						$data = $xstr['info']['pageResult'][0];
						$save['registrar_type'] = $data['registrar_type'];//注册商类型
						$save['owner_type'] = $data['owner_type'];//域名类型：1：个人，2：企业
						$save['model_name'] = $data['mouldName'];//模板名
						$save['sm_state'] = $data['smzt'];//实名状态：空/0未实名 1审核成功 2审核拒绝 3审核中
						$save['state'] = $data['zt']; //模板状态 0：创建成功 1：创建失败
						$save['contact_id'] = $data['contactid'];//模板编号
						$save['create_time'] = date('Y-m-d H:i:s',strtotime($data['cjsj']));
						$save['owner_xing_zh'] = $data['owner_xing'];
						$save['owner_ming_zh'] = $data['owner_ming'];
						$save['remark'] = $data['remark'];
						$save['id_type'] = $data['idtype'];
						$save['id_code'] = $data['idcode'];
						$save['org_type'] = $data['orgprooftype'];
						$save['org_code'] = $data['orgcode'];
						$save['smbh'] = $data['bh'];
						$save['owner_zh'] = $data['owner_zh'];
						$save['owner_ln_zh'] = $data['owner_ln_zh'];
						$save['owner_fn_zh'] = $data['owner_fn_zh'];
						$save['owner_country'] = $data['owner_country'];
						$save['owner_province_zh'] = $data['owner_province_zh'];
						$save['owner_city_zh'] = $data['owner_city_zh'];
						$save['owner_street_zh'] = $data['owner_street_zh'];
//						$save['owner_xing'] = $data['owner_xing'];
//						$save['owner_ming'] = $data['owner_ming'];
						$save['owner'] = $data['owner'];
						$save['owner_ln'] = $data['owner_ln'];
						$save['owner_fn'] = $data['owner_fn'];
						$save['owner_province'] = $data['owner_province'];
						$save['owner_city'] = $data['owner_city'];
						$save['owner_street'] = $data['owner_street'];
						$save['owner_zip'] = $data['owner_zip'];
						$save['owner_email'] = $data['owner_email'];
						$save['owner_telC'] = $data['owner_telC'];
						$save['owner_telA'] = $data['owner_telA'];
						$save['owner_telN'] = $data['owner_telN'];
						$save['owner_faxC'] = $data['owner_faxC'];
						$save['owner_faxA'] = $data['owner_faxA'];
						$save['owner_faxN'] = $data['owner_faxN'];
						$save['org_type'] = $data['orgprooftype'];
						$res = $model->where(['id' => ['eq',$template_id]])->save($save);
						$return["msg"] = "同步成功！";
						$return["status"] = true;
						return $return;
					}
				}else{
					$return["msg"] = business_code($xstr['code']);
					$return["status"] = false;
					return $return;
				}
			}
		}else{
			$return["msg"] = "模板不存在！";
			$return["status"] = false;
			return $return;
		}
	}


}