<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\KdModel;
use Frontend\Model\KdDomainModel;
use Common\Model\CertifyLogModel;

class CloudsafeController extends FrontendController{
    public function _initialize(){
        parent::_initialize();
    }

    /**
    * 快云抗D
    * @date: 2019年03月28日 下午2:48:39
    * @author: gcf
    */
    public function kdshow(){
        $article = new \Frontend\Model\HelpModel();
        $cpbz = $article->home_news("快云服务器");
        $czsc = $article->home_news("服务器");
        $bazn = $article->home_news("备案");
        $this->assign(['cpbz'=>$cpbz,'czsc'=>$czsc,'bazn'=>$bazn,]);
        $this->display();
    }

    /**
    * 快云抗D购买页面
    * @date: 2019年03月28日 下午4:50:55
    * @author: gcf
    */
    public function  kdbuy(){
		$kd = new KdModel();
		$info = $kd->get_kd_price_list();
		$this->assign(['price_info'=>$info]);
		$this->assign('product_id',319);
        $this->display();
    }

    /**
     * 快云抗D购买
     * @date:2019-04-01
     * @author:gcf
     */
	public function kd_buy(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
		$data=request();
		$kd = new KdModel();
		$res = $kd->kd_buy($data);//var_dump($res);exit;
		if($res["status"]){
            $url = U('order/orderlist',['state'=>'6']);
            $msg = '购买成功，您可以在[会员中心-我的订单]查看订单信息!';
            $this->success($msg,$url,3);
		}else{
            $this->error($res['msg']);
		}
	}
    /**
     * 抗D订单开通页
     */
    public function open(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $orderId=$data['order_id'];

        $order=M("order")->where(['id'=>$orderId])->find();
        $this->assign('orderinfo',$order);
        $this->display();
    }
    /**
     * 抗D订单开通，绑定域名
     */
    public function addDomainOpen(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $cloudsafe=new KdModel();
        $res=$cloudsafe->addDomainOpen($data);
        if($res['status']){
            $this->success("域名添加成功，订单开通成功！",U('cloudsafe/lists'),true);
        }else{
            $this->error($res['msg'],true);
        }
    }
    /**
     * 快云抗D 业务列表
     * @date:2019-04-02
     * @author:gcf
     */
    public function lists(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
		$data = request(true);
        $page = $data["page"] + 0;
		$keyword = $data["select"] ? $data["select"] : "";
        $cloudkd = new KdModel();
        $where = $cloudkd->conver_par();//搜索条件
		$order = $data["order"] == "ASC" ? "ASC" : "DESC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
        $res_info = $cloudkd->get_kd_business_list($where,$pagnum,$order,GD::PTYPE_CLOUD_KD);
        if($page > 0 && isMobile() == 'phone'){
            if(empty($res_info['list'])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($res_info['list']);
                die();
            }
        }

        $this->assign([
            "count"=>$res_info['count'],  //数据总条数
            "page"=>$res_info["page_show"], //分页
            "info" =>$res_info['list'], //数据列
            "keyword" => $keyword,
            "pagnum"=>$pagnum,
            "state" => array(1 => "已开通",2 => "已删除",3 => "已过期",4 => "购买未激活",5=>'激活异常')
        ]);
        $this->display();
    }

    /**
     * 抗D域名管理页
     */
    public function guanli(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！');
        }

        $this->assign('info',$kd_bs);
        $this->display();
    }
    /**
     * 域名完成向导,域名激活展示页
     */
    public function xiangdao(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！');
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！');
        }


        $this->assign('info',$kd_bs);
        $this->display();
    }
    /**
     * 域名激活
     */
    public function cnameActivate(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $did=$date['did'];
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！',true);
        }
        if($did!=$kd_bs['api_bid']){
            $this->error('订单号不属于当前业务！请合理操作！',true);
        }

        $res=$kd->activeDomain($kd_bs);
        if($res['status']){
            $this->success('激活成功！',U('cloudsafe/guanli',['yid'=>$yid]),true);
        }else{
            $this->error($res['msg'],true);
        }

    }
    /**
     * 套餐激活
     */
    public function taocanActivate(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $did=$date['did'];
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！');
        }
        if($did!=$kd_bs['api_bid']){
            $this->error('订单号不属于当前业务！请合理操作！');
        }

        $res=$kd->activeTaocan($kd_bs);
        if($res['status']){
            $this->success('激活成功！',U('cloudsafe/guanli',['yid'=>$yid]));
        }else{
            $this->error($res['msg']);
        }

    }

    /**
     * 子域名列表页
     */
    public function son_domain(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！');
        }
        $this->assign('kdinfo',$kd_bs);
        /**********************************/
        $page = request()["page"] + 0;

        $keyword = request()['select'] ? request()["select"] : "";
        $kdDomain = new KdDomainModel();
        $where = $kdDomain->conver_par();//搜索条件
        $order = I("get.order");
        $pagnum=request()['pagnum'] ? request()["pagnum"] : "10";//每页显示条数
        $res_info = $kdDomain->get_kd_domain_list($where,$pagnum,$order);

        if($page > 0 && isMobile() == 'phone'){
            if(empty($res_info['list'])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($res_info['list']);
                die();
            }
        }
        $this->assign([
            "count"=>$res_info['count'],  //数据总条数
            "page"=>$res_info["page_show"], //分页
            "info" =>$res_info['list'], //数据列
            "keyword" => $keyword,
            "pagnum"=>$pagnum,
            "state" => array(1 => "已开通",2 => "已删除",3 => "已过期",4 => "购买未激活",5=>'激活异常')
        ]);

        $this->display();
    }

    /**
     * 添加子域名
     */

    public function add_domain(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();//var_dump($date);exit;
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！',true);
        }
        if(empty($date['tldomain'])){
            $return['status']=false;
            $return['msg']="请填写主机名！";
            return $return;
        }
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->add_domain($date,$kd_bs);
        if($res['status']){
            $this->success('子域名添加成功',U('cloudsafe/son_domain',['yid'=>$yid,'domain'=>$domain]),true);
        }else{
            $this->error($res['msg'],true);
        }

    }


    /**
     * 删除子域名
     */
    public function deleteSubdomain(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $yid=$data['yid'];
        $api_id=$data['api_id'];
        $id=$data['id'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }

        $kdDomain = new KdDomainModel();
        $res=$kdDomain->del_domain($id,$kd_bs,$api_id);
        if($res['status']){
            $this->success('子域名删除成功',U('cloudsafe/son_domain',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }
    }

	/**
	 * 修改子域名-获取div数据
	 * @date: 2019年4月30日14:46:47
	 * @author: GuoPeng
	 */
	public function toUpdateSubdomainDIV(){
		$data = request(true);
		if(!session('?user_id')){
			session("backward",U('cloudsafe/guanli',['yid'=>$data['yid']]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kd = new KdDomainModel();
		$res = $kd->toUpdateSubdomainDIV();
		if($res['status']){
			$this->success('成功！',"",$res['info']);
		}else{
			$this->error($res['msg'],"",true);
		}
	}

	/**
	 * 修改子域名
	 * @date: 2019年4月30日14:46:47
	 * @author: GuoPeng
	 */
	public function edit_domain(){
		$data = request(true);
		if(!session('?user_id')){
			session("backward",U('cloudsafe/guanli',['yid'=>$data['yid']]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->edit_domain();
		if($res['status']){
			$this->success('子域名修改成功！',"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

    /**
     * 子域名接入检测
     */
    public function checkSubdomain(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $yid=$data['yid'];
        $id=$data['id'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }

        $kdDomain = new KdDomainModel();
        $res=$kdDomain->check_domain($id,$kd_bs);
        if($res['status']){
            $this->success('子域名检测成功！',U('cloudsafe/son_domain',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }
    }

    /**
     * 子域名控制面板
     * @date: 2019年5月5日13:49:51
     * @author: GuoPeng
     */
    public function subdomain_panel(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/subdomain_panel",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kd = new KdModel();
		$kd_bs = $kd->where(['id' => $yid])->find();
		if(!$kd_bs){
			$this->error('该业务不存在！');
		}
		if($kd_bs['user_id'] != session('user_id')){
			$this->error('当前业务不属于该会员！');
		}
		$kdDomain = new KdDomainModel();
		$son_domain = $kdDomain->where(['bid' => $yid,"id" => $id])->find();
		if(!$son_domain){
			$this->error('该子域名不存在！');
		}
		$domain = $kd_bs['domain'];
		$this->assign('domain',$domain);
		$this->assign('info',$son_domain);
		$this->display();
	}

    /**
     * 子域名控制面板-CC防火墙设置
     * @date: 2019年5月29日15:09:52
     * @author: GuoPeng
     */
    public function to_cc(){
		$data = request(true);
		$yid = $data["yid"] + 0;
		$id = $data["id"] + 0;
		if(!session("?user_id")){
			session("backward",U("cloudsafe/subdomain_panel",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->to_cc();
		if($res["status"]){
			$this->success("CC防火墙设置成功！","",true);
		}else{
			$this->error($res["msg"],true);
		}
	}

    /**
     * 子域名控制面板-404页面优化功能
     * @date: 2019年5月6日10:49:04
     * @author: GuoPeng
     */
    public function jsl_404(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/subdomain_panel",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->jsl_404();
		if($res['status']){
			$this->success('子域名修改成功！',"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-永久在线页面
	 * @date: 2019年5月5日13:49:51
	 * @author: GuoPeng
	 */
	public function to_online(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_online",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kd = new KdModel();
		$kd_bs = $kd->where(['id' => $yid])->find();
		if(!$kd_bs){
			$this->error('该业务不存在！');
		}
		if($kd_bs['user_id'] != session('user_id')){
			$this->error('当前业务不属于该会员！');
		}
		$kdDomain = new KdDomainModel();
		$son_domain = $kdDomain->where(['bid' => $yid,"id" => $id])->find();
		if(!$son_domain){
			$this->error('该子域名不存在！');
		}
		$domain = $kd_bs['domain'];
		$this->assign('domain',$domain);
		$online = json_decode($son_domain["online"],true);
		$this->assign('online',$online);
		$this->assign('info',$son_domain);
		$this->display();
	}

	/**
	 * 子域名控制面板-永久在线设置功能
	 * @date: 2019年5月6日18:21:17
	 * @author: GuoPeng
	 */
	public function online(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_online",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->online();
		if($res['status']){
			$this->success('永久在线设置成功！',"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-永久在线信息获取
	 * @date: 2019年5月6日18:21:17
	 * @author: GuoPeng
	 */
	public function sync_online(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_online",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->sync_online();
		if($res['status']){
			$this->success('成功！',"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-智能限速页面
	 * @date: 2019年5月5日13:49:51
	 * @author: GuoPeng
	 */
	public function to_speed(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_speed",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kd = new KdModel();
		$kd_bs = $kd->where(['id' => $yid])->find();
		if(!$kd_bs){
			$this->error('该业务不存在！');
		}
		if($kd_bs['user_id'] != session('user_id')){
			$this->error('当前业务不属于该会员！');
		}
		$kdDomain = new KdDomainModel();
		$son_domain = $kdDomain->where(['bid' => $yid,"id" => $id])->find();
		if(!$son_domain){
			$this->error('该子域名不存在！');
		}
		$domain = $kd_bs['domain'];
		$this->assign('domain',$domain);
		$speed = json_decode($son_domain["speed"],true);
		$this->assign('speed',$speed);
		$this->assign('info',$son_domain);
		$this->display();
	}

	/**
	 * 子域名控制面板-智能限速设置功能
	 * @date: 2019年5月6日18:21:17
	 * @author: GuoPeng
	 */
	public function speed(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_speed",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->speed();
		if($res['status']){
			$this->success($res['msg'],"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-智能限速信息获取
	 * @date: 2019年5月6日18:21:17
	 * @author: GuoPeng
	 */
	public function sync_speed(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_speed",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->sync_speed();
		if($res['status']){
			$this->success($res['msg'],"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-黑白名单设置页面
	 * @date: 2019年5月10日09:32:48
	 * @author: GuoPeng
	 */
	public function to_white(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_white",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kd = new KdModel();
		$kd_bs = $kd->where(['id' => $yid])->find();
		if(!$kd_bs){
			$this->error('该业务不存在！');
		}
		if($kd_bs['user_id'] != session('user_id')){
			$this->error('当前业务不属于该会员！');
		}
		$kdDomain = new KdDomainModel();
		$son_domain = $kdDomain->where(['bid' => $yid,"id" => $id])->find();
		if(!$son_domain){
			$this->error('该子域名不存在！');
		}
		$domain = $kd_bs['domain'];
		$this->assign('domain',$domain);
		$white = json_decode($son_domain["white"],true);
		$this->assign('white',$white);
		$this->assign('info',$son_domain);
		$this->display();
	}

	/**
	 * 子域名控制面板-黑白名单设置功能
	 * @date: 2019年5月10日09:32:48
	 * @author: GuoPeng
	 */
	public function white(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_white",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->white();
		if($res['status']){
			$this->success($res['msg'],"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

	/**
	 * 子域名控制面板-黑白名单信息获取
	 * @date: 2019年5月10日09:32:48
	 * @author: GuoPeng
	 */
	public function sync_white(){
		$data = request(true);
		$yid = $data['yid'] + 0;
		$id = $data['id'] + 0;
		if(!session('?user_id')){
			session("backward",U("cloudsafe/to_white",["yid" => $yid,"id"=>$id]));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$kdDomain = new KdDomainModel();
		$res = $kdDomain->sync_white();
		if($res['status']){
			$this->success($res['msg'],"",true);
		}else{
			$this->error($res['msg'],true);
		}
	}

    /**
     * 子域名SSL列表页
     */
    public function domain_ssl(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！');
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！');
        }
        $this->assign('kdinfo',$kd_bs);
        //获取子域名
        $son_domains=M("kangd_domain")->where(['bid'=>$yid])->select();
        $this->assign('son_domains',$son_domains);//var_dump($son_domains);
        /**********************************/
        $res_info = M('kangd_ssl')->where(['bid'=>$yid])->order('create_time desc')->select();

        if(isMobile() == 'phone'){
            if(empty($res_info['list'])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($res_info['list']);
                die();
            }
        }
        $this->assign([
            "info" =>$res_info, //数据列
        ]);

        $this->display();
    }
    /**
     * ssl证书同步
     */
    public function ssl_tongbu(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！');
        }

        $kdDomain = new KdDomainModel();
        $res=$kdDomain->ssl_tongbu($kd_bs);
        if($res['status']){
            $this->success('证书同步成功！',U('cloudsafe/domain_ssl',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }

    }
    /**
     * 子域名  添加SSL证书
     */
    public function add_ssl(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $file=$_FILES['file'];//var_dump($file);exit;
        $sondomainsArr=$date['subdomains']; //子域名，数组
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('根域名不属于当前业务！请合理操作！',true);
        }

        $kdDomain = new KdDomainModel();
        $res=$kdDomain->add_ssl($domain,$sondomainsArr,$file,$kd_bs);
        if($res['status']){
            $this->success('证书添加成功！',U('cloudsafe/domain_ssl',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }

    }

    /**
     * 子域名  修改SSL证书
     */
    public function edit_ssl(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $file=$_FILES['editfile'];//var_dump($file);exit;
        $sondomainsArr=$date['editsubdomains']; //子域名，数组
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $id=$date['id'];//ssl主键id
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        if($domain!=$kd_bs['domain']){
            $this->error('根域名不属于当前业务！请合理操作！',true);
        }

        $kdDomain = new KdDomainModel();
        $res=$kdDomain->edit_ssl($domain,$sondomainsArr,$file,$kd_bs,$id);
        if($res['status']){
            $this->success('证书修改成功！',U('cloudsafe/domain_ssl',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }

    }

    /**
     * 删除ssl证书
     */
    public function del_ssl(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];//业务id
        $bid=$date['bid'];//证书对应业务id
        $id=$date['id'];//ssl证书id
        if($yid!=$bid){
            $this->error("当前操作业务与SSL证书所属业务不匹配！请合理操作！",true);
        }
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！',true);
        }
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->del_ssl($yid,$id,$kd_bs);
        if($res['status']){
            $this->success('证书删除成功！',U('cloudsafe/domain_ssl',['yid'=>$yid,'domain'=>$kd_bs['domain']]),true);
        }else{
            $this->error($res['msg'],true);
        }
    }

    /**
     * 报表
     */
    public function bao_biao(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $date=request();
        $yid=$date['yid'];
        $domain=$date['domain'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        if($kd_bs['user_id']!=session('user_id')){
            $this->error('当前业务不属于该会员！');
        }
        if($domain!=$kd_bs['domain']){
            $this->error('该域名不属于当前业务！请合理操作！');
        }


        $this->assign('kdinfo',$kd_bs);
        $this->display();
    }
    /**
     * 获取今日汇总数据
     */
    public function websiteData(){
        $date=request();
        $domainid=$date['domainid'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->websiteData($kd_bs);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }
    /**
     * 网站访问流量flowClean
     */
    public function visiteTrend(){
        $date=request();
        $domainid=$date['domainid'];
        $dateType=$date['dateType'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->visiteTrend($kd_bs,$dateType);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }
    /**
     * 网站流量清洗
     */
    public function flowClean(){
        $date=request();
        $domainid=$date['domainid'];
        $dateType=$date['dateType'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->flowClean($kd_bs,$dateType);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }

    /**
     * 攻击拦截
     */
    public function attackTrend(){
        $date=request();
        $domainid=$date['domainid'];
        $dateType=$date['dateType'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->attackTrend($kd_bs,$dateType);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }
    /**
     * 实时攻击检测
     */
    public function cc_realTime(){
        $date=request();
        $domainid=$date['domainid'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->cc_realTime($kd_bs);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }

    /**
     * 攻击详情
     */
    public function cc_attackDetails(){
        $date=request();
        $domainid=$date['domainid'];
        $report_type=$date['report_type'];
        $startDate=$date['startDate'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->cc_attackDetails($kd_bs,$report_type,$startDate);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }
    /**
     * cc解封
     */
    public function ccUnlock(){
        $date=request();
        $domainid=$date['domainid'];
        $bis_sign=$date['bis_sign'];
        $domain=$date['domain'];
        $yid=$date['yid'];
        $kd=new KdModel();
        $kd_bs=$kd->where(['id'=>$yid])->find();
        $kdDomain = new KdDomainModel();
        $res=$kdDomain->ccUnlock($kd_bs,$bis_sign,$domain);
        if($res['status']){
            $this->success($res['msg'],'',true);
        }else{
            $this->error($res['msg'],true);
        }
    }




}