<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\CloudserverModel;
use Common\Model\CertifyLogModel;

class CloudserverController extends FrontendController{
    public function _initialize(){
        parent::_initialize();
    }

    /**
    * 快云服务器首页
    * @date: 2016年11月24日 下午2:48:39
    * @author: Lyubo
    */
    public function cloudserverShow(){
        $article = new \Frontend\Model\HelpModel();
        $cpbz = $article->home_news("快云服务器");
        $czsc = $article->home_news("服务器");
        $bazn = $article->home_news("备案");
        $this->assign(['cpbz'=>$cpbz,'czsc'=>$czsc,'bazn'=>$bazn,]);
        $this->display("Cloudserver/cloudserverShow");
    }

    /**
    * 快云服务器购买页面
    * @date: 2016年11月24日 下午4:50:55
    * @author: Lyubo
    */
    public function cloudserverBuy(){
		$cloudserver = new CloudserverModel();
		$info = $cloudserver->get_cloudserver_price_list();
		$discount = 1;
		if(session('?user_id')){
			$discounts = WebSiteConfig(8);
			if($discounts["discount_buy"] == 1){
				$user_id = session('user_id');
				$user = new \Frontend\Model\MemberModel();
				$user_level = $user->get_user_level($user_id,18);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
		}
		$this->assign(['discount'=>$discount]);
		$this->assign(['info'=>json_encode($info)]);
        $this->display("Cloudserver/cloudserverBuy");
    }

    /**
     * 获取用户所有cloudserver业务
     * @date: 2016年10月25日 下午4:42:40
     * @author: Lyubo
     */
    public function cloudserverlist(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
		$data = request(true);
		$page = $data["page"] + 0;
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "DESC" ? $data["order"] : "ASC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
        $cloudserver = new CloudserverModel();
        $where = $cloudserver->conver_par();
        $info = $cloudserver->get_cloudserver_business_list($where,$pagnum,$order,GD::PTYPE_CLOUD_SERVER);
        $Not_open = $cloudserver->get_not_open($info['list']);
		if($page > 0 && isMobile() == 'phone'){
			if(empty($info['list'])){
				echo json_encode("last");die();
			}else{
				echo json_encode($info['list']);die();
			}
		}
		$area_code_list = json_decode(AREA_CODE,true);
        $this->assign([
            "count"=>$info['count'],
            "page"=>$info["page_show"],
            "info" =>$info['list'],
			"pagnum"=>$pagnum,
            "business_info"=>implode(",",$Not_open),
			"keyword" => $keyword,
			"area_code_list" => $area_code_list
        ]);
        $this->display();
    }

	/**
	 * 获取用户所有cloudserver业务
	 * @date: 2016年10月25日 下午4:42:40
	 * @author: Lyubo
	 */
	public function cloudserverrenew(){
		if (! session('?user_id')) {
			redirect(U('Login/login'));die();
		}
		$data = request(true);
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "DESC" ? $data["order"] : "ASC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
		$cloudserver = new CloudserverModel();
		$where = $cloudserver->conver_par();
		$info = $cloudserver->get_cloudserver_renew_list($where,$pagnum,$order,GD::PTYPE_CLOUD_SERVER);
		$area_code_list = json_decode(AREA_CODE,true);
		$this->assign([
			"count"=>$info['count'],
			"page"=>$info["page_show"],
			"info" =>$info['list'],
			"keyword" => $keyword,
			"area_code_list" => $area_code_list
		]);
		$this->display();
	}

	/**
	 * 用户cloudserver实名认证页面
	 * @date: 2018年09月12日
	 * @author: gechangfen
	 */
	public function toAuthentication(){
		if(!session('?user_id')){
			redirect(U('Login/login'));
			die();
		}
		$data = request();
		$cs_id = $data['cs_id'];
		$user_id = session('user_id');
		$cloudserver = new CloudserverModel();
		$binfo = $cloudserver->where(array('id' => $cs_id,'user_id' => $user_id))->find();
		if(!$binfo){
			$this->error('未查询到符合条件的业务');
		}
		$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($cloudserver);
		$result = $cloudserverRespository->CloudserverBusinessSynchronizing($binfo['api_bid']);
		/*同步后，查一下实名状态，并返回状态值*/
		$auth = $cloudserver->where(array('id' => $cs_id))->find();//实名状态查询
		if($auth['authentication'] != 0){ //已实名
			$this->success("该业务已经提交实名认证，请勿重复提交",U('cloudserver/cloudserverlist'),true);
		}
		if(IS_POST){  //实名认证处理
			$data = I("post.");
			$result = $cloudserver->certify($data,$binfo);
			if($result === false){
				$message = $cloudserver->getError();
			}else{
				$message = business_code($result);
			}
			if($result == -1){
				if(IS_AJAX){
					$this->success("快云服务器实名认证信息提交成功，请等待审核！",U('cloudserver/cloudserverlist'),true);
				}else{
					$this->success("快云服务器实名认证信息提交成功，请等待审核！",U('cloudserver/cloudserverlist'));
				}
			}else{
				if(IS_AJAX){
					$this->error($message,U('cloudserver/cloudserverlist'),true);
				}else{
					$this->error($message,U('cloudserver/cloudserverlist'));
				}
			}
		}else{
			$this->assign(['bid' => $binfo['api_bid'],'cs_id' => $binfo['id']]);
			$this->display("Cloudserver/toAuthentication");
		}
	}

	/**
	 * 实名认证记录
	 * 2018-09-18
	 * gcf
	 * */
	public function authList(){
		if(!session('?user_id')){
			redirect(U('Login/login'));
			die();
		}
		$data = request();
		$where['user_id'] = $wheret['user_id'] = session('user_id');
		$where['pb_id'] = $data['id'];//产品业务主键id
		$where['api_bid'] = $data['business_id'];//接口业务id
		$certifylog = new CertifyLogModel;
		$order_by = '';
		if($where['pb_id']){
			$info = $certifylog->get_log_list($where,10,"*",$order_by);
		}else{
			$info = $certifylog->get_log_list($wheret,10,"*",$order_by);
		}
		foreach($info['list'] as $k => &$v){
			$v['idcart'] = substr_replace($v['idcart'],'*******',4,12);
			$v['phone'] = substr_replace($v['phone'],'*****',3,4);
			//	$v['contactname'] = substr_replace($v['contactname'],'*',-2,2);
		}
		/*审核状态如何判定，及审核说明情况 */
		$this->assign(["count" => $info['count'],"page" => $info["page_show"],'info' => $info['list']]);
		$this->display("Cloudserver/authList");
	}

    /**
     * 获取列表数量和待续费业务数量
     * @date: 2017年4月11日 下午4:47:38
     * @author: Lyubo
     * @param: variable
     */
    public function state_count(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $cloudserver = new CloudserverModel();
        $sum = $cloudserver->cloudserver_stateCount(GD::PTYPE_CLOUD_SERVER);
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 修改备注
     * @author: Lyubo
     * @param: remark，business_id
     * @return boolean
     */
    public function remark(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$cloudserver = new CloudserverModel();
		$result = $cloudserver->remark_edit();
		if($result){
			$data = "ok";
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

    /**
    * 快云服务器价格
    * @data: 2016年11月25日 下午2:39:40
    * @author: Lyubo
    * @param: disk:数据盘
    * @param: dqbh:地区编号
    * @param: gmqx:购买期限
    * @param: disktype:数据盘类型
    * @param: serverbh:服务器编号
    * @return price
    */
    public function buyPrice(){
        $cloudserver = new CloudserverModel();
        $data = request();
		$data["type"] = GD::TID_BUY;
        $price = $cloudserver->showPrice($data);
        $date['price'] = $price;
        $this->ajaxReturn($date);
    }

    /**
    * 快云服务器操作系统
    * @date: 2016年11月25日 下午2:48:10
    * @author: Lyubo
    * @return string json $os_type
    */
    public function OsType(){
        $cloudserver = new CloudserverModel();
        $os_type = $cloudserver->OsTypeInfo();
        if ($os_type) {
            echo json_encode($os_type);
            exit();
        } else {
            echo json_encode($os_type);
            exit();
        }
    }

    /**
     * 快云服务器租赁服务协议
     * @date: 2017年5月27日 下午18:00:40
     * @author: Guopeng
     * @return array
     */
    public function cloudserver_agreement(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $this->display();
    }

    /**
    * 快云服务器开通
    * @date: 2016年12月1日 上午9:33:23
    * @author: Lyubo
    */
    public function cloudserver_open(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$cloudserver = new CloudserverModel();
		$order = new \Frontend\Model\OrderModel();
		$data = request();
		$member_id = session("user_id");
		$order_id = $data['order_id'];
		$url = U('order/orderlist',['state'=>'6']);
		if(IS_POST){
			$password = $data['password'];
			if(!preg_match("/^(?=^.{9,20}$)(?=(?:.*?\\d){3})(?=(?:.*?[a-z]){3})(?=(?:.*?[A-Z]){3})[0-9a-zA-Z].*$/",$password)){
				$message = "密码格式不正确,密码必须包含3个大写字母，3个小写字母，3个数字和除@#%&以外的特殊字符，长度最小9位";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if(is_null($order_id) || !is_numeric($order_id) || strpos($order_id,".") != false || $order_id <= 0){
				$message = "订单编号错误";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}elseif(is_null($password) || !reg_user_pass($password) || strpos($password,'@') != false || strpos($password,'#') != false || strpos($password,'%') != false){
				$message = '密码只能包含字母，数字和除@#%&以外的特殊字符，长度最小8位';
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}else{
				// 获取订单信息
				$order_info = $order->order_find($order_id);
				// 开通快云服务器
				$result = $cloudserver->cloudserver_open($order_id,$member_id,$password);
				$message = business_code($result['code']);
				if($result['code'] == -1){
					if(isMobile() == "phone"){
						$message = "快云服务器开通成功，服务器密码为:".$password."，您可以在控制台查看快云服务器业务信息";
						$url = U('order/orderlist');
					}else{
						$message = "快云服务器开通成功，您可以在[会员中心]查看订单信息和快云服务器信息"."服务器密码为:".$password;
						$url = U('cloudserver/cloudserverlist');
					}
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}else{
					if(IS_AJAX){
						$this->error($message,$url,true);
					}else{
						$this->error($message,$url);
					}
				}
			}
		}else{
			//显示快云服务器开通页面
			$order_info = $order->order_find($order_id);
			$url = U('order/orderlist');
			if(empty($order_info)){
				$message="订单不存在！";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if($order_info ['user_id'] != $member_id){
				$message="该订单不属于当前会员！";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if($order_info ['state'] != 6){
					$message = '订单状态错误！';
					if(IS_AJAX){
						$this->error($message,$url,true);
					}else{
						$this->error($message,$url);
					}
			}
			$this->assign('order_info',$order_info);
			$this->display();
		}
	}

	/**
	 * 快云服务器服务码开通
	 * @date: 2018年4月24日16:58:52
	 * @author: Guopeng
	 */
	public function cs_code_open(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$cs = new CloudserverModel();
		$order = new \Frontend\Model\OrderModel();
		$data = request();
		$member_id = session("user_id");
		$order_id = $data['order_id'];
		$url = U('order/orderlist',['state'=>'6']);
		if(IS_POST){
			$code = $data['code'];
			if(empty($code)){
				$message = "测试码不能为空！";
				if(IS_AJAX){
					$this->error($message,"",true);
				}else{
					$this->error($message,"");
				}
			}
			$password = $data['password'];
			if(!preg_match("/^(?=^.{9,20}$)(?=(?:.*?\\d){3})(?=(?:.*?[a-z]){3})(?=(?:.*?[A-Z]){3})[0-9a-zA-Z].*$/",$password)){
				$message = "密码格式不正确,密码必须包含3个大写字母，3个小写字母，3个数字和除@#%&以外的特殊字符，长度最小9位";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if(is_null($order_id) || !is_numeric($order_id) || strpos($order_id,".") != false || $order_id <= 0){
				$message = "订单编号错误";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}elseif(is_null($password) || !reg_user_pass($password) || strpos($password,'@') != false || strpos($password,'#') != false || strpos($password,'%') != false){
				$message = '密码只能包含字母，数字和除@#%&以外的特殊字符，长度最小8位';
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}else{
				// 开通快云服务器
				$result = $cs->cs_code_open($order_id,$member_id,$password,$code);
				$message = business_code($result['code']);
				if($result['code'] == -1){
					if(isMobile() == "phone"){
						$message = "快云服务器成功加入开通队列，服务器密码为:".$password.",暂时不支持手机管理产品，您可以在电脑登录[产品中心-快云服务器]查看业务信息";
						$url = U('order/orderinfo',["order_id" => $order_id]);
					}else{
						$message = "快云服务器成功加入开通队列，您可以在[会员中心]查看订单信息和快云服务器信息"."服务器密码为:".$password;
						$url = U('cloudserver/cloudserverlist');
					}
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}else{
					if(IS_AJAX){
						$this->error($message,$url,true);
					}else{
						$this->error($message,$url);
					}
				}
			}
		}else{
			//显示快云服务器开通页面
			$order_info = $order->order_find($order_id);
			if($order_info['free_trial'] <= 0){
				$message = '非试用订单不能使用测试码开通！';
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if($order_info ['user_id'] != $member_id || $order_info ['state'] != 6){
				if($order_info['state'] == '1'){
					$message = '订单状态失败，请联系客服';
				}elseif($order_info['state'] == '1'){
					$message = '订单已开通,请到业务列表查看业务信息';
				}else{
					$message = '订单不存在，或者订单错误';
				}
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			$this->assign('order_info',$order_info);
			$this->display();
		}
	}

    /**
    * 快云服务器续费
    * @date: 2016年12月4日 下午1:53:14
    * @author: Lyubo
    */
    public function cloudserver_renewals(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $cloudserver = new CloudserverModel();
        $data = request();
        $cloudserver_id = $data['cloudserver_id'];
        $member_id  = session("user_id");
        if(IS_POST){
            $renewalstime = $data['renewalstime'] + 0;
            if(is_null($cloudserver_id) || !is_numeric($cloudserver_id) || strpos($cloudserver_id,".") != false){
                $msg = "业务编号为空或错误";
				if(IS_AJAX) {
					$this->error($msg, U('cloudserver/cloudserverlist'),true);
				}else{
					$this->error($msg, U('cloudserver/cloudserverlist'));
				}
            }else{
                $result = $cloudserver->cloudserver_renewals($cloudserver_id,$member_id,$renewalstime);
                $message = business_code($result);
                if($result == -1){
					if(IS_AJAX) {
						$this->success("快云服务器续费成功", U('cloudserver/cloudserverlist'),true);
					}else{
						$this->success("快云服务器续费成功", U('cloudserver/cloudserverlist'));
					}
                }else{
					if(IS_AJAX) {
						$this->error($message, U('cloudserver/cloudserverlist'),true);
					}else{
						$this->error($message, U('cloudserver/cloudserverlist'));
					}
                }
            }
        }else{
            //显示续费信息
            if(is_null($cloudserver_id) || !is_numeric($cloudserver_id) || strpos($cloudserver_id,".") != false || $cloudserver_id <= 0){
                $msg = "业务编号为空或错误";
				$this->_mc_error($msg);
            }else{
                // 业务信息
                $cloudserver_info = $cloudserver->show_cloudserver_renewals($member_id,$cloudserver_id);
                if($cloudserver_info <= 0){
                    $msg = business_code($cloudserver_info);
					$this->_mc_error($msg);
                }else{
                    $this->assign($cloudserver_info);
                    $this->display();
                }
            }
        }
    }

	/**
	 * 快云服务器转正
	 * @date: 2018年5月4日10:26:41
	 * @author: Guopeng
	 */
	public function cs_onformal(){
		if (! session('?user_id')) {
			redirect(U('Login/login'));die();
		}
		$cs = new CloudserverModel();
		$data = request();
		$cs_id = $data['cs_id'] + 0;
		$mid = session("user_id");
		if(IS_POST){
			$onformal_time = $data['service_time'];
			if(is_null($cs_id) || !is_numeric($cs_id) || strpos($cs_id,".") != false){
				$msg = "业务编号为空或错误";
				$this->error($msg,U('cloudserver/cloudserverlist'));
			}else{
				$result = $cs->cs_onformal($cs_id,$mid,$onformal_time);
				$message = business_code($result);
				if($result == -1){
					$this->success("快云服务器转正成功",U('cloudserver/cloudserverlist'));
				}else{
					$this->error($message,U('cloudserver/cloudserverlist'));
				}
			}
		}else{
			if(empty($cs_id)){
				$msg = "业务编号为空或错误！";
				$this->_mc_error($msg);
			}else{
				// 业务信息
				$cs_info = $cs->show_cs_onformal($mid,$cs_id);
				if($cs_info <= 0){
					$msg = business_code($cs_info);
					$this->_mc_error($msg);
				}else{
					$this->assign($cs_info);
					$this->display();
				}
			}
		}
	}

	/**
	 * 快云服务器升级
	 * @date: 2016年12月4日 下午1:53:14
	 * @author: Lyubo
	 */
	public function cs_uplevel(){
		if (! session('?user_id')) {
			redirect(U('Login/login'));die();
		}
		$cs = new CloudserverModel();
		$data = request();
		$cs_id = $data['cs_id'] + 0;
		$member_id  = session("user_id");
		if(IS_POST){
			if(empty($cs_id)){
				$msg = "业务编号为空或错误";
				$this->error($msg,U('cloudserver/cloudserverlist'));
			}else{
				$result = $cs->cs_uplevel($cs_id,$member_id,$data);
				$message = business_code($result);
				if($result == -1){
					$this->success("快云服务器升级成功！",U('cloudserver/cloudserverlist'));
				}else{
					$this->error($message,U('cloudserver/cloudserverlist'));
				}
			}
		}else{
			//显示升级信息
			if(empty($cs_id)){
				$msg = "业务编号为空或错误";
				$this->_mc_error($msg);
			}else{
				$discount = 1;
				$discounts = WebSiteConfig(8);
				if($discounts["discount_uplevel"] == 1){
					$user = new \Frontend\Model\MemberModel();
					$user_level = $user->get_user_level($member_id,18);
					if($user_level["discount"] > 0){
						$discount = $user_level["discount"];
					}
				}
				$this->assign(['discount'=>$discount]);
				// 业务信息
				$cs_info = $cs->show_cs_uplevel($member_id,$cs_id);
				if($cs_info <= 0){
					$msg = business_code($cs_info);
					$this->_mc_error($msg);
				}else{
					$info = $cs->get_cloudserver_price_list();
					$this->assign(["info"=>json_encode($info[$cs_info["dqbh"]])]);
					$this->assign($cs_info);
					$this->display();
				}
			}
		}
	}

    /****************************服务器操作********************************/
    /**
     * 获取快云服务器开通进度
     * @date: 2016年12月2日 上午11:34:20
     * @author : Lyubo
     * @param : $cloudserver_id,保存在主站的订单编号            
     * @return  boolean
     */
    public function get_progress(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
		$cloudserver = new CloudserverModel();
		$data = request();
		$cloudserver_id = $data['cloudserver_id'];
		if(is_null($cloudserver_id) || !is_numeric($cloudserver_id) || strpos($cloudserver_id,".") != false){
			$message = "业务编号为空或错误";
			$ajaxdata['status'] = 'no';
			$ajaxdata['message'] = $message;
			$this->ajaxReturn($ajaxdata);
		}else{
			$result = $cloudserver->get_business_info($cloudserver_id);
			$message = business_code($result);
			if($result == -1){
				$ajaxdata['status'] = 'y';
				$ajaxdata['message'] = "业务开通成功";
				$this->ajaxReturn($ajaxdata);
			}else{
				$ajaxdata['status'] = 'n';
				$ajaxdata['message'] = $message;
				$this->ajaxReturn($ajaxdata);
			}
		}
	}

    /**
    * 获取IP绑定进度
    * @date: 2016年12月4日 上午11:53:41
    * @author: Lyubo
    * @param: $ip_api_bid
    * @return boolean
    */
    public function IpProgress(){
        if (! session('?user_id')) {
            redirect(U('Login/login'),0,'');die();
        }
        $cloudserver = new CloudserverModel();
        $data = request();
        $result = $cloudserver->ip_progress($data['cloudserver_id'],$data['ip']);
        $message = business_code($result);
        if ($result == -1) {
            $ajaxdata['status'] = 'y';
            $ajaxdata['message'] = "IP绑定成功";
            $this->ajaxReturn($ajaxdata);
        } elseif($result == '5033') {
            $ajaxdata['status'] = 'n';
            $ajaxdata['message'] = $message;
            $this->ajaxReturn($ajaxdata);
        }else{
            $ajaxdata['status'] = 'no';
            $ajaxdata['message'] = $message;
            $this->ajaxReturn($ajaxdata);
        }
    }
    /**
    * 快云服务器解绑IP
    * @date: 2016年12月3日 下午5:45:53
    * @author: Lyubo
    * @param: $cloudserver_id,$ip_id,$ip_adderss,$cloudserver_api_bid,$cloudserver_ip_bid
    * @return boolean
    */
    public function cloudserver_relieve(){
        if (! session('?user_id')) {
            redirect(U('Login/login'),0,'');die();
        }
        $data = request();
        $cloudserver_id = $data['cloudserver_id'];
        $cloudserver = new CloudserverModel();
        if(IS_POST){
            $ip_address = $data["ipdz"];
            $ip_bid = $data["cloudserver_ip_bid"];
            $api_bid = $data["cloudserver_api_bid"];
            $cloudserver_ip_id = $data['cloudserver_ip_id'];
            $result = $cloudserver->cloudserver_relieve($cloudserver_id,$cloudserver_ip_id,$ip_address,$api_bid,$ip_bid);
            $msg = business_code($result);
            if($result == -1){
				if(IS_AJAX) {
					$this->success("解绑IP：" . $ip_address . "成功", U('cloudserver/cloudserverlist'),true);
				}else{
					$this->success("解绑IP：" . $ip_address . "成功", U('cloudserver/cloudserverlist'));
				}
            }else{
				if(IS_AJAX) {
					$this->error($msg, U('cloudserver/cloudserverlist'),true);
				}else{
					$this->error($msg, U('cloudserver/cloudserverlist'));
				}
            }
        }else{
            $cloudserver_info = $cloudserver->show_cloudserver_info($cloudserver_id);
            $this->assign($cloudserver_info);
            $this->display();
        }
    }
    /**
    * 快云服务器绑定IP
    * @date: 2016年12月3日 下午7:52:49
    * @author: Lyubo
    * @param: $cloudserver_id
     */
    public function cloudserver_bound(){
        if (! session('?user_id')) {
            redirect(U('Login/login'),0,'');die();
        }
        $data = request();
        $cloudserver_id = $data['cloudserver_id'];
        $cloudserver = new CloudserverModel();
        $m_ip = new \Frontend\Model\IpModel();
        if(IS_POST){
            if (!filter_var($data['ipdz'], FILTER_VALIDATE_IP)){
				$this->error("IP地址格式错误！");
            }
            $cloudserverip_id  = $data['cloudserver_ip_id'];
            $cloudserver_api_bid = $data["cloudserver_api_bid"];
            $ip_address  = $data['ipdz'];
            $result = $cloudserver->cloudserver_bound($cloudserver_id,$cloudserver_api_bid,$ip_address);
            $message = business_code($result);
            if($result== -1){
				if(IS_AJAX) {
					$this->success("IP：" . $ip_address . "正在绑定，请稍后查看业务信息请在当页面耐心等候1--2分钟", U('cloudserver/cloudserverlist'),true);
				}else{
					$this->success("IP：" . $ip_address . "正在绑定，请稍后查看业务信息请在当页面耐心等候1--2分钟", U('cloudserver/cloudserverlist'));

				}
            }else{
				if(IS_AJAX) {
					$this->error($message, U('cloudserver/cloudserverlist'),true);
				}else{
					$this->error($message, U('cloudserver/cloudserverlist'));
				}
            }
        }else{
			$where["id"] = ["eq",$cloudserver_id];
			if($data['type'] == 'get'){
				$cloudserver_info = $cloudserver->where($where)->find();
			}else{
				$cloudserver_info = $cloudserver->where($where)->find();
			}
			//获取所有的ip处于未绑定状态的ip地址的信息
			$ip_info = $m_ip->get_user_ips(['user_id'=>['eq',session('user_id')],'belong_server' => 0]);
			$this->assign($cloudserver_info);
			$this->assign(['ip_info'=>$ip_info]);
			$this->display();
		}
    }
    /**
     * 同步业务信息
     * @date: 2016年11月29日 下午2:53:15
     * @author: Lyubo
     * @param: $business_id,$ptype
     * @return boolean
     */
    public function memberSync(){
        $data =request();
        $yw_id = $data['business_id']+0;
		$cs_id=$data['cs_id'];
		$cloudserver = new CloudserverModel();
		$url = U('cloudserver/cloudserverlist');
		$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($cloudserver);
		$result = $cloudserverRespository->CloudserverBusinessSynchronizing($yw_id);
        if($result){
			/*同步后，查一下实名状态，并返回状态值*/
			if($cs_id>0) {
				$auth = $cloudserver->where(array('id' => $cs_id))->find();//实名状态查询
				$this->success([$auth['authentication'],"同步业务信息成功",$auth['api_bid']], $url, true);
			}else{
				$this->success("同步业务信息成功", $url, true);
			}
        }else{
            $this->error("同步业务信息失败-".$cloudserverRespository->model()->getError(),$url,true);
        }
    }

	/**
	 * 刷新实名状态信息
	 * @date: 2019年4月16日09:45:04
	 * @author: GuoPeng
	 * @param: $business_id,$ptype
	 */
	public function upload_auth(){
		$data = request(true);
		$id = $data['id'] + 0;
		$cloudserver = new CloudserverModel();
		$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($cloudserver);
		$result = $cloudserverRespository->upload_auth($id);
		if($result){
			$this->success("刷新成功！","",true);
		}else{
			$this->error("刷新失败：".$cloudserverRespository->model()->getError(),"",true);
		}
	}

	/**
	 * 批量同步业务信息
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		$data = request();
		$yids = $data["yids"];
		$cloudserver = new CloudserverModel();
		$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($cloudserver);
		if(!is_array($yids)){
			$this->error("同步业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $cloudserver->cloudserver_info($yid);
			if(!$info){
				$this->error("同步业务信息失败!","",true);
			}
			$yw_id = $info['business_id'];
			$result = $cloudserverRespository->CloudserverBusinessSynchronizing($yw_id);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}

	/**
	 * 批量关联认证业务信息
	 * @date: 2018年10月15日
	 * @author: gcf
	 * @param: $business_id,$ptype
	 */
	public function SyncRen(){
		$data = request();
		$yids = $data["yids"];
		$cloudserver = new CloudserverModel();
		$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($cloudserver);
		if(!is_array($yids)){
			$this->error("关联业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		$allt = $okt = $errt = 0;
		$auth = array();
		$wauth = array();
		foreach($yids as $yid){ //先同步；
			$all++;
			$info = $cloudserver->cloudserver_info($yid);
			if(!$info){
				$this->error("关联业务信息获取失败!","",true);
			}
			$yw_id = $info['api_bid'];
			$result = $cloudserverRespository->CloudserverBusinessSynchronizing($yw_id);
			if($result){
				$ok++;
			}else{
				$err++;
			}
			if($info['authentication'] == 1){  //获取已认证的业务
				array_push($auth,$info['api_bid']);
			}
			if($info['authentication'] != 1){  //获取未认证的业务
				array_push($wauth,$info['api_bid']);
			}
		}
		if(count($wauth)){  //有未认证业务的情况下，再判断有没有选已认证业务
			if(!count($auth)){  //验证是否选有已认证业务
				$this->error("请选择至少一个已认证的业务！","",true);
			}
			foreach($yids as $yid){  //批量关联认证
				$info = $cloudserver->cloudserver_info($yid);
				if(!$info){
					$this->error("关联业务信息获取失败!","",true);
				}
				if($info['authentication'] != 1){ //未认证的才去关联认证
					$allt++;
					$res = $cloudserver->guanLian($auth[0],$info);//关联认证
					if($res == -1){
						$okt++;
					}else{
						$errt++;
					}
				}
			}
			$this->success("共关联<font color='red'>".$allt."</font>个业务，成功<font color='red'>".$okt."</font>个，失败<font color='red'>".$errt."</font>个！","",true);
		}else{
			$this->success("共关联<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
		}
	}

/****************************服务器操作********************************/
}