<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2018/10/28
 * Time: 10:08
 */

namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\CloudstorageModel;
use Frontend\Model\CloudstoragespaceModel;
use Frontend\Model\CloudstoragespacefileModel;
use Frontend\Model\HelpModel;

/**
 * 对象存储
 * @date: 2018年10月31日10:58:09
 * @author: Guopeng
 */
class CloudstorageController extends FrontendController{

	/**
	 * 对象存储产品信息页面
	 * @date: 2018年10月31日10:58:09
	 * @author: Guopeng
	 */
	public function Show(){
		$article = new HelpModel();
		$cpbz = $article->home_news("对象存储");
		$czsc = $article->home_news("存储");
		$bazn = $article->home_news("备案");
		$this->assign(['cpbz' => $cpbz,'czsc' => $czsc,'bazn' => $bazn]);
		$this->display();
	}

	/**
	 * 对象存储购买页面
	 * @date: 2018年10月31日10:58:09
	 * @author: Guopeng
	 */
	public function Buy(){
		$this->display();
	}

	/**
	 * 对象存储购买页面
	 * @date: 2018年10月31日10:58:09
	 * @author: Guopeng
	 */
	public function Buybw(){
		$this->display();
	}

	/**
	 * 获取对象存储价格
	 * @date: 2018年11月1日10:05:52
	 * @author: Guopeng
	 */
	public function getPrice(){
		if(IS_AJAX && IS_POST){
			$storagein = new CloudstorageModel();
			$res = $storagein->getPrice();
			if($res["status"]){
				$this->success($res["info"],"",true);
			}else{
				$this->error($res["msg"],"",true);
			}
		}else{
			$this->_error("防止偷鸡！");
		}
	}

	/**
	 * 对象存储购买
	 * @date: 2018年11月2日18:30:31
	 * @author: Guopeng
	 * @param: variable
	 * @return string json code
	 */
	public function storage_buy(){
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		$result = $storage->buy();
		if($result){
			$url = U('order/orderlist',['state'=>'6']);
			$msg = '购买成功，您可以在[会员中心-我的订单]查看订单信息!';
			$this->success($msg,$url,3);
		}else{
			$msg = $storage->getError();
			$this->error($msg);
		}
	}

	/**
	 * 对象存储开通页面
	 * @date: 2018年11月8日09:39:46
	 * @author: Guopeng
	 */
	public function open(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			// 开通快云存储
			$result = $storage->open(false);
			if($result["status"] === true){
				$msg = "对象存储业务开通成功！";
				if(isset($result["bid"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('cloudstorage/lists'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			//显示快云存储开通页面
			$result = $storage->open(true);
			if($result["status"] === true){
				$order_state = array(0 => "失败",1 => "成功",2 => "待处理",3 => "处理中",4 => "审核中",5 => "已删除",6 => "已付款");
				$order_type = array(0 => "新增",1 => "增值",2 => "续费",3 => "变更方案",4 => "转正");
				$this->assign('order_state',$order_state);
				$this->assign('order_type',$order_type);
				$this->assign('order_info',$result["info"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

	/**
	 * 对象存储转正
	 * @date: 2018年11月14日15:06:25
	 * @author: Guopeng
	 */
	public function onformal(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			// 转正快云存储
			$result = $storage->onformal(false);
			if($result["status"] === true){
				$msg = "对象存储业务转正成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('cloudstorage/lists'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			//显示快云存储转正页面
			$result = $storage->onformal(true);
			if($result["status"] === true){
				$this->assign('info',$result["info"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

	/**
	 * 对象存储续费
	 * @date: 2018年11月12日10:38:04
	 * @author: Guopeng
	 */
	public function renewals(){
		/*if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}*/
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			// 续费快云存储
			$result = $storage->renewals(false);
			if($result["status"] === true){
				$msg = "对象存储业务续费成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('cloudstorage/lists'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			//显示快云存储续费页面
			$result = $storage->renewals(true);
			if($result["status"] === true){
				$order_state = array(1 => "成功",2 => "已删除",3 => "已过期",4 => "失败");
				$this->assign('state',$order_state);
				$this->assign('info',$result["info"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

	/**
	 * 对象存储增值
	 * @date: 2018年11月12日10:38:04
	 * @author: Guopeng
	 */
	public function appreciation(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			$result = $storage->appreciation(false);
			if($result["status"] === true){
				$msg = "对象存储业务增值成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('cloudstorage/lists'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			//显示快云存储增值页面
			$data = request();
			$type = $data["m"];
			$result = $storage->appreciation(true);
			if($result["status"] === true){
				$order_state = array(1 => "正常",2 => "已删除",3 => "已过期",4 => "失败");
				$this->assign('state',$order_state);
				$this->assign('info',$result["info"]);
				if($type == "traffic"){
					$this->display("app_traffic");
				}elseif($type == "bandwidth"){
					$this->display("app_bandwidth");
				}else{
					$this->display("app_quota");
				}
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

	/**
	 * 同步业务信息
	 * @date: 2018年11月12日10:38:04
	 * @author: Guopeng
	 * @return boolean
	 */
	public function sync(){
		$data = request();
		$id = $data['id'] + 0;
		$url = U('Cloudstorage/Cloudstoragelist');
		$storage = new CloudstorageModel();
		$result = $storage->sync($id);
		if($result["status"]){
			$this->success("同步业务信息成功",$url,true);
		}else{
			$this->error("同步业务信息失败-".$result["msg"],$url,true);
		}
	}

	/**
	 * 修改备注
	 * @date: 2018年11月12日10:38:04
	 * @author: Guopeng
	 * @return boolean
	 */
	public function remark(){
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		if(IS_POST && IS_AJAX){
			$storage = new CloudstorageModel();
			$result = $storage->remark_edit();
			if($result){
				$data = "ok";
				$this->ajaxReturn($data,'json');
			}else{
				$data = "fail";
				$this->ajaxReturn($data,'json');
			}
		}else{
			$this->_empty();
		}
	}

	/**
	 * 云存储租赁服务协议
	 * @date: 2018年12月13日15:10:39
	 * @author: Guopeng
	 */
	public function agreement(){
		if(isMobile() != "phone"){
			$this->_empty();
		}
		$this->display();
	}
    /****************************************************************/

	/**
    *快云对象存储列表页
    *2018-10-30
     * gcf
    */
    public function lists(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
		$page = request()["page"] + 0;

        $keyword = request()['select'] ? request()["select"] : "";
        $cloudstorage = new CloudstorageModel();
        $where = $cloudstorage->conver_par();//搜索条件
        $order = I("get.order");
		$pagnum=request()['pagnum'] ? request()["pagnum"] : "10";//每页显示条数
        $res_info = $cloudstorage->get_cloudstorage_business_list($where,$pagnum,$order,GD::PTYPE_CLOUD_STORAGE);

		if($page > 0 && isMobile() == 'phone'){
			if(empty($res_info['list'])){
				echo json_encode("last");
				die();
			}else{
				echo json_encode($res_info['list']);
				die();
			}
		}


		$this->assign([
            "count"=>$res_info['count'],  //数据总条数
            "page"=>$res_info["page_show"], //分页
            "info" =>$res_info['list'], //数据列
            "keyword" => $keyword,
			"pagnum"=>$pagnum,
            "state" => array(1 => "正常",2 => "已删除",3 => "已过期",4 => "失败")
        ]);

    // var_dump($res_info['list']);
        $this->display();
    }
    /**
    快云对象存储空间列表页
     */
    public function bucketlist(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $keyword = request()['select'] ? request()["select"] : "";
        $data=request();
        $yid=$data['yid'];//业务Id
        $cloudstoragespace = new CloudstoragespaceModel();
        $where = $cloudstoragespace->conver_par();//搜索条件
        $where["yid"] = array("eq",$yid);
        $order = I("get.order");
        $res_info = $cloudstoragespace->get_cloudstorage_space_list($where,10,$order);
        $this->assign([
            "count"=>$res_info['count'],  //数据总条数
            "page"=>$res_info["page_show"], //分页
            "info" =>$res_info['list'], //数据列
            "keyword" => $keyword,
            'yid'=>$yid
        ]);
       //  var_dump($res_info);
        $this->display();
    }
    /**检测空间名是否已存在  接口已调通
     * gcf 2018-11-07
    */
    public function checkBucketExist(){

        $data=request();
        $yid=$data['yid'];
        $spaceName=$data['bucketName'];
        if($yid==false){
            echo json_encode(array('status'=>-1,'msg'=>'业务参数错误'));exit;
        }
        if(empty($spaceName)){
            echo json_encode(['status'=>-1,'msg'=>'空间名称不能为空！']);exit;
        }

        $cloudstoragespace = new CloudstoragespaceModel();
       $res= $cloudstoragespace->spaceisexist($yid,$spaceName);

        if($res==-1){ //进行创建空间的操作，
            echo json_encode(['status'=>-1,'msg'=>""]);exit;
        }elseif($res==1){  //空间名称已存在
            echo json_encode(['status'=>-1,'msg'=>"空间名称已存在，请重新命名！"]);exit;
        }else{  //接口调用失败或业务信息错误
            echo json_encode(['status'=>-1,'msg'=>$res]);exit;
        }
    }
    /**
     * 创建空间  接口已调通
     * gcf  2018-11-08
    */
    public function createspace(){
        $data=request();
        $insert['space']=$bucketName=$data['space'];
        $insert['yid']=$yid=$data['yid'];
        $insert['quanxian']=$acl=$data['quanxian'];
        $insert['user_id']=session('user_id');
        $insert['createtime']=time();
        $cloudstoragespace = new CloudstoragespaceModel();
        $res=$cloudstoragespace->createspace($yid,$bucketName,$acl);

        if($res==-1){ //创建空间接口成功
            $ress=$cloudstoragespace->add($insert);
            $this->success("空间创建成功！", U('cloudstorage/bucketlist',['yid'=>$yid]),true);
        }else{
            echo json_encode(['status'=>-2,'info'=>$res]);exit;
        }
    }

    /**
     * 获取key
    */
    public function getkey(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $yid=$data['yid'];
        $cloudstorage = new CloudstorageModel();
        $userkey=$cloudstorage->getuserkey($yid);//根据业务ID，查询用户存储key值
        $this->assign([
            "keys"=>$userkey
        ]);

        $this->display();
    }
    /**
     * 空间文件/夹列表
    */
    public function objects(){
		if(!session('?user_id')){
			redirect(U('Login/login'));
			die();
		}
		$data = request();
		$yid = $data['yid'];//业务id
		$space_id = $data['space_id'];
		$space_name = $data['space'];
		$file_fid = $data['file_fid'] ? $data['file_fid'] : 0;
		$file_name = $data['file_name'];
		$file_fname = $data['file_fname'];
		$cloudstroage = new CloudstorageModel();
		$cloudstoragebs = $cloudstroage->getuserkey($yid);
		if($cloudstoragebs['user_id'] != session('user_id')){
			echo json_encode(['status' => -2,'msg' => "当前业务与会员信息不匹配，请合理操作！"]);
			exit;
		}
		$cloudstoragespace = new CloudstoragespaceModel();
		$spaceinfo = $cloudstoragespace->getspaceinfo($space_id);
		if($spaceinfo['space'] != $space_name){
			$this->error("空间名称与对应空间id不匹配！请合理操作！");
		}
		if($data['upload'] == 1){
			$this->upload($data);
			die;
		}
		$cloudstoragespacefile = new CloudstoragespacefileModel();
		if($file_fid){
			$file_fname = $cloudstoragespacefile->getforendfile($file_fid);
		}
		$where = $cloudstoragespacefile->conver_par();//搜索条件
		$keyword = $data['keyword'];
		if(!empty($keyword)){
			$where["file"] = array("like","%$keyword%");
		}
		$where["yid"] = array("eq",$yid);
		$where["space_id"] = array("eq",$space_id);
		$where["file_fid"] = array("eq",$file_fid);
		$where["space_name"] = array("eq",$space_name);
		$order = I("get.order");
		$res_info = $cloudstoragespacefile->get_cloudstorage_spacefile_list($where,10,$order);
		$this->assign([
			"count" => $res_info['count'],  //数据总条数
			"page" => $res_info["page_show"], //分页
			"info" => $res_info['list'], //数据列
			"quanxian" => $spaceinfo['quanxian'],
			"keyword" => $keyword,"wheres" => ['yid' => $yid,'space_id' => $space_id,'space_name' => $space_name,"file_name" => $file_name,'file_fname' => $file_fname,'file_fid' => $file_fid]
		]);
		$this->display();
	}

    /**
     * 上传文件
     */
    public function upload($data){

        $data=array_merge($_FILES['file'],$data);
        $cloudstoragespacefile=new CloudstoragespacefileModel();
        //判断当前目录下，文件名是否存在，存在则更新数据，不存在则新增
        $file_fid=$data['file_fid']?$data['file_fid']:0;
        $isfile_cunzai=$cloudstoragespacefile->where(['space_name'=>$data['space'],'file_fid'=>$file_fid,'yid'=>$data['yid'],'file'=>$data['name'],'user_id'=>session('user_id')])->find();
        if($isfile_cunzai['id']){  //该空间下，该目录下，此文件名已存在
            $is_zai=$isfile_cunzai['id'];
        }else{
            $is_zai=-1;
        }

        $res=$cloudstoragespacefile->upload($data);//文件上传

        if($res==-1){ //上传成功，数据存入代理数据库
            $insert_spacefile['yid']=$data['yid'];
            $insert_spacefile['user_id']=session('user_id');
            $insert_spacefile['createtime']=time();
            $insert_spacefile['file']=strtolower($data['name']);
            $insert_spacefile['filesize']=$this->trans_byte(strlen(file_get_contents($data['tmp_name'])));
            $insert_spacefile['file_fid']=$data['file_fid'];
            $insert_spacefile['space_name']=$data['space'];
            $insert_spacefile['space_id']=$data['space_id'];
            $insert_spacefile['type']=2;//1文件夹  2文件
          //  var_dump($insert_spacefile);exit;
            if($is_zai==-1){
                $cloudstoragespacefile->add($insert_spacefile);
            }else{
                $cloudstoragespacefile->where(['id'=>$is_zai])->save($insert_spacefile);
            }
			echo json_encode(['status'=>1]);exit;
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }

    }

    /**
     * 获取文件大小
     * gcf
     */
   public function trans_byte($byte){
        $KB = 1024;
        $MB = 1024 * $KB;
        $GB = 1024 * $MB;
        $TB = 1024 * $GB;
        if ($byte < $KB) {
            return $byte . "B";
        } elseif ($byte < $MB) {
            return round($byte / $KB, 2) . "KB";
        } elseif ($byte < $GB) {
            return round($byte / $MB, 2) . "MB";
        } elseif ($byte < $TB) {
            return round($byte / $GB, 2) . "GB";
        } else {
            return round($byte / $TB, 2) . "TB";
        }
    }

    /**
     * 创建文件夹  接口已调通,****做到多级级***
     * gcf 2018-11-12
    */
    public function createFolder(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $yid=$data['yid'];//业务id
        $space_id=$data['space_id'];//空间id
        $space_name=$data['space_name'];//空间名称
        $folder_name=$data['folderName'];//文件夹名称
        $file_fid=$data['file_fid'];//文件夹父id
        $cloudstoragespacefile = new CloudstoragespacefileModel();
        $res=$cloudstoragespacefile->createfloder($yid,$space_name,$folder_name,$file_fid);

        if($res==-1){
            $insert_spacefile['yid']=$yid;
            $insert_spacefile['user_id']=session('user_id');
            $insert_spacefile['createtime']=time();
            $insert_spacefile['file']=$folder_name;
            $insert_spacefile['file_fid']=$file_fid;
            $insert_spacefile['space_name']=$space_name;
            $insert_spacefile['space_id']=$space_id;
            $insert_spacefile['type']=1;//1文件夹  2文件
            $cloudstoragespacefile->add($insert_spacefile);

            echo json_encode(['status'=>-1,'msg'=>"创建文件夹成功"]);exit;
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }
    }

    /**
     * 空间删除
     * gcf 2018-11-09
     */
    public function delspace(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $space_id=$data['space_id'];
        $space_name=$data['space_name'];

        $cloudstoragespace=new CloudstoragespaceModel();
        $cloudstoragespacefile=new CloudstoragespacefileModel();
        $spaceinfo=$cloudstoragespace->getspaceinfo($space_id);
        if($spaceinfo['space']!=$space_name){
            echo json_encode(['status'=>-1,'msg'=>"空间名称与所属空间id不对应，请正确操作删除功能！"]);exit;
        }else{
            $res=$cloudstoragespace->delspace($spaceinfo);
            if($res==-1){
                $cloudstoragespace->where(['id'=>$spaceinfo['id']])->delete();
                $cloudstoragespacefile->where(['space_name'=>$space_name])->delete();
                echo json_encode(['status'=>-1,'msg'=>"空间".$space_name."删除成功"]);exit;
            }else{
                $cloudstoragespace->where(['id'=>$spaceinfo['id']])->delete();
                $cloudstoragespacefile->where(['space_name'=>$space_name])->delete();
                echo json_encode(['status'=>-2,'msg'=>$res]);exit;
            }
        }
    }
    /**
     * 同步空间
     * gcf 2018-11-13
     */
    public function tongspace(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $yid=$data['yid'];
        if(!$yid){
            echo json_encode(['status'=>-2,'msg'=>"业务id错误"]);exit;
        }
        $cloudstorage=new CloudstorageModel();
        $cloudstoragebs=$cloudstorage->getuserkey($yid);
        $cloudstoragespace=new CloudstoragespaceModel();
        $spaceslist=$cloudstoragespace->where(['user_id'=>session('user_id'),'yid'=>$yid])->select();
        $spacesDl=array();
        if(count($spaceslist)){  //本地代理空间数据
            foreach($spaceslist as $kl=>$vl){
                array_push($spacesDl,$vl['space']);
            }
        }
        $res=$cloudstoragespace->getallspaces($cloudstoragebs);
        if($res['code']==-1){  //成功，获取返回的空间数据
            $spacelists=$res['msg']; //空间名字，易逗号隔开，需处理
            $spacelistA=explode(';',$spacelists);//空间数组，

            $insert['yid']=$yid;
            $insert['user_id']=session('user_id');
            $insert['quanxian']=2;
            $insert['createtime']=strtotime($cloudstoragebs['open_time']);
            if(!empty($spacelists)) {  //同步过来的数据为非空
                foreach ($spacelistA as $k => $v) {  //同步数据不在本地数据里的空间，执行创建
                    if (!in_array($v, $spacesDl)) {
                        $insert['space'] = $v;
                        $cloudstoragespace->add($insert);
                    }
                }
                foreach ($spacesDl as $kd => $vd) {  //本地数据不在同步数据里的空间，执行删除
                    if (!in_array($vd, $spacelistA)) {
                        $cloudstoragespace->where(['space' => $vd])->delete();
                    }
                }
            }else{  //同步数据为空，则本地只执行删除
                $res=$cloudstoragespace->where(['user_id'=>session('user_id'),'yid'=>$yid])->delete();
            }
            echo json_encode(['status'=>-1,'msg'=>"同步成功！"]);exit; //返回接口返回信息
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res['msg']]);exit; //返回接口返回信息
        }
    }
    /**
     *同步文件列表
     *gcf  2018-11-26
     */
    public function tongallfiles(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $yid=$data['yid'];
        $space_name=$data['space_name'];
        $file_fid=$data['file_fid'];
        $file_fid=$file_fid?$file_fid:0;
        $file=$data['file_name'];
        if(!$yid){
            echo json_encode(['status'=>-2,'msg'=>"业务id错误"]);exit;
        }
        if(empty($space_name)){
            echo json_encode(['status'=>-2,'msg'=>"空间名称不能为空"]);exit;
        }
        $cloudstorage=new CloudstorageModel();
        $cloudstoragebs=$cloudstorage->getuserkey($yid);
        $cloudstoragespacefile=new CloudstoragespacefileModel();
        if($file_fid){
            $file_fname=$cloudstoragespacefile->getforendfile($file_fid);
            $file_fname=$file_fname;
        }else{
            $file_fname=$file;
        }

      //  $res=$cloudstoragespacefile->tongallfiles($cloudstoragebs['access_key'],$cloudstoragebs['secret_key'],$space_name,$yid); 弃用
        $res=$cloudstoragespacefile->tongfiles($cloudstoragebs['access_key'],$cloudstoragebs['secret_key'],$space_name,$yid,$file_fname);
     //  var_dump($res);

        if($res['code']==-1){
            //本地当前空间、当前目录下，文件名称数据
            $cun_fileA=$cloudstoragespacefile->where(['space_name'=>$space_name,'space_id'=>$data['space_id'],'file_fid'=>$file_fid,'yid'=>$data['yid'],'user_id'=>session('user_id')])->select();
            $ben_files=array();
            if(count($cun_fileA)){
                foreach($cun_fileA as $ak=>$av){
                    array_push($ben_files,$av['file']);
                }
            }
            //获取同步数据：当前空间、当前目录下，文件名称数据
            $tdatas=$res['msg'];//同步过来的数据，待处理。。。
            $tong_files=array();//同步过来的当前目录下，文件名称数据
            $tongA=array(); //var_dump($tdatas);exit;
            if(count($tdatas)) { //有同步数据过来
                foreach ($tdatas as $k => $v) {
                    array_push($tong_files,$v['name']);
                    $tongA[$v['name']]=$v;
                }
                $insert['space_id']=$data['space_id'];
                $insert['space_name']=$space_name;
                $insert['file_fid']=$file_fid;
                $insert['createtime']=time();
                $insert['user_id']=session('user_id');
                $insert['yid']=$yid;
                foreach($tong_files as $tk=>$tv){ //同步数据不在本地数据里，执行创建
                    if(!in_array($tv,$ben_files)){
                        $insert['file']=$tongA[$tv]['name'];
                        $insert['type']=$tongA[$tv]['dir']?1:2;
                        $insert['filesize']=$insert['type']==1?0:$this->trans_byte($tongA[$tv]['size']);
                        $cloudstoragespacefile->add($insert);
                    }
                }
                foreach($ben_files as $bk=>$bv){ //本地数据不在同步数据里，执行删除
                    if(!in_array($bv,$tong_files)){
                        $cloudstoragespacefile->where(['space_name'=>$space_name,'space_id'=>$data['space_id'],'file_fid'=>$file_fid,'yid'=>$data['yid'],'user_id'=>session('user_id'),'file'=>$bv])->delete();
                    }
                }
            }else{ //没有数据同步过来，本地只执行删除
                $cloudstoragespacefile->where(['space_name'=>$space_name,'file_fid'=>$file_fid,'yid'=>$data['yid'],'user_id'=>session('user_id')])->delete();
            }
           //
            echo json_encode(['status'=>-1,'msg'=>"同步成功"]);exit; //返回接口返回信息
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res['msg']]);exit; //返回接口返回信息
        }
    }
    /**
     * 重命名文件夹
     * gcf 2018-11-13
     */
    public function renameflouder(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $yid=$data['yid'];
        $space_name=$data['bucketName'];
        $oldname=$data['Filename'];
        $newname=$data['newfoldername'];
        $type=$data['type'];//1文件夹  2文件
        $file_id=$data['file_id'];//要修改的数据id

        $cloudstoragespacefile=new CloudstoragespacefileModel();
        $cloudstorage=new CloudstorageModel();
        $cloudstoragebs=$cloudstorage->getuserkey($yid);
        if($cloudstoragebs['user_id']!=session('user_id')){
            echo json_encode(['status'=>-2,'msg'=>"当前业务与会员信息不匹配，请合理操作！"]);exit;
        }
        if(empty($space_name)){
            echo json_encode(['status'=>-2,'msg'=>"空间不存在！"]);exit;
        }
        if(empty($newname)){
            echo json_encode(['status'=>-2,'msg'=>"新名称不能为空！"]);exit;
        }

        $cloudstoragespacefile = new CloudstoragespacefileModel();
        $res=$cloudstoragespacefile->renamefloder($data);

        if($res==-1){
            $cloudstoragespacefile->where(['id'=>$file_id])->save(['file'=>$newname]);//代理平台数据修改
            echo json_encode(['status'=>-1,'msg'=>"重命名文件夹成功【".$oldname."】->【".$newname."】"]);exit;
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }
    }

    /**
     * 删除文件夹
     * gcf 2018-11-13
     */
    public function delflouder(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $yid=$data['yid'];
        $space_name=$data['space_name'];
        $space_id=$data['space_id'];
        $file_id=$data['file_id'];
        $file_fid=$data['file_fid'];
        $file=$data['file'];
        $cloudstoragespacefile=new CloudstoragespacefileModel();
        if($file_fid){
            $file_fname=$cloudstoragespacefile->getforendfile($file_fid);
            $file_fname=$file_fname.$file;
        }else{
            $file_fname=$file;
        }

        $res=$cloudstoragespacefile->delflouder($yid,$space_id,$space_name,$file_fname,$file);
        if($res==-1){
            $cloudstoragespacefile->where(['id'=>$file_id])->delete();
            $cloudstoragespacefile->where(['file_fid'=>$file_id])->delete();
            echo json_encode(['status'=>-1,'msg'=>"文件夹【".$file."】删除成功"]);exit;
        }else{
            $cloudstoragespacefile->where(['id'=>$file_id])->delete();
            $cloudstoragespacefile->where(['file_fid'=>$file_id])->delete();
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }
    }
    /**
     * 删除文件
     * gcf 2018-11-21
     */
    public function delfile(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $yid=$data['yid'];
        $space_name=$data['space_name'];
        $space_id=$data['space_id'];
        $file_id=$data['file_id'];
        $file_fid=$data['file_fid'];
        $file=$data['file'];
        $cloudstoragespacefile=new CloudstoragespacefileModel();
        if($file_fid){
            $file_fname=$cloudstoragespacefile->getforendfile($file_fid);
            $file_fname=$file_fname.$file;
        }else{
            $file_fname=$file;
        }

        $res=$cloudstoragespacefile->delfile($yid,$space_id,$space_name,$file_fname,$file);
        if($res==-1){
            $cloudstoragespacefile->where(['id'=>$file_id])->delete();
            $cloudstoragespacefile->where(['file_fid'=>$file_id])->delete();
            echo json_encode(['status'=>-1,'msg'=>"文件【".$file."】删除成功"]);exit;
        }else{
            $cloudstoragespacefile->where(['id'=>$file_id])->delete();
            $cloudstoragespacefile->where(['file_fid'=>$file_id])->delete();
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }
    }
    /**
     * 重命名文件
     * gcf 2018-11-20
     */
    public function renamefile(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

        $data=request();
        $yid=$data['yid'];
        $space_name=$data['bucketName'];
        $oldname=$data['Filename'];
        $newname=$data['newfoldername'];
        $type=$data['type'];//1文件夹  2文件
        $file_id=$data['file_id'];//要修改的数据id


        $cloudstorage=new CloudstorageModel();
        $cloudstoragebs=$cloudstorage->getuserkey($yid);
        if($cloudstoragebs['user_id']!=session('user_id')){
            echo json_encode(['status'=>-2,'msg'=>"当前业务与会员信息不匹配，请合理操作！"]);exit;
        }
        if(empty($space_name)){
            echo json_encode(['status'=>-2,'msg'=>"空间不存在！"]);exit;
        }
        if(empty($newname)){
            echo json_encode(['status'=>-2,'msg'=>"新名称不能为空！"]);exit;
        }

        $cloudstoragespacefile = new CloudstoragespacefileModel();
        $res=$cloudstoragespacefile->renamefile($data);

        if($res==-1){
            $cloudstoragespacefile->where(['id'=>$file_id])->save(['file'=>$newname]);//代理平台数据修改
            echo json_encode(['status'=>-1,'msg'=>"重命名文件成功【".$oldname."】->【".$newname."】"]);exit;
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res]);exit;
        }
    }
    /**
     * 获取文件访问路径
     * gcf 2018-11-22
     */
    public function getfileUrl(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $data=request();
        $cloudstoragespacefile=new CloudstoragespacefileModel();

        $res=$cloudstoragespacefile->getfileUrl($data);
        if($res['status']==-1){
            echo json_encode(['status'=>-1,'msg'=>$res['msg']]);exit;
        }else{
            echo json_encode(['status'=>-2,'msg'=>$res['msg']]);exit;
        }
    }
	//下载
	public function downfile(){
		$fileurl=request()['fileurl'];
		$file = fopen ($fileurl, "r" );
		//输入文件标签
		Header ( "Content-type: application/octet-stream" );
		Header ( "Accept-Ranges: bytes" );
		Header ( "Accept-Length: " . filesize ($fileurl));
		Header ( "Content-Disposition: attachment; filename=" .end(explode("/",$fileurl)));
		//输出文件内容
		//读取文件内容并直接输出到浏览器
		echo fread ( $file, filesize ($fileurl));
		fclose ( $file );
		exit ();
	}

	/**
	 * 概览
	 * gcf
	 */
	public function gailan(){
		if (! session('?user_id')) {
			redirect(U('Login/login'));die();
		}

		$keyword = request()['select'] ? request()["select"] : "";
		$data=request();
		$yid=$data['yid'];//业务Id
		if(!$yid){
			$this->error("业务id错误！");
		}
		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);
		$storage_use=$cloudstorage->get_storage_use($cloudstoragebs['access_key'],$cloudstoragebs['secret_key'],$yid);
		if($storage_use['code']==-1){
			$useArr=explode("/",$storage_use['msg']);
			$stoeage_uses=$useArr[0]."G/".$useArr[1]."G";
		}else{
			$stoeage_uses="--";
		}

		$cloudstoragespace = new CloudstoragespaceModel();
		$where = $cloudstoragespace->conver_par();//搜索条件
		$where["yid"] = array("eq",$yid);
		$order = I("get.order");
		$res_info = $cloudstoragespace->get_cloudstorage_space_list($where,10,$order);
		foreach($res_info['list'] as $k=>&$v){
			$v['rongliang_use']=$cloudstoragespace->get_rl_use($cloudstoragebs['access_key'],$cloudstoragebs['secret_key'],$yid,$v['space'])."KB";

		}
		$this->assign([
			"count"=>$res_info['count'],  //数据总条数
			"page"=>$res_info["page_show"], //分页
			"info" =>$res_info['list'], //数据列
			"keyword" => $keyword,
			"stoeage_uses"=>$stoeage_uses,
			"dk"=>$cloudstoragebs['dk'],
			'model'=>$cloudstoragebs['model'],
			'use_flow'=>$cloudstoragebs['use_flow'], //已使用流量
			'flow'=>$cloudstoragebs['flow'],//全部流量
			'yid'=>$yid
		]);
		$this->display();
	}
    /**
     * 刷新缓存
    */
    public function refresh(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }

		$data = request();
		$cloudstoragespacefile = new CloudstoragespacefileModel();
		if(IS_POST){

			$sapce_name=$data['space_name'];
			$str_urls=$data['arrUrl'];//url地址
			if(empty($sapce_name)){
				echo json_encode(['status'=>-2,'msg'=>"空间名称不能为空！"]);exit;
			}
			if(empty($str_urls)){
				echo json_encode(['status'=>-2,'msg'=>"刷新内容不能为空！"]);exit;
			}
			$res=$cloudstoragespacefile->refreshurls($sapce_name,$str_urls,$data['yid']);
		 	 if($res==-1){
				echo json_encode(['status'=>-1,'msg'=>"刷新成功"]);exit;
			}
		}else {
			$yid = $data['yid'];//业务id
			$space_id = $data['space_id'];
			$space_name = $data['space'];
			$this->assign([
				"wheres" => ['yid' => $yid, 'space_id' => $space_id, 'space_name' => $space_name]
			]);
			$this->display();
		}
    }

	/**
	 * 空间权限设置
	 * @date: 2018年11月23日16:00:08
	 * @author: Guopeng
	 */
	public function setauth(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			$result = $storage->setauth(false);
			if($result["status"] === true){
				$msg = "快云存储空间属性设置成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,"",true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $storage->setauth(true);
			if($result["status"] === true){
				$this->assign('yid',$result["info"]["yid"]);
				$this->assign('sid',$result["info"]["sid"]);
				$this->assign('space',$result["info"]["space"]);
				$this->assign('acl',$result["info"]["acl"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

    /**
     * 域名管理
	 * @date: 2018年11月26日10:53:37
	 * @author: Guopeng
	 */
    public function setdomain(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			$result = $storage->setdomain(false);
			if($result["status"] === true){
				$msg = "添加空间绑定域名成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,"",true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $storage->setdomain(true);
			if($result["status"] === true){
				$this->assign('yid',$result["info"]["yid"]);
				$this->assign('sid',$result["info"]["sid"]);
				$this->assign('space',$result["info"]["space"]);
				$this->assign('info',$result["info"]["space_domain_info"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
    }

	/**
	 * 防盗链管理
	 * @date: 2018年11月27日09:39:44
	 * @author: Guopeng
	 */
	public function setlinkdef(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			$result = $storage->setlinkdef(false);
			if($result["status"] === true){
				$msg = "添加空间绑定域名成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,"",true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $storage->setlinkdef(true);
			if($result["status"] === true){
				$this->assign('yid',$result["info"]["yid"]);
				$this->assign('sid',$result["info"]["sid"]);
				$this->assign('space',$result["info"]["space"]);
				$this->assign('refer',$result["info"]["refer"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}


	/**
	 * 设置镜像存储
	 * @date: 2018年11月27日09:39:44
	 * @author: Guopeng
	 */
    public function setmirror(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$storage = new CloudstorageModel();
		if(IS_POST && IS_AJAX){
			$result = $storage->setmirror(false);
			if($result["status"] === true){
				$msg = "设置镜像存储成功！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,"",true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $storage->setmirror(true);
			if($result["status"] === true){
				$this->assign('yid',$result["info"]["yid"]);
				$this->assign('sid',$result["info"]["sid"]);
				$this->assign('space',$result["info"]["space"]);
				$this->assign('mirror',$result["info"]["mirror"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
    }
    /**
     * 获取列表数量
     * @date: 2018-10-30
     * @author: gcf
     */
    public function state_count(){
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $cloudstorage = new CloudstorageModel();
        $sum = $cloudstorage->cloudserver_stateCount(GD::PTYPE_CLOUD_SERVER);
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }





}