<?php
namespace Frontend\Controller;

use Common\Data\StateData as SD;
use Common\Respository\DomainRespository;
use Common\Respository\DomaintemplateRespository;
use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\DomainModel;
use Frontend\Model\MemberModel;
use Frontend\Model\ProductModel;
use Frontend\Model\TemplateModel;

/**
 * 域名
 * @date: 2016年10月25日 下午3:51:53
 * @author: Lyubo
 */
class DomainController extends FrontendController{
	public function _initialize(){
		parent::_initialize();
	}

	/**
	 * 获取该用户所有域名业务
	 * @date: 2016年10月25日 下午4:38:44
	 * @author: Lyubo
	 */
	public function domainlist(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$keyword = request()['select'] ? request()["select"] : "";
		$dm = new DomainModel();
		$where = $dm->conver_par();
		$order = I("get.order");
		$pagnum=request()['pagnum'] ? request()["pagnum"] : "10";//每页显示条数
		$info = $dm->get_domain_business_list($where,$pagnum,$order,GD::PTYPE_DOMAIN);
		$page = request()["page"] + 0;
		if($page > 0 && isMobile() == 'phone'){
			if(empty($info['list'])){
				echo json_encode("last");
				die();
			}else{
				echo json_encode($info['list']);
				die();
			}
		}
		$this->assign([
			"count" => $info['count'],
			"page" => $info["page_show"],
			"info" => $info['list'],
			"keyword" => $keyword,
			"pagnum"=>$pagnum,
			"realstatus" => array(-1=>"未实名",0=>"已实名",1=>"审核中",2=>"审核拒绝",3=>"实名失败",4=>"实名异常",5=>"等待上报",6=>"资料未提交")
		]);
		$this->display();
	}

	/**
	 * 修改备注
	 * @date: 2016年10月27日 上午11:23:22
	 * @author: Lyubo
	 * @param: remark，business_id
	 * @return boolean
	 */
	public function remark(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$dm = new DomainModel();
		$result = $dm->remark_edit();
		if($result){
			$data = "ok";
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 跳转中国数据控制面板
	 * @date: 2016年10月29日 下午2:50:07
	 * @author: Lyubo
	 * @param: $business_id
	 * @return ajax
	 */
	public function panel(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$dm = new DomainModel();
		$result = $dm->domain_panel();
		if($result["code"] == '0'){
			$data["status"] = "ok";
			$data["url"] = $result['info']["ym"];
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 域名页面
	 * @date: 2016年11月20日 下午3:16:40
	 * @author: Lyubo
	 */
	public function domain(){
		$dm = new DomainModel();
		$product = $dm->domain_product();
		$default_domain = $dm->get_default_domain();
		$this->assign([
			'endomain' => $product['endomain'],
			'cndomain' => $product['cndomain'],
			'domian_list' => array_merge($product['endomain'],$product['cndomain']),
			'default_domain' => $default_domain
		]);
		$this->display();
	}

	/**
	 * 域名查询
	 * @date: 2016年11月20日 下午1:41:42
	 * @author: Lyubo
	 * @param: $domain,$suffix   域名参数，域名后缀
	 * @return array
	 */
	public function domain_query(){
		$data = request(true);
		$dm = new DomainModel();
		$product = $dm->domain_product();
		$domain_type = "endomain";
		$domain_name = $data['domain'];
		$pid = $data['pid'] + 0;
		if($domain_name == ""){
			$domain_name = "";
			$domain_config = WebSiteConfig(SD::SYS_DEFAULT_DOMAIN);
			$default_domain = explode(",",$domain_config["default_domain"]);
		}else{
			if(preg_match('/[\x{4e00}-\x{9fa5}]/u',$domain_name) > 0){
				$domain_type = "cndomain";
			}
			$default_domain[] = $pid;
		}
		$this->assign([
			"domain_type" => $domain_type,
			"domain_name" => $domain_name,
			'endomain' => $product['endomain'],
			'cndomain' => $product['cndomain'],
			"default_domain" => $default_domain,
			"pid" => $pid,
		]);
		$this->display();
	}

	/**
	 * 域名查询ajax
	 * @date: 2018年4月11日 上午11:15:05
	 * @author: Lyubo
	 * @param: state
	 */
	public function check_domain(){
		if(!IS_AJAX || !IS_POST){
			redirect(U('domain/domain_query'),0,'');die();
		}
		$dm = new DomainModel();
		$res = $dm->domain_query();
		if($res["status"]){
			$product_list = $res["info"];
			$is_reg = $product_list["is_reg"];
			$this->assign(["product_list" => $product_list]);
			$html = $this->fetch("search_all");
			$info["is_reg"] = $is_reg;
			$this->success($html,"",$info);
		}else{
			$this->error($res["msg"],"",true);
		}
	}

	/**
	 * 万网（新）域名注册邮箱验证ajax
	 * @date: 2018年12月26日17:53:17
	 * @author: Guopeng
	 */
	public function check_domain_mail(){
		if(!IS_AJAX || !IS_POST){
			redirect(U('domain/domain_query'),0,'');die();
		}
		$dm = new DomainModel();
		$res = $dm->check_domain_mail();
		if($res["status"] === false){
			$this->error($res["msg"],"",true);
		}else{
			$this->success($res["msg"],"",true);
		}
	}

	/**
	 * 域名注册
	 * @date: 2016年11月24日 下午1:41:38
	 * @author: Lyubo
	 * @param: $product_id,$domain,$suffix
	 * @return boolean
	 */
	public function domainRegister(){
		$data = request(true);
		if(!session('?user_id')){
			if(IS_POST && IS_AJAX){
				session('backward',__SELF__);
				$this->error("请先登录！",U('Login/login'),true);
			}else{
				session('backward',__SELF__);
				redirect(U('Login/login'),0,'');
			}
			die();
		}
		$dm = new DomainModel();
		if(IS_POST && IS_AJAX){
			$api_type = $data["api_type"];
			$result = $dm->domain_register();
			if($result["status"] === false){
				$message = $result["msg"];
				if($api_type == 3 || $api_type == 100014){
					if($result["msg"] == 1120){
						$message = "域名注册失败，请查看邮箱邮件，验证邮箱再注册域名！";
					}
				}
				$this->error($message,"",true);
			}else{
				$msg = "域名注册成功，请在在[会员中心]查看订单信息和域名信息！";
				if($api_type == 3 || $api_type == 100014){
					$msg = "域名注册中，请在[会员中心]订单列表获取域名业务信息！";
					$this->success($msg,U('order/orderlist',array("state"=>3)),true);
				}else{
					$this->success($msg,U('domain/domainlist'),true);
				}
			}
		}else{
			$result = $dm->show_domain_register();
			if($result["status"] === false){
				$this->error($result["msg"],U('domain/domain'));
			}
			$this->assign("data",$data);
			$this->assign("registry",array(1=>"中国数据",2=>"西部数码",3=>"万网（新）"));
			$this->assign("result",$result);
			$this->display("Domain/domainRegister");
		}
	}

	/**
	 * 域名续费
	 * @date: 2016年12月3日 上午11:24:55
	 * @author: Lyubo
	 * @param: domain_id
	 */
	public function domain_renewals(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$domain = new DomainModel();
		$product = new ProductModel();
		$data = request();
		$domain_id = $data['domain_id'];
		$member_id = session("user_id");
		if(IS_POST){
			$renewals_time = $data['renewalstime'];
			/*域名续费*/
			$code = $domain->domain_renewals($domain_id,$member_id,$renewals_time);
			$message = business_code($code);
			if($code == -1){
				if(IS_AJAX) {
					$this->success("域名续费成功，你可以在[会员中心]查看域名信息", U('domain/domainlist'),true);
				}else{
					$this->success("域名续费成功，你可以在[会员中心]查看域名信息", U('domain/domainlist'));
				}
			}else{
				if(IS_AJAX) {
					$this->error($message, U('domain/domainlist'),true);
				}else{
					$this->error($message, U('domain/domainlist'));
				}
			}
		}else{
			if(empty ($domain_id) && !is_numeric($domain_id)){
				$msg = "编号不存在，或编号错误";
				$this->error($msg,U('domain/domainlist'));
			}
			$domain_info = $domain->domain_renewals_info($domain_id,$member_id);
			$discount = 1;
			$user = new MemberModel();
			$user_level = $user->get_user_level($member_id,$domain_info["product_type_id"]);
			if($user_level["discount"] > 0){
				$discount = $user_level["discount"];
			}
			$product_price_list = null;
			if(!empty($domain_info)){
				$condition['type'] = ["eq",SD::STATE_RENEWALS];
				$condition['api_type'] = ["eq",$domain_info["api_type"]];
				$product_price_list = $product->get_product_price_buy_time($domain_info ["product_id"],$condition);
				$product_price_list["product_price"] = number_format(ceil($product_price_list["product_price"]*$discount),2,".","");
				$domain_info['product_price_list'] = $product_price_list;
			}
			$this->assign($domain_info);
			$this->display();
		}
	}

	/**
	 * 域名同步
	 * @date: 2017年1月12日 下午5:02:48
	 * @author: Lyubo
	 * @param: variable
	 */
	public function memberSync(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),true);die();
		}
		$data = request();
		$yw_id = $data['business_id'] + 0;
		$url = U('domain/domainlist');
		$dm = new DomainModel();
		$dmRespository = new \Common\Respository\DomainRespository($dm);
		$result = $dmRespository->DomainBusinessSynchronizing($yw_id);
		if($result){
			$this->success("同步业务信息成功",$url,true);
		}else{
			$this->error("同步业务信息失败-".$dmRespository->model()->getError(),$url,true);
		}
	}

	/**
	 * 批量同步域名
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),true);die();
		}
		$member_id = session("user_id")+0;
		$data = request();
		$yids = $data["yids"];
		$dm = new DomainModel();
		$dmRespository = new DomainRespository($dm);
		if(!is_array($yids)){
			$this->error("同步业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $dm->domain_renewals_info($yid,$member_id);
			if(!$info){
				$this->error("同步业务信息失败!","",true);
			}
			$yw_id = $info['api_bid'];
			$result = $dmRespository->DomainBusinessSynchronizing($yw_id);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个域名，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}

	/**
	 * 西数域名解析
	 * @date: 2018年8月28日18:37:52
	 * @author: Guopeng
	 */
	public function domain_analysis(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$data = request();
		$bid = $data["bid"] + 0;
		$dm = new DomainModel();
		if(IS_POST){
			$result = $dm->domain_analysis($data,"post");
			$msg = $dm->getError();
			if($result != -1){
				$this->error($msg,"",true);
			}else{
				$this->success("成功","",true);
			}
		}else{
			$info = $dm->domain_analysis($data,"get");
			$domain_info = $dm->get_api_bid_one($bid);
			if(is_array($info)){
				$this->assign("provider",$domain_info["provider"]);
				$this->assign("domain",$domain_info["domain_name"]);
				$this->assign("bid",$bid);
				$this->assign("info",$info);
				$this->display();
			}else{
				$this->_mc_error($dm->getError());
			}
		}
	}

	/**
	 * 域名实名
	 * @date: 2018年12月11日17:08:15
	 * @author: Guopeng
	 */
	public function toAuth(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$model = new DomainModel();
		if(IS_POST && IS_AJAX){
			$result = $model->toAuthentication(false);
			if($result["status"] === true){
				$msg = "域名实名认证信息提交成功，请等待审核！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('Domain/domainlist'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $model->toAuthentication(true);
			if($result["status"] === true){
				$this->assign('info',$result["info"]);
				$this->display("toAuth");
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}

	/**
	 * 域名实名认证记录
	 * @date: 2018年12月11日17:08:15
	 * @author: Guopeng
	 */
	public function auth_list(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$model = new DomainModel();
		$info = $model->auth_list();
		$this->assign([
			"count" => $info['count'],
			"page" => $info["page_show"],
			'info'=>$info['list'],
			"realstatus" => array(-1=>"未实名",0=>"已实名",1=>"审核中",2=>"审核拒绝",3=>"实名失败",4=>"实名异常",5=>"等待上报",6=>"资料未提交")
		]);
		$this->display();
	}

	/******************** 域名模板 ********************/
	/**
	 * 域名模板列表
	 * @date: 2019年2月20日11:03:10
	 * @author: Guopeng
	 */
	public function template_list(){
		if(!session('?user_id')){
			session("backward",U("Domain/template_list"));
			redirect(U('Login/login'),0,'');die();
		}
		$model = new TemplateModel();
		$info = $model->gat_template_list();
		$this->assign([
			"count" => $info['count'],
			"page" => $info["page_show"],
			'domain_type'=> array(1=>"个人域名",2=>"企业域名"),
			'registry_type'=> array(5=>"中国数据",100012=>"西部数码",100014=>"万网（新）"),
			'state_type'=> array(1=>"创建失败",0=>"创建成功"),
			'auth_type'=> array(0=>"未实名",1=>"审核成功",2=>"审核拒绝",3=>"审核中"),
			'info'=>$info['list']
		]);
		$this->display();
	}

	/**
	 * 域名模板创建
	 * @date: 2019年2月21日11:15:46
	 * @author: Guopeng
	 */
	public function template_add(){
		if(!session('?user_id')){
			session("backward",U("Domain/template_add"));
			if(IS_AJAX){
				$this->error("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		if(IS_POST && IS_AJAX){
			$model = new TemplateModel();
			$res = $model->template_add();
			if($res["status"] === false){
				$this->error($res["msg"],"",true);
			}else{
				$this->success("域名模板创建成功！",U("Domain/template_list"),true);
			}
		}
		$this->display();
	}

	/**
	 * 域名模板删除
	 * @date: 2019年2月27日11:47:19
	 * @author: Guopeng
	 */
	public function template_delete(){
		if(!session('?user_id')){
			session("backward",U("Domain/template_list"));
			$this->error("请先登录！",U('Login/login'),true);
		}
		$model = new TemplateModel();
		$res = $model->template_delete();
		if($res["status"] === false){
			$this->error($res["msg"],"",true);
		}else{
			$this->success("域名模板删除成功！","",true);
		}
	}

	/**
	 * 域名模板备注修改
	 * @date: 2019年2月27日11:47:57
	 * @author: GuoPeng
	 * @param: remark，business_id
	 * @return boolean
	 */
	public function template_remark(){
		if(!session('?user_id')){
			session("backward",U("Domain/template_list"));
			redirect(U('Login/login'),0,'');die();
		}
		$model = new TemplateModel();
		$result = $model->template_remark_edit();
		if($result["status"] === true){
			$data = "ok";
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 域名模板详情页面
	 * @date: 2019年2月27日14:29:36
	 * @author: GuoPeng
	 * @param: remark，business_id
	 * @return boolean
	 */
	public function template_info(){
		if(!session('?user_id')){
			session("backward",U("Domain/template_list"));
			redirect(U('Login/login'),0,'');die();
		}
		$model = new TemplateModel();
		$result = $model->get_template_info();
		$id_type["100014"] = array(1=>"身份证",2=>"护照",3=>"港澳居民来往内地通行证",4=>"台湾居民来往大陆通行证",5=>"外国人永久居留身份证");
		$id_type["100012"] = array(1=>"身份证",2=>"军官证",3=>"其他");
		$id_type["5"] = array(1=>"身份证",2=>"护照",3=>"港澳居民来往内地通行证",4=>"台湾居民来往大陆通行证",5=>"外国人永久居留身份证");
		$org_type["100014"] = array(1=>"营业执照",2=>"组织机构代码证",3=>"统一社会信用代码证书",4=>"民办非企业单位登记证书");
		$org_type["100012"] = array(1=>"营业执照",2=>"组织机构代码证",3=>"其他");
		$org_type["5"] = array(1=>"组织机构代码",2=>"工商营业执照/三证合一",3=>"军队代号",4=>"基金会法人登记证书",5=>"律师事务所执业许可证",6=>"民办非企业单位登记证书");
		if($result["status"] === true){
			$this->assign([
				"tinfo" => $result["msg"],
				'state_type'=> array(1=>"创建失败",0=>"创建成功"),
				'auth_type'=> array(0=>"未实名",1=>"审核成功",2=>"审核拒绝",3=>"审核中"),
				'domain_type'=> array(1=>"个人域名",2=>"企业域名"),
				'registry_type'=> array(5=>"中国数据",100012=>"西部数码",100014=>"万网（新）"),
				'id_type'=> $id_type,
				'org_type'=> $org_type
			]);
			$this->display("template_info");
		}else{
			R("Empty/error_page",array($result["msg"],U("Domain/template_list")));
		}
	}

	/**
	 * 同步域名模板
	 * @date: 2019年2月27日14:29:36
	 * @author: gcf
	 */
	public function templateSyncBatch(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),true);die();
		}
		$data = request();
		$template_id = $data["id"];
		$model = new TemplateModel();
		$dmRespository = new DomaintemplateRespository($model);
		if(!$template_id){
			$this->error("同步域名模板ID错误！","",true);
		}
		$result = $dmRespository->DomainTemplateSynchronizing($template_id);
		if($result['status']){
			$this->success("同步成功！","",true);
		}else{
			$this->success($result['msg'],"",true);
		}
	}

	/**
	 * 域名模板实名
	 * @date: 2019年8月19日17:24:50
	 * @author: GuoPeng
	 */
	public function template_real_name(){
		if(isMobile() == "phone"){
			$this->error("该功能暂未上线,敬请期待！");
		}
		if(!session('?user_id')){
			if(IS_AJAX){
				$this->success("请先登录！",U('Login/login'),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
		}
		$model = new TemplateModel();
		if(IS_POST && IS_AJAX){
			$result = $model->toAuthentication();
			if($result["status"] === true){
				$msg = "模板实名信息提交成功，等待审核！";
				if(isset($result["msg"])){
					$msg = $result["msg"];
				}
				$this->success($msg,U('Domain/template_list'),true);
			}else{
				$message = $result["msg"];
				$this->error($message,"",true);
			}
		}else{
			$result = $model->get_template_real_name_info();
			if($result["status"] === true){
				$this->assign('info',$result["info"]);
				$this->display();
			}else{
				$this->_mc_error($result["msg"]);
			}
		}
	}
	/******************** 域名模板 ********************/
}