<?php
namespace Frontend\Controller;

use Common\Respository\VpsBusinessRespository;
use Frontend\Controller\FrontendController;
use Frontend\Model\FastvpsModel;
use Frontend\Model\OrderModel;
use Common\Model\CertifyLogModel;

/**
* FASTVPS
* @date: 2016年10月25日 下午3:51:53
* @author: Lyubo
*/
class FastvpsController extends FrontendController{
	public function _initialize(){
		parent::_initialize();
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
	}

	/**
	 * 获取用户所有FASTVPS业务
	 * @author: Lyubo
	 */
	public function fastvpslist(){
		$data = request(true);
		$page = $data["page"] + 0;
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "DESC" ? $data["order"] : "ASC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : 10;//每页显示条数
		$fs = new FastvpsModel();
		$where = $fs->conver_par();
		$info = $fs->get_vps_business_list($where,$pagnum,$order);
		if($page > 0 && isMobile() == 'phone'){
			if(empty($info['list'])){
				echo json_encode("last");
				die();
			}else{
				echo json_encode($info['list']);
				die();
			}
		}
		$this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"pagnum"=>$pagnum,"keyword" => $keyword]);
		$this->display();
	}

	/**
	 * 获取用户所有FASTVPS待续费业务
	 * @author: Lyubo
	 */
	public function fastvpsrenew(){
		$data = request(true);
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "DESC" ? $data["order"] : "ASC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
		$fs = new FastvpsModel();
		$where = $fs->conver_par();
		$info = $fs->get_vps_renew_list($where,$pagnum,$order);
		$this->assign(["count"=>$info['count'],"page"=>$info["page_show"],"info"=>$info['list'],"keyword"=>$keyword,"pagnum"=>$pagnum]);
		$this->display();
	}

	/**
	 * 获取列表数量和待续费业务数量
	 * @date: 2017年4月11日 下午4:47:38
	 * @author: Lyubo
	 */
	public function state_count(){
		$fs = new FastvpsModel();
		$sum = $fs->stateCount();
		$date["status"] = 'ok';
		$date["sum"] = $sum;
		return $this->ajaxReturn($date);
	}

	/**
	 * 修改备注
	 * @author: Lyubo
	 */
	public function remark(){
		$fs = new FastvpsModel();
		$result = $fs->remark_edit();
		if($result){
			$data = "ok";
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 用户快云vps实名认证页面
	 * @date: 2018年09月12日
	 * @author: gechangfen
	 */
	public function toAuthentication(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$data = request();
		$fastvps_id = $data['fastvps_id'];
		$user_id = session('user_id');
		$fastvps = new FastvpsModel();
		$binfo = $fastvps->where(array('id' => $fastvps_id,'user_id' => $user_id))->find();
		if(!$binfo){
			$this->error('未查询到符合条件的业务');
		}
		$vpsRespository = new \Common\Respository\VpsBusinessRespository($fastvps);
		if($data['ptype']){
			$result = $vpsRespository->VpsBusinessSynchronizing($binfo['business_id'],$data['ptype']);
		}
		/*同步后，查一下实名状态，并返回状态值*/
		$auth = $fastvps->where(array('id' => $fastvps_id))->find();//实名状态查询
		if($auth['authentication'] != 0){ //已实名
			$this->error("该业务已经提交实名认证，请勿重复提交",U('fastvps/fastvpslist'));
		}
		if(IS_POST){  //实名认证处理
			$data = I("post.");
			$result = $fastvps->certify($data,$binfo);
			if($result === false){
				$message = $fastvps->getError();
			}else{
				$message = business_code($result);
			}
			if($result == -1){
				if(IS_AJAX){
					$this->success("快云VPS实名认证信息提交成功，请等待审核！",U('fastvps/fastvpslist'),true);
				}else{
					$this->success("快云VPS实名认证信息提交成功，请等待审核！",U('fastvps/fastvpslist'));
				}
			}else{
				if(IS_AJAX){
					$this->error($message,U('fastvps/fastvpslist'),true);
				}else{
					$this->error($message,U('fastvps/fastvpslist'));
				}
			}
		}else{
			$this->assign(['bid' => $binfo['business_id'],'fastvps_id' => $binfo['id']]);
			$this->display("Fastvps/toAuthentication");
		}
	}

	/**
	 * 实名认证记录
	 * 2018-09-18
	 * gcf
	 * */
	public function authList(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$data = request();
		$where['user_id'] = $wheret['user_id'] = session('user_id');
		$where['pb_id'] = $data['fastvps_id'];//产品业务主键id
		$where['api_bid'] = $data['business_id'];//接口业务id
		$certifylog = new CertifyLogModel;
		$order_by = '';
		if($where['pb_id']){
			$info = $certifylog->get_log_list($where,10,"*",$order_by);
		}else{
			$info = $certifylog->get_log_list($wheret,10,"*",$order_by);
		}
		foreach($info['list'] as $k => &$v){
			$v['idcart'] = substr_replace($v['idcart'],'*******',4,12);
			$v['phone'] = substr_replace($v['phone'],'*****',3,4);
			//	$v['contactname']=substr_replace($v['contactname'],'*',-2,2);
		}
		/*审核状态如何判定，及审核说明情况 */
		$this->assign(["count" => $info['count'],"page" => $info["page_show"],'info' => $info['list']]);
		$this->display("Fastvps/authList");
	}

	/**
	 * 快云VPS开通
	 * @date: 2016年11月19日 下午3:43:39
	 * @author: Lyubo
	 */
	public function fastvps_open(){
		$order = new OrderModel();
		$fastvps = new FastvpsModel();
		$open_info = request();
		$order_id = $open_info['order_id'];
		$member_id = session('user_id');
		if(is_null($order_id) || $order_id <= 0 || !is_int($order_id)){
			$message = '订单不存在，或者订单错误';
			$url = U('order/orderlist',['state' => '6']);
			if(IS_AJAX){
				$this->error($message,$url,true);
			}else{
				$this->error($message,$url);
			}
		}
		if(IS_POST){
			$result = $fastvps->fastvps_open($order_id,$member_id);
			$message = business_code($result['code']);
			if($result['code'] == -1){
				//发送开通邮件
				business_sendMail('11',$result,$member_id);
				if(isMobile() == "phone"){
					$message = "快云VPS开通成功，您可以在控制台查看快云VPS业务信息";
					$url = U('order/orderlist');
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}else{
					$message = "快云VPS开通成功，您可以在[产品中心-快云VPS]查看业务信息";
					$url = U('fastvps/fastvpslist');
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}
			}elseif($result['code'] === 0){
				if(isMobile() == "phone"){
					$message = "快云VPS开通成功，您可以在控制台查看快云VPS业务信息";
					$url = U('order/orderlist');
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}else{
					$message = "快云VPS开通成功，您可以在[产品中心-快云VPS]查看业务信息";
					$url = U('fastvps/fastvpslist');
					if(IS_AJAX){
						$this->success($message,$url,true);
					}else{
						$this->success($message,$url);
					}
				}
			}else{
				$url = U('order/orderlist');
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message);
				}
			}
		}else{
			//显示开通页面
			$order_info = $order->order_find($order_id);
			$url = U('order/orderlist');
			if(empty($order_info)){
				$message="订单不存在";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if($order_info ['user_id'] != $member_id){
				$message="该订单不属于当前会员！";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			if($order_info ['state'] != 6){
				$message = '订单状态错误！';
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}
			}
			$system_types = $fastvps->GetOsType($order_info["product_id"],$order_info["access"]);
			$system_type = [];
			if($system_types["code"] != 0){
				$system_type = false;
			}else{
				foreach($system_types["info"] as $key => $value){
					$system_type = array_merge($system_type,$value);
				}
			}
			$syetype = "Windows2003";
			if($order_info["system_type"] == 1){
				$syetype = "CentOS 6.7";
			}elseif($order_info["system_type"] == 2){
				$syetype = "Windows2008";
			}
			$this->assign('syetype',$syetype);
			$this->assign('system_type',$system_type);
			$this->assign('order_info',$order_info);
			$this->display();
		}
	}

	/**
	 * vps测试码开通
	 * @date: 2018年4月24日16:58:52
	 * @author: Guopeng
	 */
	public function code_open(){
		$vps = new FastvpsModel();
		$url = U('order/orderlist',['state'=>'6']);
		$order_id = request()['order_id'] + 0;
		if(IS_POST && IS_AJAX){
			$result = $vps->code_open(false);
			if($result["status"] === true){
				if(isMobile() == "phone"){
					$msg = "VPS成功开通，暂时不支持手机管理产品，您可以在电脑登录[会员中心-产品中心-VPS]查看业务信息";
					$url = U('order/orderinfo',["order_id" => $order_id]);
				}else{
					$msg = "VPS开通成功，您可以在[会员中心]查看VPS业务信息！";
					$url = U('vps/vpslist');
				}
				$this->success($msg,$url,true);
			}else{
				$msg = $result['msg'];
				$this->error($msg,$url,true);
			}
		}else{
			$result = $vps->code_open(true);
			if($result["status"] === false){
				$this->_mc_error($result["msg"]);
			}
			$order_info = $result["info"];
			$this->assign('order_info',$order_info);
			$system_types = $vps->GetOsType($order_info["product_id"],$order_info["access"]);
			$system_type = [];
			if($system_types["code"] != 0){
				$system_type = false;
			}else{
				foreach($system_types["info"] as $key => $value){
					$system_type = array_merge($system_type,$value);
				}
			}
			$syetype = "Windows2003";
			if($order_info["system_type"] == 1){
				$syetype = "CentOS 6.7";
			}elseif($order_info["system_type"] == 2){
				$syetype = "Windows2008";
			}
			$this->assign('syetype',$syetype);
			$this->assign('system_type',$system_type);
			$this->display();
		}
	}

	/**
	 * 快云VPS续费业务
	 * @author:Guopeng
	 */
	function fastvps_renewals(){
		$user_id = intval(session("user_id"));
		$vs = new FastvpsModel();
		$url = U('fastvps/fastvpslist');
		$data = request();
		$yw_id = $data["fastvps_id"] + 0;
		if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
			$message = "业务编号为空或错误";
			$this->error($message,$url);
		}
		if(IS_POST){
			$order_time = $data["renewalstime"] + 0;
			$result = $vs->fastvps_renewals($user_id,$yw_id,$order_time);
			$message = business_code($result);
			if($result == -1){
				$message = "快云VPS续费成功，您可以在[会员中心]查看订单信息和快云VPS信息";
				if(IS_AJAX) {
					$this->success($message, $url, true);
				}else{
					$this->success($message, $url);
				}
			}else{
				if(IS_AJAX) {
					$this->error($message, $url, true);
				}else{
					$this->error($message, $url);
				}
			}
		}else{
			// 业务信息
			$result = $vs->fastvps_renewals($user_id,$yw_id,'',"get");
			$message = business_code($result);
			if($result <= 0){
				$this->error($message,$url);
			}
			// 续费业务信息
			$this->assign($result);
			$this->display();
		}
	}

	/**
	 * 快云VPS升级业务
	 * @author:Guopeng
	 */
	function fastvps_uplevel(){
		$user_id = intval(session("user_id"));
		$vs = new FastvpsModel();
		$url = U('fastvps/fastvpslist');
		$data = request();
		$yw_id = $data["fastvps_id"] + 0;
		if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
			$message = "业务编号为空或错误";
			$this->error($message,$url);
		}
		if(IS_POST){
			$up_product_id = $data["up_product_id"] + 0;
			if(is_null($up_product_id) || !is_numeric($up_product_id) || strpos($up_product_id,".") != false || $up_product_id <= 0){
				$message = "产品名称错误";
				if(IS_AJAX){
					$this->error($message,$url,true);
				}else{
					$this->error($message,$url);
				}

			}else{
				$result = $vs->fastvps_upgrade($user_id,$yw_id,$up_product_id);
				$message = business_code($result);
				if($result == -1){
					$message = "快云VPS升级成功，您可以在[会员中心]查看订单信息和快云VPS信息";
					if(IS_AJAX) {
						$this->success($message, $url,true);
					}else{
						$this->success($message, $url);
					}
				}else{
					if(IS_AJAX) {
						$this->error($message, $url,true);
					}else{
						$this->error($message, $url);
					}
				}
			}
		}else{
			// 业务信息
			$result = $vs->fastvps_upgrade($user_id,$yw_id,'',"get");
			$message = business_code($result);
			if($result <= 0){
				$this->error($message,$url);
			}
			// 续费业务信息
			$this->assign($result);
			$this->display();
		}
	}

	/**
	 * 快云VPS增值业务
	 * @author:Guopeng
	 */
	function fastvps_appreciation(){
		$user_id = intval(session("user_id"));
		$vs = new FastvpsModel();
		$url = U('fastvps/fastvpslist');
		$data = request();
		$yw_id = $data["fastvps_id"] + 0;
		if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
			$message = "业务编号为空或错误";
			$this->error($message,$url);
		}
		if(IS_POST){
			$appreciation_name = $data["api_name"]; // 增值类型
			$appreciation_size = $data["app_size"] + 0; // 增值容量
			if(is_null($appreciation_size) || !is_numeric($appreciation_size) || strpos($appreciation_size,".") != false || $appreciation_size <= 0){
				$message = "增值容量错误";
				if(IS_AJAX) {
					$this->error($message, $url,true);
				}else{
					$this->error($message, $url);
				}
			}elseif(is_null($appreciation_name)){
				$message = "增值类型错误";
				if(IS_AJAX) {
					$this->error($message, $url,true);
				}else{
					$this->error($message, $url);
				}
			}else{
				$result = $vs->fastvps_appreciation($user_id,$yw_id,$appreciation_name,$appreciation_size);
				$message = business_code($result);
				if($result == -1){
					$message = "快云VPS增值成功，您可以在[会员中心]查看订单信息和快云VPS信息";
					if(IS_AJAX) {
						$this->success($message, $url,true);
					}else{
						$this->success($message, $url);
					}
				}else{

					if(IS_AJAX) {
						$this->error($message, $url,true);
					}else{
						$this->error($message, $url);
					}
				}
			}
		}else{
			//快云VPS业务信息
			$result = $vs->fastvps_appreciation($user_id,$yw_id,'','',"get");
			$message = business_code($result);
			if($result <= 0){
				$this->error($message,$url);
			}
			$this->assign($result);
			$this->display();
		}
	}

	/**
	 * 快云VPS业务转正
	 * @author:Guopeng
	 */
	function fastvps_onformal(){
		$user_id = intval(session("user_id"));
		$vs = new FastvpsModel();
		$url = U('fastvps/fastvpslist');
		$data = request();
		$yw_id = $data["fastvps_id"] + 0;
		if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
			$message = "业务编号为空或错误";
			$this->error($message,$url);
		}
		if(IS_POST){
			/** 快云VPS转正 */
			$service_time = $data["service_time"] + 0;
			$result = $vs->fastvps_onformal($user_id,$yw_id,$service_time);
			$message = business_code($result);
			if($result == -1){
				$message = "快云VPS转正成功，您可以在[会员中心]查看快云VPS信息";
				if(IS_AJAX){
					$this->success($message,$url,true);
				}else{
					$this->success($message,$url);
				}
			}else{
				if(IS_AJAX) {
					$this->error($message, $url,true);
				}else{
					$this->error($message, $url);
				}
			}
		}else{
			/** 显示快云VPS转正信息 */
			$result = $vs->fastvps_onformal($user_id,$yw_id,'','get');
			if($result <= 0){
				$message = business_code($result);
				$this->error($message,$url);
			}
			$this->assign($result);
			$this->display();
		}
	}

	/**
	 * 同步业务信息
	 * @date: 2016年11月29日 下午2:53:15
	 * @author: Lyubo
	 * @param: $yw_id,$type
	 * @return boolean
	 */
	public function memberSync(){
		$data = request();
		$yw_id = $data['business_id'] + 0;
		$ptype = $data['ptype'];
		$fastvps = new FastvpsModel();
		$url = U('fastvps/fastvpslist');
		$fastvpsRespository = new VpsBusinessRespository($fastvps);
		$result = $fastvpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
		if($result){
			$this->success("同步业务信息成功",$url,true);
		}else{
			$this->error("同步业务信息失败-".$fastvpsRespository->model()->getError(),$url,true);
		}
	}

	/**
	 * 刷新实名状态信息
	 * @date: 2019年4月16日09:45:04
	 * @author: GuoPeng
	 * @param: $business_id,$ptype
	 */
	public function upload_auth(){
		$data = request(true);
		$id = $data['id'] + 0;
		$vps = new FastvpsModel();
		$fastvpsRespository = new VpsBusinessRespository($vps);
		$result = $fastvpsRespository->upload_auth($id);
		if($result){
			$this->success("刷新成功！","",true);
		}else{
			$this->error("刷新失败：".$fastvpsRespository->model()->getError(),"",true);
		}
	}

	/**
	 * 批量同步业务信息
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		$data = request();
		$yids = $data["yids"];
		$fastvps = new FastvpsModel();
		$fastvpsRespository = new VpsBusinessRespository($fastvps);
		if(!is_array($yids)){
			$this->error("同步业务信息失败！","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $fastvps->fastvps_info($yid);
			if(!$info){
				$this->error("同步业务信息失败！","",true);
			}
			$yw_id = $info['business_id'];
			$ptype = $info['api_ptype'];
			$result = $fastvpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}

	/**
	 * 批量关联认证业务信息
	 * @date: 2018年10月19日
	 * @author: gcf
	 * @param: $business_id,$ptype
	 */
	public function SyncRen(){
		$data = request();
		$yids = $data["yids"];
		$fastvps = new FastvpsModel();
		$fastvpsRespository = new VpsBusinessRespository($fastvps);
		if(!is_array($yids)){
			$this->error("关联业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		$allt = $okt = $errt = 0;
		$auth = array();
		$wauth = array();
		//先同步
		foreach($yids as $yid){
			$all++;
			$info = $fastvps->fastvps_info($yid);
			if(!$info){
				$this->error("关联业务信息获取失败！","",true);
			}
			$yw_id = $info['business_id'];
			$ptype = $info['api_ptype'];
			$result = $fastvpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
			if($result){
				$ok++;
			}else{
				$err++;
			}
			//获取已认证的业务
			if($info['authentication'] == 1){
				array_push($auth,$info['business_id']);
			}
			//获取未认证的业务
			if($info['authentication'] != 1){
				array_push($wauth,$info['business_id']);
			}
		}
		//有未认证业务的情况下，再判断有没有选已认证业务
		if(count($wauth)){
			//验证是否选有已认证业务
			if(!count($auth)){
				$this->error("请选择至少一个已认证的业务！","",true);
			}
			foreach($yids as $yid){  //批量关联认证
				$info = $fastvps->fastvps_info($yid);
				if(!$info){
					$this->error("关联业务信息获取失败！","",true);
				}
				if($info['authentication'] != 1){ //未认证的才去关联认证
					$allt++;
					$res = $fastvps->guanLian($auth[0],$info);//关联认证
					if($res == -1){
						$okt++;
					}else{
						$errt++;
					}
				}
			}
			$this->success("共关联<font color='red'>".$allt."</font>个业务，成功<font color='red'>".$okt."</font>个，失败<font color='red'>".$errt."</font>个！","",true);
		}else{
			$this->success("共关联<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
		}
	}

}