<?php
namespace Frontend\Controller;

use Common\Aide\AlipayAide;
use Common\Aide\ShengpayAide;
use Common\Aide\TenpayAide;
use Common\Data\StateData as SD;
use Frontend\Controller\FrontendController;
use Frontend\Model\FinancialModel;
use Frontend\Model\InvoiceModel;
use Frontend\Model\MemberModel;

class FinancialController extends FrontendController{

	/*public function _initialize(){
		parent::_initialize();
		if (! session('?user_id')) {
			redirect(U('Login/login'), 0, '');
			die();
		}
	}*/

	/**
	 * 会员账户金额信息
	 * @date: 2016年11月2日 下午3:57:35
	 * @author: Lyubo
	 */
	public function member_account_info(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
		$financial = new FinancialModel();
		$where = $financial->conver_par();
		$member_account_info = $financial->account_info($where);
		$this->assign(['account_info' => $member_account_info]);
		$this->display();
	}

	/**
	 * 交易记录
	 * @date: 2016年11月2日 下午5:11:07
	 * @author: Lyubo
	 */
	public function member_transactions_list(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
		$page = request()["page"] + 0;
		$financial = new FinancialModel();
		$where = $financial->conver_par();
		$member_tran_list = $financial->tran_list($where,$per_page = 10);
		if($page > 0 && isMobile() == 'phone'){
			if(empty($member_tran_list['list'])){
				echo json_encode("last");
				die();
			}else{
				echo json_encode($member_tran_list['list']);
				die();
			}
		}
		$this->assign([
			"tran_list" => $member_tran_list["list"],
			"count" => $member_tran_list['count'],
			"page" => $member_tran_list["page_show"],
		]);
		$this->display();
	}

	/**
	 * 申请发票
	 * @date: 2019年6月24日11:18:25
	 * @author: GuoPeng
	 */
	public function invoice_page(){
		if(!session("?user_id")){
			if(IS_AJAX){
				$this->error("请先登录",U("Login/login"),true);
			}else{
				redirect(U("Login/login"),0,"");die();
			}
		}
		$custom = WebSiteConfig(9);
		if($custom["invoice_type"] == 0){
			$this->_mc_error("功能未开启！");
		}
		if(IS_AJAX){
			$invoice = new InvoiceModel();
			$result = $invoice->add_invoice();
			if($result["state"]){
				$msg = "提交发票申请成功！";
				$this->success($msg,U("Financial/my_invoice"),true);
			}else{
				$msg = "提交发票申请失败-{$result["msg"]}！";
				$this->error($msg,"",true);
			}
		}else{
			$financial = new FinancialModel();
			$where = $financial->conver_par();
			$member_account_info = $financial->account_info($where);
			$xfze = $member_account_info["purchases"];
			$this->assign(["xfze" => $xfze]);//消费总金额
			$this->display();
		}
	}

	/**
	 * 发票申请记录
	 * @date: 2019年6月24日11:18:25
	 * @author: GuoPeng
	 */
	public function my_invoice(){
		if(!session("?user_id")){
			redirect(U("Login/login"),0,"");die();
		}
		$custom = WebSiteConfig(9);
		if($custom["invoice_type"] == 0){
			$this->_mc_error("功能未开启！");
		}
		$data = request();
		$page = $data["page"] + 0;
		$keyword = $data["select"] ? $data["select"] : "";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
		$invoice = new InvoiceModel();
		$result = $invoice->my_invoice();
		if($page > 0 && isMobile() == "phone"){
			if(empty($result["info"]["list"])){
				echo json_encode("last");die();
			}else{
				echo json_encode($result["info"]["list"]);die();
			}
		}
		if($result["state"]){
			$cost_type_arr = array("其他","域名","虚拟主机","VPS","快云VPS","快云服务器","快云数据库","SSL证书","快云存储","抗D");
			$this->assign(["cost_type_arr" => $cost_type_arr]);
			$this->assign(["info" => $result["info"]["list"]]);
			$this->assign(["pagnum"=>$pagnum,"keyword" => $keyword]);
			$this->display();
		}else{
			$this->error($result["msg"]);
		}
	}

	/**
	 * 取消申请发票
	 * @date: 2019年6月24日11:18:25
	 * @author: GuoPeng
	 */
	public function invoice_cancel(){
		if(!session("?user_id")){
			if(IS_AJAX){
				$this->error("请先登录",U("Login/login"),true);
			}else{
				redirect(U("Login/login"),0,"");die();
			}
		}
		$custom = WebSiteConfig(9);
		if($custom["invoice_type"] == 0){
			$this->_mc_error("功能未开启！");
		}
		if(IS_AJAX){
			$invoice = new InvoiceModel();
			$result = $invoice->invoice_cancel();
			if($result["state"]){
				$msg = "成功取消发票申请！";
				$this->success($msg,U("Financial/my_invoice"),true);
			}else{
				$msg = "取消失败-{$result["msg"]}！";
				$this->error($msg,"",true);
			}
		}
	}

	/************************************************支付宝充值*****************************************/
	/**
	 * 在线充值
	 * @date: 2016年11月3日 上午10:59:01
	 * @author: Lyubo
	 *
	 */
	public function member_recharge(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
		$member = new MemberModel();
		$member_info = $member->get_member_money();
		$this->assign(["member_info" => $member_info]);
		$this->display();
	}

	public function member_recharge_online(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');
			die();
		}
		$financial = new FinancialModel();
		$member = new  MemberModel();
		$data = request();
		$member_id = session("user_id");
		$money = round($data["money"],2);
		$orderNo = create_order_no();
		$member_where['user_id'] = ['eq',$member_id];
		$member_info = $member->get_member_info($member_where);
		$body = $member_info['login_name'].'-'.$orderNo.'-'.$member_info['user_id'].'-'.$money;
		$zfb_parm['recharge_type'] = 2;
		$zfb_parm['orderNo'] = $orderNo;
		$zfb_parm['money'] = $money;
		$type = $data['paymode'];
		if($type == 'alipay'){
			$result = $financial->user_recharge_online($member_id,$money,$orderNo,'ZFB');
		}elseif($type == 'tenpay'){
			$result = $financial->user_recharge_online($member_id,$money,$orderNo,'CFT');
		}elseif($type == 'shengpay'){
			$result = $financial->user_recharge_online($member_id,$money,$orderNo,'SFT');
		}else{
			$result = false;
		}
		if($result === false){
			$this->error("充值失败，请重新充值",U("financial/member_recharge"));
		}else{
			if($type == 'alipay'){
				//支付宝支付
				$alipay = new AlipayAide();
				$alipay->buySomething($orderNo,$money,$body);
			}elseif($type == 'tenpay'){
				//财付通支付
				$tenpay = new TenpayAide();
				$tenpay->tenpay($orderNo,$money,$body);
			}elseif($type == 'shengpay'){
				//盛付通支付
				$shengpay = new ShengpayAide();
				$shengpay->buySheng($orderNo,$money,$body);
			}
		}
	}

	public function wxpay(){
		header("Content-type:text/html;charset=utf-8");
		if(IS_AJAX){
			if(!session('?user_id')){
				$this->error("请先登录！",U('Login/login'),true);
			}
			$financial = new FinancialModel();
			$result = $financial->wxpay();
			if($result == false){
				$msg = $financial->getError();
				$this->error($msg,"",true);
			}else{
				$msg = "微信统一下单成功！";
				$this->success($msg,"",$result);
			}
		}else{
			if(!session('?user_id')){
				redirect(U('Login/login'),0,'');
				die();
			}
			$this->_empty();
		}
	}

	public function notify(){
		header("Content-type:text/html;charset=utf-8");
		$pay_config = WebSiteConfig(7);
		if($pay_config["pay_wx"] == 0){
			$this->_mc_error("本站微信支付功能未开启！");
		}
		//引入WxPayPubHelper
		vendor('WxPayPubHelper.WxPayPubHelper');
		$config['appid'] = $pay_config["wxpay_appid"];
		$config['mchid'] = $pay_config["wxpay_mchid"];
		$config['key'] = $pay_config["wxpay_key"];
		//$config['sslcert_path'] = './cacert/apiclient_cert.pem';
		//$config['sslkey_path'] = './cacert/apiclient_key.pem';
		//使用通用通知接口
		$notify = new \Notify_pub($config);
		//存储微信的回调
		$xml = $GLOBALS['HTTP_RAW_POST_DATA'];
		$notify->saveData($xml);
		$data = $notify->getData();
		//验证签名，并回应微信。
		//对后台通知交互时，如果微信收到商户的应答不是成功或超时，微信认为通知失败，
		//微信会通过一定的策略（如每30分钟共8次）定期重新发起通知，
		//尽可能提高通知的成功率，但微信不保证通知最终能成功。
		if($notify->checkSign() == FALSE){
			$notify->setReturnParameter("return_code","FAIL");//返回状态码
			$notify->setReturnParameter("return_msg","签名验证失败");//返回信息
		}else{
			if($data["return_code"] == "FAIL"){
				$notify->setReturnParameter("return_code","FAIL");//返回状态码
				$notify->setReturnParameter("return_msg","支付失败");//返回信息
			}elseif($data["result_code"] == "FAIL"){
				$notify->setReturnParameter("return_code",$data["err_code"]);//返回状态码
				$notify->setReturnParameter("return_msg",$data['err_code_des']);//返回信息
			}else{
				if(session('?user_id')){
					$user_id = session('user_id');
					$where["user_id"] = $user_id;
				}
				$money = $data['total_fee'] / 100;
				//此处应该更新一下订单状态，商户自行增删操作
				$where["order_id"] = $data['out_trade_no'];
				$where["SFT_OrderNo"] = $data['attach'];
				$member_online_transactions = M("member_online_transactions");
				$member_account = M("member_account");
				$mot_info = $member_online_transactions->where($where)->find();
				if(!empty($mot_info) && $mot_info["state"] == 2){
					$update_where["user_id"] = $mot_info["user_id"];
					$member_result = $member_account->where($update_where)->setInc('balance',$money);
					if($member_result === false){
						$notify->setReturnParameter("return_code","FAIL");//返回状态码
						$notify->setReturnParameter("return_msg","充值成功，信息保存失败");//返回信息
					}else{
						$msg = '用户-'.$mot_info["login_name"].'-使用微信在线充值，金额：'.($data['cash_fee'] / 100).'元，充值成功';
						$info = array(
							'state' => SD::STATE_ONLINE_TRAN_SUCCESS,'account_money' => $money,
							'update_time' => current_date(),"SFT_TransNo" => $data['transaction_id'],
							'note_appended' => $msg
						);
						$result = $member_online_transactions->where($where)->save($info);
						if($result === false){
							$notify->setReturnParameter("return_code","FAIL");//返回状态码
							$notify->setReturnParameter("return_msg","充值成功，信息保存失败");//返回信息
						}else{
							$add = add_transactions($mot_info["user_id"],$money,$msg,0,1,null,null,$msg);
							if($add !== false){
								//成功返回微信参数
								$notify->setReturnParameter("return_code","SUCCESS");//返回状态码
								$notify->setReturnParameter("return_msg","OK");//返回信息
							}else{
								$notify->setReturnParameter("return_code","FAIL");//返回状态码
								$notify->setReturnParameter("return_msg","充值成功，信息保存失败");//返回信息
							}
						}
					}
				}else{
					$notify->setReturnParameter("return_code","FAIL");//返回状态码
					$notify->setReturnParameter("return_msg","充值信息保存失败");//返回信息
				}
			}
		}
		$returnXml = $notify->returnXml();
		echo $returnXml;
	}

	//查询订单
	public function orderQuery(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),["code" => 1]);
		}
		$pay_config = WebSiteConfig(7);
		if($pay_config["pay_wx"] == 0){
			$this->error("本站未设置微信充值功能！","",true);
		}
		//引入WxPayPubHelper
		vendor('WxPayPubHelper.WxPayPubHelper');
		$config['appid'] = $pay_config["wxpay_appid"];
		$config['mchid'] = $pay_config["wxpay_mchid"];
		$config['key'] = $pay_config["wxpay_key"];
		$config['appsecret'] = $pay_config["wxpay_appsecret"];
		$config['sslcert_path'] = './cacert/apiclient_cert.pem';
		$config['sslkey_path'] = './cacert/apiclient_key.pem';
		//商户订单号
		if(!isset($_POST["out_trade_no"])){
			$this->error("订单号不存在！","",true);
		}else{
			$out_trade_no = $_POST["out_trade_no"];
			//使用订单查询接口
			$orderQuery = new \OrderQuery_pub($config);
			//设置必填参数
			$orderQuery->setParameter("out_trade_no","$out_trade_no");//商户订单号
			//非必填参数，商户可根据实际情况选填
			//$orderQuery->setParameter("transaction_id","XXXX");//微信订单号
			//获取订单查询结果
			$orderQueryResult = $orderQuery->getResult();
			//商户根据实际情况设置相应的处理流程,此处仅作举例
			if($orderQueryResult["return_code"] == "FAIL"){
				$this->error($orderQueryResult["return_msg"],"",true);
			}elseif($orderQueryResult["result_code"] == "FAIL"){
				$this->error($orderQueryResult["err_code_des"],"",true);
			}else{
				//判断交易状态
				switch($orderQueryResult["trade_state"]){
					case 'SUCCESS':
						$this->success("支付成功！",U("financial/member_transactions_list"),true);
						break;
					case 'REFUND':
						$this->error("转入退款！","",true);
						break;
					case 'NOTPAY':
						$this->error($orderQueryResult['trade_state_desc']."！","",true);
						break;
					case 'CLOSED':
						$this->error("超时关闭订单！","",true);
						break;
					case 'REVOKED':
						$this->error("已撤销！","",true);
						break;
					case 'USERPAYING':
						$this->error("用户支付中！","",true);
						break;
					case 'PAYERROR':
						$this->error("支付失败".$orderQueryResult["trade_state"],"",true);
						break;
					default:
						$this->error("未知失败".$orderQueryResult["trade_state"],"",true);
						break;
				}
			}
		}
	}
}