<?php
namespace Frontend\Controller;
use Common\Controller\BaseController;
use Frontend\Model\AboutModel;
use Frontend\Model\MenuModel;
use Frontend\Model\ProductModel;

/**
 * 前台的基础控制器
 * @author: duanbin
 * @时间: 2016年9月30日 上午10:34:42
 */
class FrontendController extends BaseController{
	
	/**
	 * 初始化函数
	 * @时间: 2016年9月30日 上午10:35:01
	 * @author: duanbin
	 */
	public function _initialize(){
		parent::_initialize();
		/**
		 * 如果访问的是前台，并且是移动端，那么就返回相应的移动端的页面
		 * @时间: 2016年9月29日 下午5:34:55
		 */
		$system = WebSiteConfig(9);
		if(!empty($system["pc_default_theme"])){
			C("DEFAULT_THEME",$system["pc_default_theme"]);
		}
		header("Content-type: text/html; charset=utf-8");
		$default = "Default";
		$tmpl_parse_string2 = array();
		if(isMobile() == "phone"){
			C("DEFAULT_V_LAYER","Mobile");
			if(!empty($system["mobile_default_theme"])){
				$default = $system["mobile_default_theme"];
			}
			C("DEFAULT_THEME",$default);
			C("TMPL_ACTION_MOBILE_ERROR",THINK_PATH."Tpl/dispatch_mobile_jump.tpl"); // 默认错误跳转对应的模板文件
			if($default !== "Default"){
				//前台手机站静态资源
				$tmpl_parse_string2 = array(
					"__FRONTEND_MOBILE_CSS__"      => PUBLIC_PATH."frontend/mobile/{$default}/css/",
					"__FRONTEND_MOBILE_JS__"       => PUBLIC_PATH."frontend/mobile/{$default}/js/",
					"__FRONTEND_MOBILE_IMAGES__"   => PUBLIC_PATH."frontend/mobile/{$default}/images/",
				);
			}else{
				//前台手机站静态资源
				$tmpl_parse_string2 = array(
					'__FRONTEND_MOBILE_CSS__'      => PUBLIC_PATH.'frontend/mobile/css/',
					'__FRONTEND_MOBILE_JS__'       => PUBLIC_PATH.'frontend/mobile/js/',
					'__FRONTEND_MOBILE_IMAGES__'   => PUBLIC_PATH.'frontend/mobile/images/',
				);
			}
		}elseif($system["pc_default_theme"] !== "Default"){
			$default = $system["pc_default_theme"];
		}
		$tmpl_parse_string = array(
			"__PUBLIC__"			=> __ROOT__.PUBLIC_PATH,
			"__FRONTEND__"			=> PUBLIC_PATH,
			//公共静态资源
			'__COM_CSS__'			=> __ROOT__.PUBLIC_PATH.'common/css/',
			'__COM_JS__'			=> __ROOT__.PUBLIC_PATH.'common/js/',
			'__COM_IMAGES__'		=> __ROOT__.PUBLIC_PATH.'common/images/',
			'__COM_STATICS__'		=> __ROOT__.PUBLIC_PATH.'common/statics/',
			//后台静态资源
			'__BACKEND_CSS__'		=> __ROOT__.PUBLIC_PATH.'backend/css/',
			'__BACKEND_JS__'		=> __ROOT__.PUBLIC_PATH.'backend/js/',
			'__BACKEND_IMAGES__'	=> __ROOT__.PUBLIC_PATH.'backend/images/',
			'__BACKEND_STATICS__'	=> __ROOT__.PUBLIC_PATH.'backend/statics/',
			'__BACKEND_ACEADMIN__'	=> __ROOT__.PUBLIC_PATH.'backend/statics/aceadmin/',
			//前台静态资源
			'__FRONTEND_CSS__'		=> __ROOT__.PUBLIC_PATH.'frontend/css/',
			'__FRONTEND_JS__'		=> __ROOT__.PUBLIC_PATH.'frontend/js/',
			'__FRONTEND_IMAGES__'	=> __ROOT__.PUBLIC_PATH.'frontend/images/',
			'__FRONTEND_STATICS__'	=> __ROOT__.PUBLIC_PATH.'frontend/statics/',
			'__FRONTEND_MEMBER__'	=> __ROOT__.PUBLIC_PATH.'frontend/member/',
			//PC端前台原主题静态资源
			"__FPC__"				=> __ROOT__.PUBLIC_PATH."frontend/",
			"__FPC_CSS__"			=> __ROOT__.PUBLIC_PATH."frontend/css/",
			"__FPC_JS__"			=> __ROOT__.PUBLIC_PATH."frontend/js/",
			"__FPC_IMG__"			=> __ROOT__.PUBLIC_PATH."frontend/images/",
			//PC端会员中心原主题静态资源
			"__FPC_MEM__"			=> __ROOT__.PUBLIC_PATH."frontend/member/",
			"__FPC_MEM_CSS__"		=> __ROOT__.PUBLIC_PATH."frontend/member/css/",
			"__FPC_MEM_JS__"		=> __ROOT__.PUBLIC_PATH."frontend/member/js/",
			"__FPC_MEM_IMG__"		=> __ROOT__.PUBLIC_PATH."frontend/member/images/",
			//PC端前台新主题静态资源
			"__FPC_THEME__"			=> __ROOT__.PUBLIC_PATH."frontend/{$default}/",
			"__FPC_THEME_CSS__"		=> __ROOT__.PUBLIC_PATH."frontend/{$default}/css/",
			"__FPC_THEME_JS__"		=> __ROOT__.PUBLIC_PATH."frontend/{$default}/js/",
			"__FPC_THEME_IMG__"		=> __ROOT__.PUBLIC_PATH."frontend/{$default}/images/",
			//PC端会员中心新主题静态资源
			"__FPC_THEME_MEM__"		=> __ROOT__.PUBLIC_PATH."frontend/{$default}/member/",
			"__FPC_THEME_MEM_CSS__"	=> __ROOT__.PUBLIC_PATH."frontend/{$default}/member/css/",
			"__FPC_THEME_MEM_JS__"	=> __ROOT__.PUBLIC_PATH."frontend/{$default}/member/js/",
			"__FPC_THEME_MEM_IMG__"	=> __ROOT__.PUBLIC_PATH."frontend/{$default}/member/images/",
			//手机端原主题静态资源
			"__FM__"				=> __ROOT__.PUBLIC_PATH."frontend/mobile/",
			"__FM_CSS__"			=> __ROOT__.PUBLIC_PATH."frontend/mobile/css/",
			"__FM_JS__"				=> __ROOT__.PUBLIC_PATH."frontend/mobile/js/",
			"__FM_IMG__"			=> __ROOT__.PUBLIC_PATH."frontend/mobile/images/",
			//手机端新主题静态资源
			"__FM_THEME__"			=> __ROOT__.PUBLIC_PATH."frontend/mobile/{$default}/",
			"__FM_THEME_CSS__"		=> __ROOT__.PUBLIC_PATH."frontend/mobile/{$default}/css/",
			"__FM_THEME_JS__"		=> __ROOT__.PUBLIC_PATH."frontend/mobile/{$default}/js/",
			"__FM_THEME_IMG__"		=> __ROOT__.PUBLIC_PATH."frontend/mobile/{$default}/images/",
			//模板资源
			'__FRONTEND_MOBILE__'	=> PUBLIC_PATH."frontend/mobile/{$default}/",
			"__FRONTEND_PC__"		=> PUBLIC_PATH."frontend/{$default}/",
			"__FRONTEND_PC_CSS__"	=> PUBLIC_PATH."frontend/{$default}/css/",
			"__FRONTEND_PC_JS__"	=> PUBLIC_PATH."frontend/{$default}/js/",
			"__FRONTEND_PC_IMAGES__"=> PUBLIC_PATH."frontend/{$default}/images/",
		);
		$tmpl_parse_string = array_merge($tmpl_parse_string,$tmpl_parse_string2);
		C("TMPL_PARSE_STRING",$tmpl_parse_string);
		//获取控制器名称和数据库比较输出模板关键词
		header("X-Frame-Options: SAMEORIGIN");
		//记录http中Referer参数，登陆之后的跳转链接判断这个地方
		session("backward",$_SERVER["HTTP_REFERER"]);
		$menu = new MenuModel();
		$menu_list = $menu->get_menu_list();
		$this->assign(["menu_list"=>$menu_list]);
		$about = new AboutModel();
		$info = $about->get_friendlylink_list();
		$this->assign("links",$info);
		$ptype_info = M("product_type")->select();
		$ptypes = array();
		foreach($ptype_info as $ptype){
			$ptypes[$ptype["id"]] = $ptype["type_name"];
		}
		/* 设置常量 */
		define("VHOST",$ptypes[3]);//虚拟主机
		define("HOST",$ptypes[7]);//国内主机
		define("HK_HOST",$ptypes[8]);//香港主机
		define("USA_HOST",$ptypes[16]);//美国主机
		define("CLOUD_SPACE",$ptypes[12]);//云空间
		define("CLOUD_VIRTUAL",$ptypes[17]);//云虚拟主机
		define("DOMAIN",$ptypes[4]);//域名
		define("ENDOMAIN",$ptypes[9]);//英文域名
		define("CNDOMAIN",$ptypes[10]);//中文域名
		define("HK_VPS",$ptypes[5]);//香港VPS
		define("DOMESTIC_VPS",$ptypes[6]);//特卖VPS
		define("FAST_CLOUD_VPS",$ptypes[21]);//快云VPS
		define("CLOUD_SERVER",$ptypes[18]);//快云服务器
		define("CLOUD_SERVER_IP",$ptypes[19]);//快云服务器IP
		define("CLOUD_DB",$ptypes[22]);//快云数据库
		define("CLOUD_STORAGE",$ptypes[23]);//快云存储
		define("KYSSL",$ptypes[20]);//快云SSL
		define("CLOUDSAFE",$ptypes[24]);//云安全
		define("KYCDN","快云CDN");//快云CDN
		define("KANGD",$ptypes[25]);//快云抗D
		define("TUOGUAN","服务器托管");//服务器托管
		define("ZUYONG","服务器租用");//服务器租用
		define("AREA_CODEAREA_CODE",json_encode(array(4001=>"郑州",4002=>"香港",4003=>"北京",4005=>"美国",4008=>"国内",40015=>"河南电信",40016=>"河南联通",40018=>"高防机房")));
		define("SYSTEM_TYPE",json_encode(array(0=>"Windows 2003",1=>"CentOS 6.7",2=>"Windows 2008")));
	}
	


}