<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Frontend\Model\ProductModel;

/**
* 展示产品
* @date: 2016年11月4日 下午4:32:32
* @author: Lyubo
*/
class ProductController extends FrontendController{
	
	protected  $model = null;
	
	public function _initialize(){
		parent::_initialize();
		$this->model = new ProductModel();
	}

    /**
    * VPS列表
    * @date: 2016年11月13日 下午3:49:41
    * @author: Lyubo
    */
    public function vps(){
		$product = new ProductModel();
        $data = $product->conver_par();
        $product_info = $product->get_vps_product($data);
		$product_type_list = $product->get_type_list(21);//21是快云VPS的大类
        $banner = $product->banner(3);
        if($product_info === null){
            $this->error("参数错误");
        }
		$ptype_list["hkvps"] = HK_VPS;
		$ptype_list["domesticvps"] = DOMESTIC_VPS;
		if($product_type_list){
			$ptype_list["fastvps"] = $product_type_list[0]["type_name"];
		}
		$sign = $data["type"];
		if(!in_array($sign,array("fastvps","hkvps","domesticvps"))){
			$sign = "fastvps";
		}
        $this->assign([
            "banner" => $banner,
            "sign" => $sign,
            "product_list" => $product_info,
            "ptype_list" => $ptype_list
        ]);
        $this->display();
    }

    /**
     * VPS详情
     * @date: 2016年11月12日 上午9:45:40
     * @author: Lyubo
     * @param: product_id
     */
    public function vpsDetail(){
		$product = new ProductModel();
        $vps_info = $product->vps_info();
        if($vps_info === false){
			$this->assign(["error_info" => "参数错误！"]);
			$this->display("Empty/index");die;
        }
		if(!$vps_info["product_info"]["product_state"]){
			$this->error("该产品已下线！");
		}
		if($vps_info["product_info"]["product_type_id"] == 1){
			if($vps_info["product_info"]["area_code"] == 4002){
				$sign = HK_VPS;
			}else{
				$sign = DOMESTIC_VPS;
			}
		}else{
			$sign = FAST_CLOUD_VPS;
		}
		$area_code = json_decode(AREA_CODE,true);
        $this->assign([
            "product_info" => $vps_info["product_info"],
            "product_config" => $vps_info["product_config"],
            "product_price" => $vps_info["product_price"],
            "system_type"=> $vps_info["system_type"],
            "price_id"=> $vps_info["price_id"],
            "price" => $vps_info["price"],
            "is_product_info" => true,
			"area_code" => $area_code,
			"sign" => $sign
        ]);
        $this->display("Product/vpsDetail");
    }

    /**
    * 获取虚拟主机产品列表
    * @date: 2016年11月4日 下午4:46:00
    * @author: Lyubo
    * @param: $api_type
    */
    public function virtualhost(){
		$product = new ProductModel();
        $data = $product->conver_par();
        $product_type_list = $product->get_type_list("3");//3是虚拟主机的大类
        $product_info = $product->get_host_product();
        $banner = $product->banner(2);
		$sign = $data["type"];
		if(!in_array($sign,array("host","hkhost","usahost","dedehost","cloudVirtual","cloudspace"))){
			$sign = "host";
		}
        $this->assign([
            "sign" => $sign,
            "banner" => $banner,
            "product_list" =>$product_info,
            "ptype_list"=>$product_type_list
        ]);
        $this->display();
    }

    /**
    * 虚拟主机详情
    * @date: 2016年11月12日 上午9:45:40
    * @author: Lyubo
    * @param: product_id
    */
    public function vhostDetail(){
		$product = new ProductModel();
        $virtualhost_info = $product->virtualhost_info();
        if($virtualhost_info === false){
			$this->assign(["error_info" => "参数错误！"]);
			$this->display("Empty/index");die;
        }
		if(!$virtualhost_info["product_info"]["product_state"]){
			$this->error("该产品已下线！");
		}
		$area_code = array(
			4001 => "郑州",
			4002 => "香港",
			4003 => "北京",
			4005 => "美国",
			4008 => "国内"
		);
        $this->assign([
            "product_info" =>$virtualhost_info["product_info"],
            "product_config" =>$virtualhost_info["product_config"],
            "product_price" =>$virtualhost_info["product_price"],
            "is_product_info"=>true,
            "system_type"=>$virtualhost_info["system_type"],
            "price_id"=>$virtualhost_info["price_id"],
            "price"=>$virtualhost_info["price"],
			"area_code" => $area_code
        ]);
        $this->display("Product/vhostDetail");
    }
    
    
    /**
     * ssl证书列表页
     * @时间: 2019年8月21日18:22:39
     * @author: GuoPeng
	 */
    public function ssl(){
    	$this->display();
    }

	/**
	 * SSL证书购买页
	 * @时间: 2019年8月21日18:22:39
	 * @author: GuoPeng
	 */
	public function sslbuy(){
		$product = new ProductModel();
		$products = $product->get_ssl_product();
		$banner = $product->banner(4);
		if(empty($products)){
			$this->_error("获取产品信息失败,请联系管理员！");
		}
		$this->assign(["banner" => $banner,"products" => $products]);
		$this->display();
	}
}