<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2016/12/6
 * Time: 9:46
 */

namespace Frontend\Controller;

use Common\Data\GiantAPIParamsData as GD;
use Common\Respository\SslRespository;
use Frontend\Controller\FrontendController;
use Frontend\Model\OrderModel;
use Frontend\Model\SslModel;

class SslController extends FrontendController{
    public function _initialize(){
        parent::_initialize();
		if(!in_array(ACTION_NAME,array("ssl_agreement"))){
			if(!session("?user_id")){
				if(IS_AJAX){
					$this->success("请先登录！",U("Login/login"),true);
				}else{
					redirect(U("Login/login"),0,"");
					die();
				}
			}
		}
    }

    /**
     * 购买SSL证书操作
     * @date: 2019年8月21日11:46:10
     * @author: GuoPeng
     */
    public function buy(){
        $ssl = new SslModel();
        $result = $ssl->buy();
        if($result["status"]){
            $this->success($result["msg"],U("order/orderlist",array("state" => 6)),true);
        }else{
            $url = "";
            if($result["msg"] == "交易失败：会员账号余额不足！"){
                $url = U("financial/member_recharge");
            }
            $this->error($result["msg"],$url,true);
        }
    }

    /**
     * 获取用户所有ssl证书
     * @author: Guopeng
     */
    public function ssllist(){
        $ssl = new SslModel();
        $where = $ssl->conver_par();
        $order = I("get.order") == "ASC" ? "ASC" : "DESC";
        $keyword = request()["select"] ? request()["select"] : "";
        $pagnum = request()["pagnum"] ? request()["pagnum"] : "10";//每页显示条数
        $info = $ssl->get_ssl_business_list($where,$pagnum,$order,GD::PTYPE_SSL);
        $Not_open = $ssl->get_not_open($info["list"],6);
        $page = request()["page"] + 0;
        if($page > 0 && isMobile() == "phone"){
            if(empty($info["list"])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($info["list"]);
                die();
            }
        }
        $this->assign(["count" => $info["count"],"page" => $info["page_show"],"info" => $info["list"],"pagnum" => $pagnum,"keyword" => $keyword,"not_open" => implode(",",$Not_open)]);
        $this->display();
    }

    /**
     * 获取用户所有ssl证书
     * @author: Guopeng
     */
    public function sslrenew(){
        $ssl = new SslModel();
        $where = $ssl->conver_par();
        $order = I("get.order");
        $info = $ssl->get_ssl_business_renew($where,10,$order,GD::PTYPE_SSL);
        $Not_open = $ssl->get_not_open($info["list"],6);
        $this->assign(["count" => $info["count"],"page" => $info["page_show"],"info" => $info["list"],"not_open" => implode(",",$Not_open)]);
        $this->display();
    }

    /**
     * 获取列表数量和待续费业务数量
     * @date: 2017年4月11日 下午4:47:38
     * @author: Lyubo
     */
    public function state_count(){
        $ssl = new SslModel();
        $sum = $ssl->cloudserver_stateCount(GD::PTYPE_SSL);
        $date["status"] = "ok";
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 修改备注
     * @author: Guopeng
     */
    public function remark(){
        $ssl = new SslModel();
        $result = $ssl->remark_edit($state = true);
        if($result){
            $data = "ok";
            $this->ajaxReturn($data,"json");
        }else{
            $data = "fail";
            $this->ajaxReturn($data,"json");
        }
    }

    /**
     * SSL证书开通
     * @author: Guopeng
     */
    function ssl_open(){
        $uid = session("user_id");
        $data = request(true);
        $oid = $data["order_id"];
        $Order = new OrderModel();
        $Ssl = new SslModel();
        $oinfo = $Order->order_find($oid);
		if($oinfo["user_id"] != $uid){
			$message = "订单不属于该会员！";
			$url = U("Order/orderlist",["state" => 6]);
			$this->_mc_error($message,$url);
		}
		if($oinfo["state"] != 6 && $oinfo["state"] != 2 && $oinfo["state"] != 1){
			$message = "订单状态错误！";
			$url = U("Order/orderlist",["state" => 6]);
			$this->_mc_error($message,$url);
		}
		if($oinfo["product_id"] == 228){
			$message = "该订单不可开通！";
			$url = U("Order/orderlist",["state" => 6]);
			$this->_mc_error($message,$url);
		}elseif($oinfo["product_id"] == 321){
			$this->assign(["info" => $oinfo]);
			$fill = json_decode($oinfo["root_domain"],true);
			$this->assign(["fill" => $fill]);
			if($oinfo["state"] == 1 && $oinfo["system_type"] == 5){
				$uid = session("user_id");
				$where["business_id"] = $oinfo["business_id"];
				$where["root_domain"] = $oinfo["api_ip_id"];
				$where["user_id"] = $uid;
				$where["product_id"] = $oinfo["product_id"];
				$binfo = $Ssl->where($where)->find();
				$fill = json_decode($binfo["fill"],true);
				$down["add"] = $fill["add"];
				$down["psd"] = $fill["psd"];
				$this->assign(["down" => $down]);
			}
			$this->display("ssl_comodo_open");
		}else{
			if($oinfo["state"] == 1){
				$message = "订单已开通！";
				$url = U("Ssl/ssllist");
				$this->_mc_error($message,$url);
			}
			$where["bs.business_id"] = $oinfo["business_id"];
			$where["bs.user_id"] = $uid;
			$where["bs.product_id"] = $oinfo["product_id"];
			$ssl_binfo = $Ssl->get_ssl_state($where);
			//通过business_id查询业务是否正在开通中
			if($ssl_binfo){
				$Order->order_edit($oid,["state" => 2]);
				$data["yw_id"] = $ssl_binfo["id"];
				$data["order_id"] = $oid;
				$this->redirect(U("Ssl/ssl_business_open",$data));
			}
			$result = $Ssl->ssl_open($oid,$uid);
			if($result <= 0){
				$message = business_code($result);
				$url = U("Order/orderlist",["state" => 6]);
				$this->error($message,$url);
			}else{
				$data["yw_id"] = $result;
				$data["order_id"] = $oid;
				$this->redirect(U("Ssl/ssl_business_open",$data));
			}
		}
    }

	/**
	 * SSL-Comodo证书开通
	 * @author: Guopeng
	 * @时间: 2019年8月23日11:47:24
	 */
	function ssl_comodo_open(){
		$Ssl = new SslModel();
		$result = $Ssl->comodo_open();
		if($result["status"]){
			$msg = $result["msg"];
			$this->success($msg,"",true);
		}else{
			$msg = $result["msg"];
			if($result["info"]){
				$this->error($msg,"",$result["info"]);
			}else{
				$this->error($msg,"",true);
			}
		}
	}

    /**
     * SSL证书分步开通
     * @author: Guopeng
     */
    function ssl_business_open(){
        $user_id = session("user_id");
        $open_info = request();
        $order_id = $open_info["order_id"] + 0;
        $os = new OrderModel();
        $ssl = new SslModel();
        $order_info = $os->order_find($order_id);
        if($order_info ["user_id"] != $user_id || $order_info["state"] != 2){
            $message = "订单不存在，或者订单错误";
            $url = U("Order/orderlist");
            $this->error($message,$url);
        }
        $where["bs.business_id"] = $order_info["business_id"];
        $where["bs.user_id"] = $user_id;
        $where["bs.product_id"] = $order_info["product_id"];
        $ssl_binfo = $ssl->get_ssl_state($where);
        //通过business_id查询业务是否正在开通中
        if(!$ssl_binfo){
            $message = "业务不存在";
            $url = U("Order/orderlist");
            $this->error($message,$url);
        }
        if(!is_null($ssl_binfo["domain_name"]) && !empty($ssl_binfo["domain_name"])){
            $ssl_binfo["domain_name"] = explode(",",$ssl_binfo["domain_name"]);
        }
        if(!is_null($ssl_binfo["params"]) && !empty($ssl_binfo["params"])){
            $ssl_binfo["params"] = explode(",",$ssl_binfo["params"]);
        }
        $fill = $images = $validate = "";
        if(isset($ssl_binfo["fill"]) && !empty($ssl_binfo["fill"])){
            $fill = json_decode($ssl_binfo["fill"],true);
        }
        if(isset($ssl_binfo["images"]) && !empty($ssl_binfo["images"])){
            $images = json_decode($ssl_binfo["images"],true);
        }
        if(isset($ssl_binfo["validates"]) && !empty($ssl_binfo["validates"])){
            $validate = json_decode($ssl_binfo["validates"],true);
        }
        $this->assign(["ssl_binfo" => $ssl_binfo,"order_id" => $order_id,"fill" => $fill,"images" => $images,"validates" => $validate]);
        if(strpos($ssl_binfo["api_name"],"dv") !== false){
            $this->display("ssl_dv_open");
        }else{
            $this->display("ssl_business_open");
        }
    }

    /**
     * 域名验证
     * @author: Guopeng
     */
    function check_domain(){
        $ymbd = I("post.ymbd");
        $ssl = new SslModel();
        $result = $ssl->checkDomain($ymbd);
        if($result){
            echo json_encode(array("status" => 1));
        }else{
            echo json_encode(array("status" => 0));
        }
    }

    public function ssl_dv_open(){
        $ssl = new SslModel();
        $result = $ssl->ssl_dv_open();
        $message = $ssl->getError();
        if($result){
            $message = "资料保存成功！";
            $this->success($message,U("order/orderlist"),true);
        }else{
            $this->error($message,"",true);
        }
    }

    /**
     * SSL证书开通域名绑定
     * @author: Guopeng
     */
    public function ssl_open_bind(){
        $ssl = new SslModel();
        $result = $ssl->ssl_open_bind();
        if($result){
            $message = "绑定域名成功！";
            $this->success($message,"",true);
        }else{
            $message = "绑定域名失败！".$ssl->getError();
            $this->error($message,"",true);
        }
    }

    /**
     * SSL证书资料
     * @author: Guopeng
     */
    public function ssl_fill_info(){
        $ssl = new SslModel();
        $result = $ssl->ssl_fill_info();
        $message = $ssl->getError();
        if($result){
            $message = "保存资料成功！";
            $this->success($message,"",true);
        }else{
            $this->error($message,"",true);
        }
    }

    public function ssl_upload_info(){
        $ssl = new SslModel();
        $result = $ssl->ssl_upload_info();
        if($result){
            $message = "上传成功！";
            $array = ["status" => 1,"info" => $message];
            echo json_encode($array);
            exit();
        }else{
            $message = $ssl->getError();
            $array = ["status" => $result["status"],"info" => $message];
            echo json_encode($array);
            exit();
        }
//        if($result){
//            $message = "上传成功！";
//            $this->success($message,"",true);
//        }else{
//            $message = $ssl->getError();
//            $this->error($message,"",true);
//        }
    }

    /*
     * ssl
     */
    public function ssl_user_validate(){
        $ssl = new SslModel();
        $result = $ssl->ssl_user_validate();
        if($result){
            $message = "验证成功！";
            $this->success($message,"",true);
        }else{
            $message = $ssl->getError();
            $this->error($message,"",true);
        }
    }

    /**
     * 获取SSL开通进度
     * @author : Guopeng
     * @param : $ssl_id,保存在主站的订单编号
     * @return  boolean
     */
    public function get_open_progress(){
        $ssl = new SslModel();
        $data = request();
        $ssl_id = $data["ssl_id"];
        if(is_null($ssl_id) || !is_numeric($ssl_id) || strpos($ssl_id,".") != false){
            $msg = "业务编号为空或错误";
            $this->error($msg,"",true);
        }
        $result = $ssl->get_business_info($ssl_id);
        if($result){
            $msg = "业务开通成功";
            $this->success($msg,"",true);
        }elseif($result === 0){
            $this->error("",1,true);
        }else{
            $msg = $ssl->getError();
            $this->error($msg,0,true);
        }
    }

    public function ssl_validate(){
        $data = request();
        $ssl = new SslModel();
        $user_id = session("user_id");
        $yw_id = $data["yw_id"] + 0;
        $where["id"] = $yw_id;
        $where["user_id"] = $user_id;
        $dataarray["open_step"] = 6;
        $dataarray["state"] = 6;
        $save = $ssl->where($where)->save($dataarray);
        if($save !== false){
            $msg = "验证成功";
            $this->success($msg,"",true);
        }else{
            $msg = "验证失败";
            $this->error($msg,0,true);
        }
    }

    /**
     * 同步业务信息
     * @date: 2016年11月29日 下午2:53:15
     * @author: Lyubo
     * @param: $yw_id,$ptype
     * @return boolean
     */
    public function memberSync(){
        $data = request();
        $yw_id = $data["business_id"] + 0;
        $url = U("ssl/ssllist");
        $ssl = new SslModel();
        $sslRespository = new SslRespository($ssl);
        $result = $sslRespository->SslBusinessSynchronizing($yw_id);
        if($result){
            $this->success("同步业务信息成功",$url,true);
        }else{
            $this->error("同步业务信息失败-".$sslRespository->model()->getError(),$url,true);
        }
    }

    /**
     * SSL购买服务协议
     * @date: 2017年5月26日 上午11:40:40
     * @author: Guopeng
     */
    public function ssl_agreement(){
        $this->display();
    }

}