<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Frontend\Model\OrderModel;
use Frontend\Model\VpsModel;
use Common\Model\CertifyLogModel;

/**
 * VPS
 * @date: 2016年10月25日 下午3:51:53
 * @author: Lyubo
 */
class VpsController extends FrontendController{
    public function _initialize(){
        parent::_initialize();
        if(!session('?user_id')){
            redirect(U('Login/login'));die();
        }
    }

    /**
     * 获取用户所有VPS业务
     * @date: 2016年10月25日 下午4:42:40
     * @author: Lyubo
     * @display: $info
     */
    public function vpslist(){
		$data = request(true);
		$page = $data["page"] + 0;
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "ASC" ? "ASC" : "DESC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
        $fs = new VpsModel();
        $where = $fs->conver_par();
        $info = $fs->get_vps_business_list($where,$pagnum,$order);
        if($page > 0 && isMobile() == 'phone'){
            if(empty($info['list'])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($info['list']);
                die();
            }
        }
        $this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword,"pagnum"=>$pagnum]);
        $this->display();
    }

    /**
     * 获取用户所有VPS待续费业务
     * @date: 2016年10月25日 下午4:42:40
     * @author: Lyubo
     * @display: $info
     */
    public function vpsrenew(){
		$data = request(true);
		$keyword = $data["select"] ? $data["select"] : "";
		$order = $data["order"] == "DESC" ? $data["order"] : "ASC";
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
        $fs = new VpsModel();
        $where = $fs->conver_par();
        $info = $fs->get_vps_renew_list($where,$pagnum,$order);
        $this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword,"pagnum"=>$pagnum]);
        $this->display();
    }

    /**
     * 获取列表数量和待续费业务数量
     * @date: 2017年4月11日 下午4:47:38
     * @author: Lyubo
     * @param: variable
     * @return string json
     */
    public function state_count(){
        $fs = new VpsModel();
        $sum = $fs->stateCount();
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 修改备注
     * @date: 2016年10月27日 上午11:23:22
     * @author: Lyubo
     * @param: remark，business_id
     * @return json
     */
    public function remark(){
        $vps = new VpsModel();
        $result = $vps->remark_edit();
        if($result){
            $data = "ok";
            $this->ajaxReturn($data,'json');
        }else{
            $data = "fail";
            $this->ajaxReturn($data,'json');
        }
    }

    /**
     * 获取VPS业务详情
     * @date: 2017年5月24日 上午11:02:40
     * @author: Guopeng
     * @return array
     */
    public function vpsinfo(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $fs = new VpsModel();
        $date = request();
        $vps_id = $date["yid"] + 0;
        if(empty($vps_id)){
            $this->error("业务编号错误或不存在！");
        }
        $vps_info = $fs->vps_info($vps_id);
        if(empty($vps_id)){
            $this->error("业务编号错误或不存在！");
        }
        $this->assign(["info" => $vps_info]);
        $this->display();
    }

    /**
     * VPS租赁服务协议
     * @date: 2017年5月26日 上午11:40:40
     * @author: Guopeng
     */
    public function vps_agreement(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $this->display();
    }

	/**
	 * 用户vps实名认证页面
	 * @date: 2018年09月12日
	 * @author: gechangfen
	 */
	public function toAuthentication(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$data = request();
		$vps_id = $data['vps_id'];
		$user_id = session('user_id');
		$vps = new VpsModel();
		$binfo = $vps->where(array('id' => $vps_id,'user_id' => $user_id))->find();
		if(!$binfo){
			$this->error('未查询到符合条件的业务');
		}
		$vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
		if($data['ptype']){
			$result = $vpsRespository->VpsBusinessSynchronizing($binfo['business_id'],$data['ptype']);
		}
		/*同步后，查一下实名状态，并返回状态值*/
		$auth = $vps->where(array('id' => $vps_id))->find();//实名状态查询
		if($auth['authentication'] != 0){ //已实名
			$this->error("该业务已经提交实名认证，请勿重复提交",U('vps/vpslist'));
		}
		if(IS_POST){  //实名认证处理
			$data = I("post.");
			$result = $vps->certify($data,$binfo);
			if($result === false){
				$message = $vps->getError();
			}else{
				$message = business_code($result);
			}
			if($result == -1){
				if(IS_AJAX){
					$this->success("VPS实名认证信息提交成功，请等待审核！",U('vps/vpslist'),true);
				}else{
					$this->success("VPS实名认证信息提交成功，请等待审核！",U('vps/vpslist'));
				}
			}else{
				if(IS_AJAX){
					$this->error($message,U('vps/vpslist'),true);
				}else{
					$this->error($message,U('vps/vpslist'));
				}
			}
		}else{
			$this->assign(['bid' => $binfo['business_id'],'vps_id' => $binfo['id']]);
			$this->display("Vps/toAuthentication");
		}
	}

	/**
	 * 实名认证记录
	 * 2018-09-18
	 * gcf
	 * */
	public function authList(){
		if(!session('?user_id')){
			redirect(U('Login/login'));die();
		}
		$data = request();
		$where['user_id'] = $wheret['user_id'] = session('user_id');
		$where['pb_id'] = $data['vps_id'];//产品业务主键id
		$where['api_bid'] = $data['business_id'];//接口业务id
		$certifylog = new CertifyLogModel;
		$order_by = '';
		if($where['pb_id']){
			$info = $certifylog->get_log_list($where,10,"*",$order_by);
		}else{
			$info = $certifylog->get_log_list($wheret,10,"*",$order_by);
		}
		foreach($info['list'] as $k => &$v){
			$v['idcart'] = substr_replace($v['idcart'],'*******',4,12);
			$v['phone'] = substr_replace($v['phone'],'*****',3,4);
			//	$v['contactname']=substr_replace($v['contactname'],'*',-2,2);
		}
		/*审核状态如何判定，及审核说明情况 */
		$this->assign(["count" => $info['count'],"page" => $info["page_show"],'info' => $info['list']]);
		$this->display("Vps/authList");
	}

    /**************************VPS业务开通***************************/
    /**
     * 开通VPS业务
     * @date: 2016年11月19日 上午10:02:37
     * @author: Lyubo
     * @param: $order_id
     */
    public function vps_open(){
        $order = new OrderModel();
        $vps = new VpsModel();
        $open_info = request(); 
        $order_id = $open_info['order_id'];
        $member_id = session('user_id');
        if(is_null($order_id) || $order_id <= 0 || !is_int($order_id)){
            $msg = '订单不存在';
            $url = U('order/orderlist',['state'=>'6']);
            if(IS_AJAX){
                $this->error($msg,$url,true);
            }else{
				$this->_mc_error($msg);
            }
        }
        if(IS_POST){
            $result = $vps->vps_open($order_id,$member_id);
            $msg = business_code($result['code']);
            if($result['code'] == -1){
				//发送开通邮件
				business_sendMail('11',$result,$member_id);
                if(isMobile() == "phone"){
                    $msg = "VPS开通成功，您可以在控制台查看VPS业务信息";
                    $url = U('order/orderlist');
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
                    $msg = "VPS开通成功，您可以在[产品中心-VPS]查看VPS业务信息";
                    $url = U('vps/vpslist');
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }
            }elseif($result['code'] === 0){
                if(isMobile() == "phone"){
                    $msg = "该VPS订单已经开通，暂时不支持手机管理产品，您可以在电脑登录[产品中心-VPS]查看VPS业务信息";
                    $url = U('order/orderinfo',["order_id"=>$order_id]);
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
                    $msg = "该VPS订单已经开通，您可以在[产品中心-VPS]查看VPS业务信息";
                    $url = U('vps/vpslist');
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }
            }else{
                $url = U('vps/vpslist');
                if(IS_AJAX){
                    $this->error($msg,$url,true);
                }else{
                    $this->error($msg);
                }
            }
        }else{
            //显示开通页面
            $order_info = $order->order_find($order_id);
            if(empty($order_info)){
                $msg="订单不存在！";
				$this->_mc_error($msg);
            }
            if($order_info['user_id'] != $member_id){
                $msg="该订单不属于当前会员！";
				$this->_mc_error($msg);
            }
            if($order_info['state'] != 6){
				$msg = '订单状态错误！';
				$this->_mc_error($msg);
            }
			$system_types = $vps->GetOsType($order_info["product_id"],$order_info["access"]);
			$system_type = array();
			if($system_types["code"] == 0){
				if($order_info["area_code"] == 4002){
					foreach($system_types["info"] as $key => $value){
						$system_type[] = array("bh"=>$key,"displayName"=>$value);
					}
				}else{
					foreach($system_types["info"] as $key => $value){
						$system_type = array_merge($system_type,$value);
					}
				}
			}
			$syetype = "Windows2003";
			if($order_info["system_type"] == 1){
				$syetype = "CentOS 6.7";
			}
			$this->assign('syetype',$syetype);
			$this->assign('system_type',$system_type);
            $this->assign('order_info',$order_info);
            $this->display();
        }
    }

	/**
	 * vps测试码开通
	 * @date: 2018年4月24日16:58:52
	 * @author: Guopeng
	 */
	public function vps_code_open(){
		$vps = new VpsModel();
		$url = U('order/orderlist',['state'=>'6']);
		$order_id = request()['order_id'] + 0;
		if(IS_POST && IS_AJAX){
			$result = $vps->vps_code_open(false);
			if($result["status"] === true){
				if(isMobile() == "phone"){
					$msg = "VPS成功开通，暂时不支持手机管理产品，您可以在电脑登录[会员中心-产品中心-VPS]查看业务信息";
					$url = U('order/orderinfo',["order_id" => $order_id]);
				}else{
					$msg = "VPS开通成功，您可以在[会员中心]查看VPS业务信息！";
					$url = U('vps/vpslist');
				}
				$this->success($msg,$url,true);
			}else{
				$msg = $result['msg'];
				$this->error($msg,$url,true);
			}
		}else{
			$result = $vps->vps_code_open(true);
			if($result["status"] === false){
				$this->_mc_error($result["msg"]);
			}
			$order_info = $result["info"];
			$this->assign('order_info',$order_info);
			$system_types = $vps->GetOsType($order_info["product_id"],$order_info["access"]);
			$system_type = array();
			if($system_types["code"] == 0){
				if($order_info["area_code"] == 4002){
					foreach($system_types["info"] as $key => $value){
						$system_type[] = array("bh"=>$key,"displayName"=>$value);
					}
				}else{
					foreach($system_types["info"] as $key => $value){
						$system_type = array_merge($system_type,$value);
					}
				}
			}
			$syetype = "Windows2003";
			if($order_info["system_type"] == 1){
				$syetype = "CentOS 6.7";
			}
			$this->assign('syetype',$syetype);
			$this->assign('system_type',$system_type);
			$this->display();
		}
	}
    /**************************VPS业务开通***************************/
    /**************************VPS业务续费***************************/
    /**
     * VPS业务续费
     * @author:Guopeng
     */
    function vps_renewals(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_mc_error($msg);
			}
        }
        if(IS_POST){
            $order_time = $data["renewalstime"] + 0;
            $result = $vs->vps_renewals($user_id,$yw_id,$order_time);
            $msg = business_code($result);
            if($result == -1){
                $msg = "VPS续费成功，您可以在[会员中心]查看订单信息和VPS信息";
				if(IS_AJAX){
					$this->success($msg,$url,true);
				}else{
					$this->success($msg,$url);
				}
            }else{
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }
        }else{
            // 业务信息
            $result = $vs->vps_renewals($user_id,$yw_id,'',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_mc_error($msg);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务续费***************************/
    /**************************VPS业务升级***************************/
    /**
     * VPS业务升级
     * @author:Guopeng
     */
    function vps_uplevel(){
        $user_id = session("user_id");
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_mc_error($msg);
			}
        }
        if(IS_POST){
            $up_product_id = $data["up_product_id"] + 0;
            if(is_null($up_product_id) || !is_numeric($up_product_id) || strpos($up_product_id,".") != false || $up_product_id <= 0){
                $msg = "产品名称错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }else{
                $result = $vs->vps_upgrade($user_id,$yw_id,$up_product_id);
                $msg = business_code($result);
                if($result == -1){
                    $msg = "VPS升级成功，您可以在[会员中心]查看订单信息和VPS信息";
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
					if(IS_AJAX){
						$this->error($msg,$url,true);
					}else{
						$this->error($msg,$url);
					}
                }
            }
        }else{
            // 业务信息
            $result = $vs->vps_upgrade($user_id,$yw_id,'',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_mc_error($msg);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务升级***************************/
    /**************************VPS业务增值***************************/
    /**
     * VPS业务增值
     * @author:Guopeng
     */
    function vps_appreciation(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_mc_error($msg);
			}
        }
        if(IS_POST){
            $appreciation_name = $data["api_name"]; // 增值类型
            $appreciation_size = $data["app_size"] + 0; // 增值容量
            if(is_null($appreciation_size) || !is_numeric($appreciation_size) || strpos($appreciation_size,".") != false || $appreciation_size <= 0){
                $msg = "增值容量错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }elseif(is_null($appreciation_name)){
                $msg = "增值类型错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }else{
                $result = $vs->vps_appreciation($user_id,$yw_id,$appreciation_name,$appreciation_size);
                $msg = business_code($result);
                if($result == -1){
                    $msg = "VPS增值成功，您可以在[会员中心]查看订单信息和VPS信息";
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
					if(IS_AJAX){
						$this->error($msg,$url,true);
					}else{
						$this->error($msg,$url);
					}
                }
            }
        }else{
            // 业务信息
            $result = $vs->vps_appreciation($user_id,$yw_id,'','',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_mc_error($msg);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务增值***************************/
    /**************************VPS业务转正***************************/
    /**
     * VPS业务转正
     * @author:Guopeng
     */
    function vps_onformal(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_mc_error($msg);
			}
        }
        if(IS_POST){
            /*主机转正*/
            $service_time = $data["service_time"] + 0;
            $result = $vs->vps_onformal($user_id,$yw_id,$service_time);
            $msg = business_code($result);
            if($result == -1){
                $msg = "VPS转正成功，您可以在[会员中心]查看VPS信息";
				if(IS_AJAX){
					$this->success($msg,$url,true);
				}else{
					$this->success($msg,$url);
				}
            }else{
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }
        }else{
            /*显示主机转正*/
            $result = $vs->vps_onformal($user_id,$yw_id,'','get');
            if($result <= 0){
                $msg = business_code($result);
				$this->_mc_error($msg);
            }
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务转正***************************/
    /**
     * 同步业务信息
     * @date: 2016年11月29日 下午2:53:15
     * @author: Lyubo
     * @param: $yw_id,$ptype
     * @return boolean
     */
    public function memberSync(){
        $data = request();
        $yw_id = $data['business_id'] + 0;
        $ptype = $data['ptype'];
        $url = U('vps/vpslist');
        $vps = new VpsModel();
        $vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
        $result = $vpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
        if($result){
            $this->success("同步业务信息成功",$url,true);
        }else{
            $this->error("同步业务信息失败-".$vpsRespository->model()->getError(),$url,true);
        }
    }

	/**
	 * 刷新实名状态信息
	 * @date: 2019年4月16日09:45:04
	 * @author: GuoPeng
	 * @param: $business_id,$ptype
	 */
	public function upload_auth(){
		$data = request(true);
		$id = $data['id'] + 0;
		$vps = new VpsModel();
		$vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
		$result = $vpsRespository->upload_auth($id);
		if($result){
			$this->success("刷新成功！","",true);
		}else{
			$this->error("刷新失败：".$vpsRespository->model()->getError(),"",true);
		}
	}

    /**
     * 手机站VPS购买页
     * @date: 2017年5月3日 上午9:16:49
     * @author: Guopeng
     * @param:
     */
    public function vps_buy(){
        $this->_empty();
    }

	/**
	 * 批量同步业务信息
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		$data = request();
		$yids = $data["yids"];
		$vps = new VpsModel();
		$vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
		if(!is_array($yids)){
			$this->error("同步业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $vps->vps_info($yid);
			if(!$info){
				$this->error("同步业务信息失败!","",true);
			}
			$yw_id = $info['business_id'];
			$ptype = $info['api_ptype'];
			$result = $vpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}

    /**
     * 批量关联认证业务信息
     * @date: 2018年10月17日
     * @author: gcf
     * @param: $business_id,$ptype
     */
    public function SyncRen(){
        $data = request();
        $yids = $data["yids"];
        $vps = new VpsModel();
        $vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
        if(!is_array($yids)){
            $this->error("关联业务信息失败!","",true);
        }
        $all = $ok = $err = 0;
        $allt = $okt = $errt = 0;
        $auth=array();
        $wauth=array();
        foreach($yids as $yid){ //先同步；
            $all++;
            $info = $vps->vps_info($yid);
            if(!$info){
                $this->error("关联业务信息获取失败!","",true);
            }
            $yw_id = $info['business_id'];
            $ptype = $info['api_ptype'];
            $result = $vpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
            if($result){
                $ok++;
            }else{
                $err++;
            }

            if($info['authentication']==1){  //获取已认证的业务
                array_push($auth,$info['business_id']);
            }
            if($info['authentication']!=1){  //获取未认证的业务
                array_push($wauth,$info['business_id']);
            }
        }

        if(count($wauth)){  //有未认证业务的情况下，再判断有没有选已认证业务
            if(!count($auth)){  //验证是否选有已认证业务
                $this->error("请选择至少一个已认证的业务！","",true);
            }
            foreach($yids as $yid){  //批量关联认证
                $info = $vps->vps_info($yid);
                if(!$info){
                    $this->error("关联业务信息获取失败!","",true);
                }
                if($info['authentication']!=1){ //未认证的才去关联认证
                    $allt++;
                    $res=$vps->guanLian($auth[0],$info);//关联认证
                    if($res==-1){
                        $okt++;
                    }else{
                        $errt++;
                    }
                }
            }
            $this->success("共关联<font color='red'>".$allt."</font>个业务，成功<font color='red'>".$okt."</font>个，失败<font color='red'>".$errt."</font>个！","",true);
        }else{
            $this->success("共关联<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
        }
    }
}