<?php
namespace Frontend\Model;

use Common\Data\StateData as SD;
use Frontend\Model\BusinessModel;
use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;

class CloudserverModel extends BusinessModel{
	protected $trueTableName = 'agent_cloudserver_business';

	public function conver_par(){
		$date = request();
		$where["bs.user_id"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$select = clearXSS($date['select']);
			$map['bs.api_bid'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['bs.nw_ip'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['bs.ww_ip'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['bs.service_code'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map["bs.beizhu"] = array("like","%$select%");
			$where['_complex'] = $map;
		}
		return $where;
	}

	/**
	 * 快云服务器OsType
	 * @date: 2016年11月25日 下午2:52:55
	 * @author: Lyubo
	 * @return array|int
	 */
	public function OsTypeInfo(){
		$api_config = WebSiteConfig(2);//获取网站配置
		$api_access = $api_config["api_access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$ptype = GD::PTYPE_CLOUD_SERVER;
		$pname = "cloudserver.getKVMsystem";
		$tid = 56;
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$area_code = 4001;
		$log_message = "ptype:".$ptype."||tid=".$tid."pname:".$pname;
		try{
			$result = $transaction->GetOsType($ptype,$pname,$tid,$area_code);
			//api_log("-1",$log_message,$result,'获取郑州机房服务器操作系统');
			$zz_json = json_decode($result,true);
		}catch(\Exception $e){
			$result = $e->getMessage();
			api_log("-1",$log_message,$result,'获取郑州机房服务器操作系统失败');
			return -9;
		}
		if($api_config["api_hk"] != 1){
			$hk_json = array("code"=>1);
		}else{
			$api_access = $api_config["api_hk_access"] + 0;
			$api_access = $api_access ? $api_access : 6;
			$agent = new AgentAide(1,$api_access);
			$transaction = $agent->servant;
			$area_code = 4002;
			$log_message = "ptype:".$ptype."||tid=".$tid."pname:".$pname;
			try{
				$result = $transaction->GetOsType($ptype,$pname,$tid,$area_code);
				//api_log("-1",$log_message,$result,'获取香港机房服务器操作系统');
				$hk_json = json_decode($result,true);
			}catch(\Exception $e){
				$result = $e->getMessage();
				api_log("-1",$log_message,$result,'获取香港机房服务器操作系统失败');
				return -9;
			}
		}
		return $json = ["hk" => $hk_json,"zz" => $zz_json];
	}

	public function get_cloudserver_price_list(){
		$where["product_id"] = ["in",array(219,220,221,222,223,224,225,226)];
		$where["month"] = 1;
		$product_price = M("product_price");
		$product_price_info = $product_price->where($where)->select();
		$p = array();
		foreach($product_price_info as $k => $v){
			$a["price"] = $v["product_price"];
			$a["name"] = $v["note_appended"];
			$p[$v["area_code"]][] = $a;
		}
		return $p;
	}
	/**
	 * 展示快云服务器价格
	 * @date: 2018年5月3日18:52:01
	 * @author: Guopeng
	 * @param $data
	 * @return string
	 */
	public function showPrice($data){
		$product = new ProductModel();
		$config = [
			"1" => ["disk" => "80","cpu" => "1","mem" => "1","bandwidth" => "2"],
			"2" => ["disk" => "120","cpu" => "2","mem" => "2","bandwidth" => "3"],
			"3" => ["disk" => "200","cpu" => "4","mem" => "4","bandwidth" => "5"],
			"4" => ["disk" => "300","cpu" => "8","mem" => "8","bandwidth" => "7"],
			"5" => ["disk" => "500","cpu" => "16","mem" => "16","bandwidth" => "10"]
		];
		if(isMobile() == 'phone'){
			for($i = 1;$i < count($config);$i++){
				if($data['pzbh'] == $i){
					$data['disk'] = $config[$i]['disk'];
					$data['cpu'] = $config[$i]['cpu'];
					$data['mem'] = $config[$i]['mem'];
					$data['bandwidth'] = $config[$i]['bandwidth'];
				}
			}
		}
		/** 查询数据库计算云服务器价格 */
		$price_list = $product->get_cloud_price_list($data['dqbh']);
		if(empty($price_list)){
			return $cloud_price = 0;
		}
		$dqbh = $data['dqbh'];
		$gmqx = $data['gmqx']+0;
		$gmqx = $gmqx ? $gmqx : 1;
		$cpu = $data['cpu']+0;
		$mem = $data['mem']+0;
		$disk = ($data['disk']+0) / 10;
		$bandwidth = $data['bandwidth']+0;
		$cpu_price = 20;
		$mem_price = 25;
		$disk_price = 6;
		$bandwidth_price = 20;
		$bandwidth_price2 = 70;
		$type = $data['type'];
		//机房：4001:郑州机房，4002:香港机房，40015:郑州电信，40016:河南联通
		if($dqbh == '4001'){
			if($type == 4){
				$cpu = $cpu < 0 ? 0 : $cpu;
				$mem = $mem < 0 ? 0 : $mem;
				$disk = $disk < 0 ? 0 : $disk;
				$bandwidth = $bandwidth < 0 ? 0 : $bandwidth;
			}else{
				$cpu = $cpu < 1 ? 1 : $cpu;
				$mem = $mem < 1 ? 1 : $mem;
				$disk = $disk < 1 ? 1 : $disk;
				$bandwidth = $bandwidth < 1 ? 1 : $bandwidth;
			}
			foreach($price_list as $key=>$val){
				if($val["note_appended"] == "CPU"){
					$cpu_price = $val["product_price"];
				}elseif($val["note_appended"] == "内存"){
					$mem_price = $val["product_price"];
				}elseif($val["note_appended"] == "数据盘"){
					$disk_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽"){
					$bandwidth_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽大于5M"){
					$bandwidth_price2 = $val["product_price"];
				}
			}
			$cloud_cpu_price = $cpu_price * $cpu;
			$cloud_mem_price = $mem_price * $mem;
			$cloud_disk_price = $disk_price * $disk;
			if($bandwidth > 5){
				$cloud_bandwidth_price = $bandwidth_price2 * ($bandwidth - 5) + $bandwidth_price * 5;
			}else{
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth;
			}
		}elseif($dqbh == '4002'){
			if($type == 4){
				$cpu = $cpu < 0 ? 0 : $cpu;
				$mem = $mem < 0 ? 0 : $mem;
				$disk = $disk < 0 ? 0 : $disk;
				$bandwidth = $bandwidth < 0 ? 0 : $bandwidth;
			}else{
				$cpu = $cpu < 1 ? 1 : $cpu;
				$mem = $mem < 1 ? 1 : $mem;
				$disk = $disk < 1 ? 1 : $disk;
				$bandwidth = $bandwidth < 1 ? 1 : $bandwidth;
			}
			$cpu_price = 40;
			$disk_price = 8;
			$bandwidth_price = 25;
			$bandwidth_price2 = 90;
			foreach($price_list as $key=>$val){
				if($val["note_appended"] == "CPU"){
					$cpu_price = $val["product_price"];
				}elseif($val["note_appended"] == "内存"){
					$mem_price = $val["product_price"];
				}elseif($val["note_appended"] == "数据盘"){
					$disk_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽"){
					$bandwidth_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽大于5M"){
					$bandwidth_price2 = $val["product_price"];
				}
			}
			$cloud_cpu_price = $cpu_price * $cpu;
			$cloud_mem_price = $mem_price * $mem;
			$cloud_disk_price = $disk_price * $disk;
			if($bandwidth > 5){
				$cloud_bandwidth_price = $bandwidth_price2 * ($bandwidth - 5) + $bandwidth_price * 5;
			}else{
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth;
			}
		}elseif($dqbh == '40015' || $dqbh == '40016'){
			$cpu = $cpu < 8 ? 8 : $cpu;
			$mem = $mem < 16 ? 16 : $mem;
			$disk = $disk < 30 ? 30 : $disk;
			$bandwidth = $bandwidth < 100 ? 100 : $bandwidth;
			$cpu = $cpu - 8;
			$mem = $mem - 16;
			$disk = $disk - 30;
			$bandwidth = $bandwidth - 100;
			$cpu_price = 30;
			$bandwidth_price = 15;
			if($cpu == 0 && $mem == 0 && $disk == 0 && $bandwidth == 0){
				$cloud_cpu_price = 0;
				$cloud_mem_price = 0;
				$cloud_disk_price = 0;
				$cloud_bandwidth_price = 780;
			}else{
				foreach($price_list as $key=>$val){
					if($val["note_appended"] == "CPU"){
						$cpu_price = $val["product_price"];
					}elseif($val["note_appended"] == "内存"){
						$mem_price = $val["product_price"];
					}elseif($val["note_appended"] == "数据盘"){
						$disk_price = $val["product_price"];
					}elseif($val["note_appended"] == "带宽"){
						$bandwidth_price = $val["product_price"];
					}
				}
				$cloud_cpu_price = $cpu_price * $cpu;
				$cloud_mem_price = $mem_price * $mem;
				$cloud_disk_price = $disk_price * $disk;
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth + 780;
			}
		}else{
			return $cloud_price = 0;
		}
		if($type == GD::TID_UPGRADE){
			//续费没有优惠
		}else{
			if($gmqx == 12){
				$gmqx = 10;
			}elseif($gmqx == 24){
				$gmqx = 20;
			}elseif($gmqx == 36){
				$gmqx = 30;
			}
		}
		$count = 1;
		$discount = 1;
		if(session('?user_id')){
			$discounts = WebSiteConfig(8);
			if(($type == 1 && $discounts["discount_buy"] == 1)
				|| ($type == 3 && $discounts["discount_renew"] == 1)
				|| ($type == 11 && $discounts["discount_onformal"] == 1)
				|| ($type == 4 && $discounts["discount_uplevel"] == 1)
				|| ($type == 8 && $discounts["discount_appreciation"] == 1)){
				$user = new MemberModel();
				$user_id = session('user_id');
				$user_level = $user->get_user_level($user_id,18);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
		}
		$cloud_price = number_format(ceil((($cloud_cpu_price + $cloud_mem_price + $cloud_disk_price + $cloud_bandwidth_price) * $gmqx * $count) * $discount),2,".","");
		/** 调接口获取云服务器价格 */
		/*$api_config = WebSiteConfig(2);//获取网站配置
		$api_access = $api_config["api_access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$area_code = $data['dqbh'];
		$ptype = GD::PTYPE_CLOUD_SERVER;
		$tid = 33;
		$keytype = 1;
		$yid = $data['gmqx'];
		$cpucount = $data['cpu'];
		$memory = $data['mem'];
		$ssd = $data['disk'];
		$bandwidth = $data['bandwidth'];
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$log_message = "ptype:{$ptype}-tid:{$tid}-yid:{$yid}-keytype:{$keytype}-cpucount:{$cpucount}-memory:{$memory}-ssd:{$ssd}-bandwidth:{$bandwidth}-area_code:{$area_code}";
		try{
			$result = $transaction->get_cloudserver_price($ptype,$yid,$cpucount,$memory,$ssd,$bandwidth,$area_code);
			//api_log("-1",$log_message,$result,'获取快云服务器价格');
		}catch(\Exception $e){
			$result = $e->getMessage();
			api_log("-1",$log_message,$result,'获取快云服务器价格失败');
			return -9;
		}
		$info = json_decode($result,true);
		$discount = 1;
		if(session('?user_id')){
			$discounts = WebSiteConfig(8);
			if(($type == 1 && $discounts["discount_buy"] == 1)
				|| ($type == 3 && $discounts["discount_renew"] == 1)
				|| ($type == 11 && $discounts["discount_onformal"] == 1)
				|| ($type == 4 && $discounts["discount_uplevel"] == 1)
				|| ($type == 8 && $discounts["discount_appreciation"] == 1)){
				$user = new MemberModel();
				$user_id = session('user_id');
				$user_level = $user->get_user_level($user_id,18);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
		}
		$cloud_price = number_format(ceil(($info["info"]["price"]) * $discount),2,".","");*/
		return $cloud_price;
	}

	/**
	 * 计算快云服务器价格
	 * @date: 2016年11月25日 下午2:44:35
	 * @author: Lyubo
	 * @param $data
	 * @return string
	 */
	public function CalculatedPrice($data){
		$product = new ProductModel();
		$config = [
			"1" => ["disk" => "80","cpu" => "1","mem" => "1","bandwidth" => "2"],
			"2" => ["disk" => "120","cpu" => "2","mem" => "2","bandwidth" => "3"],
			"3" => ["disk" => "200","cpu" => "4","mem" => "4","bandwidth" => "5"],
			"4" => ["disk" => "300","cpu" => "8","mem" => "8","bandwidth" => "7"],
			"5" => ["disk" => "500","cpu" => "16","mem" => "16","bandwidth" => "10"]
		];
		if(MODULE_NAME == 'Frontend' && isMobile() == 'phone'){
			for($i = 1;$i < count($config);$i++){
				if($data['pzbh'] == $i){
					$data['disk'] = $config[$i]['disk'];
					$data['cpu'] = $config[$i]['cpu'];
					$data['mem'] = $config[$i]['mem'];
					$data['bandwidth'] = $config[$i]['bandwidth'];
				}
			}
		}
		/** 查询数据库计算云服务器价格 */
		$price_list = $product->get_cloud_price_list($data['dqbh']);
		if(empty($price_list)){
			return $cloud_price = 0;
		}
		$dqbh = $data['dqbh'];
		$gmqx = $data['gmqx']+0;
		$gmqx = $gmqx ? $gmqx : 1;
		$cpu = $data['cpu']+0;
		$mem = $data['mem']+0;
		$disk = ($data['disk']+0) / 10;
		$bandwidth = $data['bandwidth']+0;
		$bandwidth = $bandwidth < 0 ? 0 : $bandwidth;
		$cpu_price = 20;
		$mem_price = 25;
		$disk_price = 6;
		$bandwidth_price = 20;
		$bandwidth_price2 = 70;
		$type = $data['type'];
		//机房：4001:郑州机房，4002:香港机房，40015:郑州电信，40016:河南联通
		if($dqbh == '4001'){
			if($type == 4){
				$cpu = $cpu < 0 ? 0 : $cpu;
				$mem = $mem < 0 ? 0 : $mem;
				$disk = $disk < 0 ? 0 : $disk;
			}else{
				$cpu = $cpu < 1 ? 1 : $cpu;
				$mem = $mem < 1 ? 1 : $mem;
				$disk = $disk < 1 ? 1 : $disk;
			}
			foreach($price_list as $key=>$val){
				if($val["note_appended"] == "CPU"){
					$cpu_price = $val["product_price"];
				}elseif($val["note_appended"] == "内存"){
					$mem_price = $val["product_price"];
				}elseif($val["note_appended"] == "数据盘"){
					$disk_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽"){
					$bandwidth_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽大于5M"){
					$bandwidth_price2 = $val["product_price"];
				}
			}
			$cloud_cpu_price = $cpu_price * $cpu;
			$cloud_mem_price = $mem_price * $mem;
			$cloud_disk_price = $disk_price * $disk;
			if($bandwidth > 5){
				$cloud_bandwidth_price = $bandwidth_price2 * ($bandwidth - 5) + $bandwidth_price * 5;
			}else{
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth;
			}
		}elseif($dqbh == '4002'){
			if($type == 4){
				$cpu = $cpu < 0 ? 0 : $cpu;
				$mem = $mem < 0 ? 0 : $mem;
				$disk = $disk < 0 ? 0 : $disk;
			}else{
				$cpu = $cpu < 1 ? 1 : $cpu;
				$mem = $mem < 1 ? 1 : $mem;
				$disk = $disk < 1 ? 1 : $disk;
			}
			$cpu_price = 40;
			$disk_price = 8;
			$bandwidth_price = 25;
			$bandwidth_price2 = 90;
			foreach($price_list as $key=>$val){
				if($val["note_appended"] == "CPU"){
					$cpu_price = $val["product_price"];
				}elseif($val["note_appended"] == "内存"){
					$mem_price = $val["product_price"];
				}elseif($val["note_appended"] == "数据盘"){
					$disk_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽"){
					$bandwidth_price = $val["product_price"];
				}elseif($val["note_appended"] == "带宽大于5M"){
					$bandwidth_price2 = $val["product_price"];
				}
			}
			$cloud_cpu_price = $cpu_price * $cpu;
			$cloud_mem_price = $mem_price * $mem;
			$cloud_disk_price = $disk_price * $disk;
			if($bandwidth > 5){
				$cloud_bandwidth_price = $bandwidth_price2 * ($bandwidth - 5) + $bandwidth_price * 5;
			}else{
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth;
			}
		}elseif($dqbh == '40015' || $dqbh == '40016'){
			$cpu = $cpu < 8 ? 8 : $cpu;
			$mem = $mem < 16 ? 16 : $mem;
			$disk = $disk < 30 ? 30 : $disk;
			$bandwidth = $bandwidth < 100 ? 100 : $bandwidth;
			$cpu = $cpu - 8;
			$mem = $mem - 16;
			$disk = $disk - 30;
			$bandwidth = $bandwidth - 100;
			$cpu_price = 30;
			$bandwidth_price = 15;
			if($cpu == 0 && $mem == 0 && $disk == 0 && $bandwidth == 0){
				$cloud_cpu_price = 0;
				$cloud_mem_price = 0;
				$cloud_disk_price = 0;
				$cloud_bandwidth_price = 780;
			}else{
				foreach($price_list as $key=>$val){
					if($val["note_appended"] == "CPU"){
						$cpu_price = $val["product_price"];
					}elseif($val["note_appended"] == "内存"){
						$mem_price = $val["product_price"];
					}elseif($val["note_appended"] == "数据盘"){
						$disk_price = $val["product_price"];
					}elseif($val["note_appended"] == "带宽"){
						$bandwidth_price = $val["product_price"];
					}
				}
				$cloud_cpu_price = $cpu_price * $cpu;
				$cloud_mem_price = $mem_price * $mem;
				$cloud_disk_price = $disk_price * $disk;
				$cloud_bandwidth_price = $bandwidth_price * $bandwidth + 780;
			}
		}else{
			return $cloud_price = 0;
		}
		if($type == GD::TID_UPGRADE){
			//续费没有优惠
		}else{
			if($gmqx == 12){
				$gmqx = 10;
			}elseif($gmqx == 24){
				$gmqx = 20;
			}elseif($gmqx == 36){
				$gmqx = 30;
			}elseif($gmqx == 48){
				$gmqx = 40;
			}
		}
		$count = 1;
		$discount = 1;
		if(session('?user_id')){
			$discounts = WebSiteConfig(8);
			if(($type == 1 && $discounts["discount_buy"] == 1)
				|| ($type == 3 && $discounts["discount_renew"] == 1)
				|| ($type == 11 && $discounts["discount_onformal"] == 1)
				|| ($type == 4 && $discounts["discount_uplevel"] == 1)
				|| ($type == 8 && $discounts["discount_appreciation"] == 1)){
				$user = new MemberModel();
				$user_id = session('user_id');
				$user_level = $user->get_user_level($user_id,18);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
		}
		$cloud_price = number_format(ceil((($cloud_cpu_price + $cloud_mem_price + $cloud_disk_price + $cloud_bandwidth_price) * $gmqx * $count) * $discount),2,".","");
		return $cloud_price;
	}

	/**********************************************快云服务器购买******************************************/
	/**
	 * 购买快云服务器
	 * @date: 2016年11月26日 下午4:27:21
	 * @author: Lyubo
	 * @param $buy_info
	 * @return int
	 */
	public function cloudserver_buy($buy_info){
		$api_config = WebSiteConfig(2);//获取网站配置
		$api_access = $api_config["api_access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if($buy_info['dqbh'] == 4002 || $buy_info['dqbh'] == 4005){
			$api_access = $api_config["api_hk_access"] + 0;
			$api_access = $api_access ? $api_access : 6;
		}
		// 封装订单参数信息
		$datarray = array(
			"user_id" => $buy_info['member_id'],
			"order_quantity" => 1,
			"free_trial" => $buy_info['free_trial'],	// 购买或者试用
			"order_time" => $buy_info['gmqx'],
			"create_time" => date('Y-m-d H:i:s'),
			"complete_time" => date('Y-m-d H:i:s'),	// 完成时间
			"state" => SD::SUCCESS_ORDER,	// 订单状态成功
			"system_type" => $buy_info['os'],	//操作系统
			"area_code" => $buy_info['dqbh'],	//地区编号
			"access" => $api_access,
			"root_domain" => $buy_info["czxt"]
		);
		$buy_info["type"] = 1;
		//执行录入订单、购买方法
		$Order = new OrderModel();
		$order_id = $Order->cloud_order_do_entry($datarray,$buy_info,SD::NEW_ORDER);
		if($order_id < 0){//小于0就是错误返回信息
			return $order_id;
		}
		return $this->api_cloudserver_buy($order_id,$buy_info);
	}

	/**
	 * 快云服务器购买接口调用
	 * @date: 2016年11月26日 下午5:43:30
	 * @author: Lyubo
	 * @param $order_id
	 * @param $buy_info
	 * @return int
	 */
	public function api_cloudserver_buy($order_id,$buy_info){
		$Order = new OrderModel();
		$order_info = $Order->order_find($order_id);
		$system = WebSiteConfig(8);
		$user_id = $order_info['user_id'];
		$api_access = $order_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$is_article = $system["product_cloudserver_buy_article"];
		//传参
		$ptype = GD::PTYPE_CLOUD_SERVER;
		$tid = GD::TID_BUY;
		$cpucount = $buy_info['cpu'];
		$memory = $buy_info['mem'];
		$disk = $buy_info['disk'];
		$bandwidth = $buy_info['bandwidth'];
		$yid = $order_info['order_time'];
		$input_name = $buy_info['os'];
		$area_code = $order_info['area_code'];
		$usetype = $system["site_buy_cloud"] + 0;
		if($yid < 6){
			$is_article = "no";
		}
		if($order_info['free_trial'] == 0){//购买
			if($is_article == "yes"){
				$info = "ptype:".$ptype."-tid:71"."-cpucount:".$cpucount."-memory:".$memory."-disk:".$disk."-bandwidth:".$bandwidth."-yid:".$yid."-input_name:".$input_name."-area_code:".$area_code;
			}else{
				$info = "ptype:".$ptype."-tid:".$tid."-cpucount:".$cpucount."-memory:".$memory."-disk:".$disk."-bandwidth:".$bandwidth."-yid:".$yid."-input_name:".$input_name."-area_code:".$area_code."-usetype:".$usetype;
			}
			try{
				if($is_article == "yes"){
					$result = $transaction->cloudserver_buy_article($ptype,$order_info['order_time'],$area_code,$buy_info);
					api_log($user_id,$info,$result,$order_info['order_log']."-参加活动");
				}else{
					$result = $transaction->cloud_buy($ptype,$order_info['order_time'],$area_code,$buy_info,$usetype);
					api_log($user_id,$info,$result,$order_info['order_log']);
				}
			}catch(\Exception $e){
				// 调用接口试用失败修改订单表
				$dataarray = array(
					"complete_time" => date('Y-m-d H:i:s'),
					"order_log" => $order_info['order_log']."-接口调用错误",
					"area_code" => $order_info['area_code'],
					"state" => SD::FAILURE_ORDER  // 订单状态失败
				);
				$Order->order_edit($order_id,$dataarray);
				api_log($user_id,$info,$e->getMessage(),$order_info['order_log']);
				return -9;//接口调用失败
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] == 0 && $xstr['code'] !== null){
				$api_id = $xstr['info']['ywddh'];
				if($order_info['free_trial'] == 0){//购买
					$dataarray = array("api_id" => $api_id,"complete_time" => date('Y-m-d H:i:s'),"state" => SD::PAYMENT_ORDER);
				}else{
					$dataarray = array("api_id" => $api_id,"complete_time" => date('Y-m-d H:i:s'),"state" => SD::EXAMINE_ORDER);
				}
				// 修改订单表
				if($Order->order_edit($order_id,$dataarray)){
					return -1;
				}else{
					$dataarray = array("api_id" =>$api_id,"complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用成功，订单表修改失败");
					$Order->order_edit($order_id,$dataarray);
					return -7; // 订单表修改失败
				}
			}elseif($xstr['code'] == 8020){
				$info = "ptype:".$ptype."-tid:".$tid."-cpucount:".$cpucount."-memory:".$memory."-disk:".$disk."-bandwidth:".$bandwidth."-yid:".$yid."-input_name:".$input_name."-area_code:".$area_code."-usetype:".$usetype;
				try{
					$result = $transaction->cloud_buy($ptype,$order_info['order_time'],$area_code,$buy_info,$usetype);
					api_log($user_id,$info,$result,$order_info['order_log']);
				}catch(\Exception $e){
					// 调用接口试用失败修改订单表
					$dataarray = array(
						"complete_time" => date('Y-m-d H:i:s'),
						"order_log" => $order_info['order_log']."-接口调用错误",
						"area_code" => $order_info['area_code'],
						"state" => SD::FAILURE_ORDER  // 订单状态失败
					);
					$Order->order_edit($order_id,$dataarray);
					api_log($user_id,$info,$e->getMessage(),$order_info['order_log']);
					return -9;//接口调用失败
				}
				$xstr = json_decode($result,true);
				if($xstr['code'] == 0 && $xstr['code'] !== null){
					if($order_info['free_trial'] == 0){//购买
						$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"state" => SD::PAYMENT_ORDER);
					}else{
						$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"state" => SD::EXAMINE_ORDER);
					}
					// 修改订单表
					if($Order->order_edit($order_id,$dataarray)){
						return -1;
					}else{
						$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用成功，订单表修改失败");
						$Order->order_edit($order_id,$dataarray);
						return -7; // 订单表修改失败
					}
				}else{
					// 调用接口试用失败修改订单表
					$dataarray = array("complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用错误","state" => SD::FAILURE_ORDER);
					$Order->order_edit($order_id,$dataarray);
					// 修改订单表
					return $xstr['code'];
				}
			}else{
				// 调用接口试用失败修改订单表
				$dataarray = array("complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用错误","state" => SD::FAILURE_ORDER);
				$Order->order_edit($order_id,$dataarray);
				// 修改订单表
				return $xstr['code'];
			}
		}else{//试用
			$tid = GD::TID_TRY;
			$info = "ptype:".$ptype."-tid:".$tid."-cpucount:".$cpucount."-memory:".$memory."-disk:".$disk."-bandwidth:".$bandwidth."-input_name:".$input_name."-area_code:".$area_code;
			try{
				$result = $transaction->cloud_try($ptype,$area_code,$buy_info);
				api_log($user_id,$info,$result,$order_info['order_log']);
			}catch(\Exception $e){
				// 调用接口试用失败修改订单表
				$dataarray = array(
					"complete_time" => date('Y-m-d H:i:s'),
					"order_log" => $order_info['order_log']."-接口调用错误",
					"area_code" => $order_info['area_code'],
					"state" => SD::FAILURE_ORDER  // 订单状态失败
				);
				$Order->order_edit($order_id,$dataarray);
				api_log($user_id,$info,$e->getMessage(),$order_info['order_log']);
				return -9;//接口调用失败
			}
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			if($order_info['free_trial'] == 0){//购买
				$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"state" => SD::PAYMENT_ORDER);
			}else{
				$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"state" => SD::EXAMINE_ORDER);
			}
			// 修改订单表
			if($Order->order_edit($order_id,$dataarray)){
				return -1;
			}else{
				$dataarray = array("api_id" => $xstr['info']['ywddh'],"complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用成功，订单表修改失败");
				$Order->order_edit($order_id,$dataarray);
				return -7; // 订单表修改失败
			}
		}else{
			// 调用接口试用失败修改订单表
			$dataarray = array("complete_time" => date('Y-m-d H:i:s'),"order_log" => $order_info['order_log']."-接口调用错误","state" => SD::FAILURE_ORDER);
			$Order->order_edit($order_id,$dataarray);
			// 修改订单表
			return $xstr['code'];
		}
	}

	/**
	 * 快云服务器开通
	 * @date: 2016年12月1日 上午10:06:39
	 * @author: Lyubo
	 * @param $order_id
	 * @param $uid
	 * @param $password
	 * @return array|string
	 */
	public function cloudserver_open($order_id,$uid,$password){
		$Order = new OrderModel();
		$product = new ProductModel();
		$result_inf = array();
		$order_info = $Order->order_find($order_id);
		$api_access = $order_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if(!$order_info){
			$result_inf['code'] = -13; // 订单不存在或订单状态错误
			return $result_inf;
		}
		if($order_info['state'] != SD::PAYMENT_ORDER){
			if($order_info['state'] == SD::SUCCESS_ORDER){
				$result_inf['code'] = -124; // 该订单已经开通
				return $result_inf;
			}
			if($order_info['state'] == SD::FAILURE_ORDER){
				$result_inf['code'] = -125; // 订单开通失败
				return $result_inf;
			}
		}
		if($order_info['user_id'] != $uid){
			$result_inf['code'] = -101;
			return $result_inf;
		}
		// 获取订单产品信息
		$pinfo = $product->get_product('214');//快云服务器默认214
		if(!$pinfo){
			$result_inf['code'] = -2;
			return $result_inf;
		}
		/* if($order_info['api_ip_id'] == '0'){//快云服务器订单
			$order_info['api_ip_id'] = $order_info['api_bid'];
		} */
		//快云服务器业务表
		$cloudserver = array(
			"user_id" => $uid,
			"login_name" => $order_info['login_name'],
			"product_id" => $pinfo['id'],
			"product_name" => $pinfo['product_name'],
			"create_time" => current_date(),
			"buy_time" => $order_info['order_time'],
			"free_trial" => $order_info['free_trial'],
			"cloudserver_user" => "administrator",
			"cloudhost_password" => $password,
			"des" => "快云服务器描述",
			"state" => SD::NOTGET,
			"api_bid" => $order_info['api_id'],
			"mail_state" => "0",
			"area_code" => $order_info['area_code'],
			"beizhu" => null,
			"access" => $api_access
		);
		if(!$this->add($cloudserver)){
			return -103;
		}else{
			$business_id = $this->getLastInsID(); // 获取最后插入ID
		}
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->cloudserver_open($pinfo['api_ptype'],$order_info['api_id'],$password);
			api_log($uid,"ptype:".$pinfo['api_ptype']."--did:".$order_info['api_id']."--tid:".GD::TID_OPEN."--password".$password,$result,$cloudserver['note_appended']);
		}catch(\Exception $e){
			$del_where['id'] = $business_id;
			$this->where($del_where)->delete();
			$result_inf['code'] = -9;
			api_log($uid,"ptype:".$pinfo['api_ptype']."--did:".$order_info['api_id']."--tid:".GD::TID_OPEN."--password".$password,$e->getMessage(),$cloudserver['note_appended']);
			return $result_inf;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] == 0 && $xstr["code"] !== null){
			$buss_arr = array(
				"cloudserver_user" => $xstr["info"]["user"],
				"cloudhost_password" => $xstr["info"]["pwd"],
				"port" => $xstr["info"]["remoteport"],
				"create_time" => $xstr["info"]["createDate"],
				"overdue_time" => $xstr["info"]["overDate"],
				"api_bid" => $xstr["info"]["bid"],
				"nw_ip" => $xstr["info"]["ip"],
				"state" => SD::SUCCESS
			);
			if($this->where(["id"=>$business_id])->save($buss_arr)){
				$yw_id = $xstr["info"]["bid"];
				$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($this);
				$tongbu = $cloudserverRespository->CloudserverBusinessSynchronizing($yw_id);
				// 修改订单表订单标识，业务编号
				$arr = array(
					"business_id" => $business_id,
					"complete_time" => current_date(),
					"state" => SD::SUCCESS_ORDER,
					"order_log" => "开通成功"
				);
				if($Order->order_edit($order_id,$arr) !== false){
					$result_inf['code'] = "-1";
					$result_inf['api_did'] = $order_info['api_id'];
					return $result_inf;
				}else{
					// 修改订单表状态
					$Order->order_edit($order_id,["state" => SD::SUCCESS_ORDER,"order_log" => "业务开通成功，订单表修改失败。"]);
					return $result_inf['code'] = "-104"; // 业务执行成功，业务表修改失败
				}
			}else{
				// 修改订单表订单标识，业务编号
				$arr = array(
					"business_id" => $business_id,
					"complete_time" => current_date(),
					"state" => SD::SUCCESS_ORDER,
					"order_log" => "业务正在队列开通,请到业务列表等待获取业务信息"
				);
				if($Order->order_edit($order_id,$arr) !== false){
					$result_inf['code'] = "-1";
					$result_inf['api_did'] = $order_info['api_id'];
					return $result_inf;
				}else{
					// 修改订单表状态
					$Order->order_edit($order_id,["state" => SD::HANDLE_ORDER,"order_log" => "业务开通成功，订单表修改失败。"]);
					return $result_inf['code'] = "-104"; // 业务执行成功，订单表修改失败
				}
			}
		}else{
			$del_where['id'] = $business_id;
			$this->where($del_where)->delete();
			$result_inf['code'] = $xstr['code'];
			$result_inf['api_did'] = $order_info['api_id'];
			return $result_inf;
		}
	}

	/**
	 * 快云服务器测试码开通
	 * @date: 2016年12月1日 上午10:06:39
	 * @author: Lyubo
	 * @param $order_id
	 * @param $uid
	 * @param $password
	 * @return array|string
	 */
	public function cs_code_open($order_id,$uid,$password,$code){
		$Order = new OrderModel();
		$product = new ProductModel();
		$result_inf = array();
		$order_info = $Order->order_find($order_id);
		$api_access = $order_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if(!$order_info){
			$result_inf['code'] = -13; // 订单不存在或订单状态错误
			return $result_inf;
		}
		if($order_info['state'] != SD::PAYMENT_ORDER){
			if($order_info['state'] == SD::SUCCESS_ORDER){
				$result_inf['code'] = -124; // 该订单已经开通
				return $result_inf;
			}
			if($order_info['state'] == SD::FAILURE_ORDER){
				$result_inf['code'] = -125; // 订单开通失败
				return $result_inf;
			}
		}
		if($order_info['free_trial'] <= 0){
			$result_inf['code'] = -127;
			return $result_inf;
		}
		if($order_info['user_id'] != $uid){
			$result_inf['code'] = -101;
			return $result_inf;
		}
		// 获取订单产品信息
		$pinfo = $product->get_product('214');//快云服务器默认214
		if(!$pinfo){
			$result_inf['code'] = -2;
			return $result_inf;
		}
		/* if($order_info['api_ip_id'] == '0'){//快云服务器订单
			$order_info['api_ip_id'] = $order_info['api_bid'];
		} */
		//快云服务器业务表
		$cloudserver = array(
			"user_id" => $uid,
			"login_name" => $order_info['login_name'],
			"product_id" => $pinfo['id'],
			"product_name" => $pinfo['product_name'],
			"create_time" => current_date(),
			"buy_time" => $order_info['order_time'],
			"free_trial" => $order_info['free_trial'],
			"cloudserver_user" => "administrator",
			"cloudhost_password" => $password,
			"des" => "快云服务器描述",
			"state" => SD::NOTGET,
			"api_bid" => $order_info['api_id'],
			"mail_state" => "0",
			"area_code" => $order_info['area_code'],
			"beizhu" => null,
			"access" => $api_access
		);
		if(!$this->add($cloudserver)){
			return -103;
		}else{
			$business_id = $this->getLastInsID(); // 获取最后插入ID
		}
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$ptype = $pinfo['api_ptype'];
		$did = $order_info['api_id'];
		$testCode = $code;
		$tid = 50;
		$info = "ptype:".$ptype."-did:".$did."-tid:50-password:".$password."-testCode:".$testCode;
		try{
			$result = $transaction->cloudserver_code_open($ptype,$did,$password,$testCode);
			api_log($uid,$info,$result,$cloudserver['note_appended']);
		}catch(\Exception $e){
			$del_where['id'] = $business_id;
			$this->where($del_where)->delete();
			$result_inf['code'] = -9;
			api_log($uid,$info,$e->getMessage(),$cloudserver['note_appended']);
			return $result_inf;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] == 0 && $xstr["code"] !== null){
			$buss_arr = array(
				"cloudserver_user" => $xstr["info"]["user"],
				"cloudhost_password" => $xstr["info"]["pwd"],
				"port" => $xstr["info"]["remoteport"],
				"create_time" => $xstr["info"]["createDate"],
				"overdue_time" => $xstr["info"]["overDate"],
				"api_bid" => $xstr["info"]["bid"],
				"nw_ip" => $xstr["info"]["ip"],
				"state" => SD::SUCCESS
			);
			if($this->where(["id"=>$business_id])->save($buss_arr)){
				$yw_id = $xstr["info"]["bid"];
				$cloudserverRespository = new \Common\Respository\CloudserverBusinessRespository($this);
				$tongbu = $cloudserverRespository->CloudserverBusinessSynchronizing($yw_id);
				// 修改订单表订单标识，业务编号
				$arr = array(
					"business_id" => $business_id,
					"complete_time" => current_date(),
					"state" => SD::SUCCESS_ORDER,
					"order_log" => "开通成功"
				);
				if($Order->order_edit($order_id,$arr) !== false){
					$result_inf['code'] = "-1";
					$result_inf['api_did'] = $order_info['api_id'];
					return $result_inf;
				}else{
					// 修改订单表状态
					$Order->order_edit($order_id,["state" => SD::SUCCESS_ORDER,"order_log" => "业务开通成功，订单表修改失败。"]);
					return $result_inf['code'] = "-104"; // 业务执行成功，业务表修改失败
				}
			}else{
				// 修改订单表订单标识，业务编号
				$arr = array(
					"business_id" => $business_id,
					"complete_time" => current_date(),
					"state" => SD::SUCCESS_ORDER,
					"order_log" => "业务正在队列开通,请到业务列表等待获取业务信息"
				);
				if($Order->order_edit($order_id,$arr) !== false){
					$result_inf['code'] = "-1";
					$result_inf['api_did'] = $order_info['api_id'];
					return $result_inf;
				}else{
					// 修改订单表状态
					$Order->order_edit($order_id,["state" => SD::HANDLE_ORDER,"order_log" => "业务开通成功，订单表修改失败。"]);
					return $result_inf['code'] = "-104"; // 业务执行成功，订单表修改失败
				}
			}
		}else{
			$del_where['id'] = $business_id;
			$this->where($del_where)->delete();
			$result_inf['code'] = $xstr['code'];
			$result_inf['api_did'] = $order_info['api_id'];
			return $result_inf;
		}
	}

	/**
	 * 快云服务器续费
	 * @date: 2016年12月4日 下午4:31:06
	 * @author: Lyubo
	 * @param $cs_id
	 * @param $uid
	 * @param $renewalstime
	 * @return int
	 */
	public function cloudserver_renewals($cs_id,$uid,$renewalstime){
		$Order = new OrderModel();
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cloudserver_server_where['id'] = ["eq",$cs_id];
		$cloudserver_info = $this->where($cloudserver_server_where)->find();
		$api_access = $cloudserver_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if($cloudserver_info['ip_state'] == 0 && $cloudserver_info['ip_bid'] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cloudserver_info['ip_bid']];
			$cloudserverip_info = $ip->where($ip_where)->find();
			$cloudserver_info['ipaddress'] = $cloudserverip_info['ipaddress'];
		}
		if(!$cloudserver_info || $cloudserver_info['user_id'] != $uid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cloudserver_info['state'] != SD::SUCCESS && $cloudserver_info['state'] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cloudserver_info['free_trial'] != 0){
			return -100; // 试用业务不能续费
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cloudserver_info['product_id']);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		if(!in_array($renewalstime,array(1,12,24,36,48))){
			return -128;
		}
		$cloudserver_info['mem'] = $cloudserver_info['memory'] / 1024;
		$cloudserver_info['bandwidth'] = $cloudserverip_info['bandwidth'];
		$cloudserver_info['type'] = GD::TID_RENEWALS;
		$cloudserver_info['dqbh'] = $cloudserver_info['area_code'];
		$cloudserver_info['gmqx'] = $renewalstime;
		// 生成订单表
		// 封装订单表数据
		$dataarray = array(
			"user_id" => $uid,
			"order_type" => SD::RENEWALS_ORDER, // 续费
			"state" => SD::FAILURE_ORDER,
			"ip_address" => $cloudserver_info['ipaddress'],
			"product_type" => $pinfo['product_type_id'],
			"product_id" => $pinfo['id'],
			"product_name" => $pinfo['product_name'],
			"free_trial" => 0, // 不是试用
			"order_time" => $renewalstime, // 续费12个月
			"order_quantity" => 1,
			"business_id" => $cloudserver_info['id'],
			"create_time" => current_date(),
			"area_code" => $cloudserver_info['area_code'], // 4001国内4002香港
			"login_name" => $cloudserver_info['login_name'],
			"complete_time" => current_date(),"access" => $api_access
		);
		$cloudserver_info['member_id'] = $uid;
		$order_id = $Order->cloud_order_do_entry($dataarray,$cloudserver_info,SD::RENEWALS_ORDER);
		if($order_id <= 0){
			return $order_id;
		}
		// 获取订单详情
		$order_info = $Order->order_find($order_id);
		$system = WebSiteConfig(8);
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$is_article = $system["product_cloudserver_renewals_article"];
		//传参
		$ptype = $pinfo['api_ptype'];
		$tid = GD::TID_RENEWALS;
		$pname = GD::PNAME_CLOUDSERVER_SERVER;
		$bid = $cloudserver_info['api_bid'];
		$yid = $renewalstime;
		$usetype = $system["site_buy_cloud"] + 0;
		if($yid < 6){
			$is_article = "no";
		}
		if($is_article == "yes"){
			$info = "ptype:".$ptype."-tid:73"."-bid:".$bid."-yid:".$yid;
		}else{
			$info = "ptype:".$ptype."-tid:".$tid."-pname:".$pname."-bid:".$bid."-yid:".$yid."-usetype:".$usetype;
		}
		try{
			if($is_article == "yes"){
				$result = $transaction->cloudserver_renewals_article($ptype,$bid,$yid);
				api_log($uid,$info,$result,"会员".$uid."续费".$pinfo['product_name']);
			}else{
				$result = $transaction->cloudserver_renewals($ptype,$pname,$bid,$yid,$usetype);
				api_log($uid,$info,$result,"会员".$uid."续费".$pinfo['product_name']);
			}
		}catch(\Exception $e){
			$dataarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"api_id" => $cloudserver_info['api_bid'],
				"order_log" => $order_info['order_log']."--接口调用失败"
			);
			$Order->order_edit($order_id,$dataarray);
			api_log($uid,$info,$e->getMessage(),"会员".$uid."续费".$pinfo['product_name']."失败");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] === 0){
			// 续费成功，修改业务表信息
			$overdue_time = $xstr['info']['overtime'];
			$dataarray = array("overdue_time" =>$overdue_time,'buy_time' => ($cloudserver_info['buy_time'] + $renewalstime));
			$up_cloudserver_where['id'] = ["eq",$cs_id];
			if($this->where($up_cloudserver_where)->save($dataarray) !== false){
				// 业务表修改成功，修改订单表
				$dataarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"api_id" => $cloudserver_info['id'],
					"order_log" => $order_info['order_log']."--续费成功"
				);
				$Order->order_edit($order_id,$dataarray);
				if(!empty($cloudserverip_info)){
					$arr = array("overdue_time" =>$overdue_time,'buy_time' => $cloudserverip_info['buy_time'] + $renewalstime);
					$up_ip_where['id'] = ["eq",$cloudserverip_info['id']];
					if($ip->where($up_ip_where)->save($arr) === false){
						return -12;
					}
				}
				return -1; // 续费成功
			}
		}elseif($xstr["code"] == 8020){
			$info = "ptype:".$ptype."-tid:".$tid."-pname:".$pname."-bid:".$bid."-yid:".$yid."-usetype:".$usetype;
			try{
				$result = $transaction->cloudserver_renewals($ptype,$pname,$bid,$yid,$usetype);
				api_log($uid,$info,$result,"会员".$uid."续费".$pinfo['product_name']);
			}catch(\Exception $e){
				$dataarray = array(
					"state" => SD::FAILURE_ORDER, // 订单状态失败
					"complete_time" => current_date(),
					"api_id" => $cloudserver_info['api_bid'],
					"order_log" => $order_info['order_log']."--接口调用失败"
				);
				$Order->order_edit($order_id,$dataarray);
				api_log($uid,$info,$e->getMessage(),"会员".$uid."续费".$pinfo['product_name']."失败");
				return -9;
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] === 0){
				// 续费成功，修改业务表信息
				$overdue_time = $xstr['info']['overtime'];
				$dataarray = array("overdue_time" =>$overdue_time,'buy_time' => ($cloudserver_info['buy_time'] + $renewalstime));
				$up_cloudserver_where['id'] = ["eq",$cs_id];
				if($this->where($up_cloudserver_where)->save($dataarray) !== false){
					// 业务表修改成功，修改订单表
					$dataarray = array(
						"state" => SD::SUCCESS_ORDER,
						"complete_time" => current_date(),
						"api_id" => $cloudserver_info['id'],
						"order_log" => $order_info['order_log']."--续费成功"
					);
					$Order->order_edit($order_id,$dataarray);
					if(!empty($cloudserverip_info)){
						$arr = array("overdue_time" =>$overdue_time,'buy_time' => $cloudserverip_info['buy_time'] + $renewalstime);
						$up_ip_where['id'] = ["eq",$cloudserverip_info['id']];
						if($ip->where($up_ip_where)->save($arr) === false){
							return -12;
						}
					}
					return -1; // 续费成功
				}
			}else{
				return $xstr['code'];
			}
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 快云服务器转正展示
	 * @date: 2018年4月27日18:22:02
	 * @author: Guopeng
	 */
	public function show_cs_onformal($mid,$cs_id){
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cs_where['id'] = ["eq",$cs_id];
		$cs_info = $this->where($cs_where)->find();
		if($cs_info['ip_state'] == 0 && $cs_info['ip_bid'] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cs_info['ip_bid']];
			$csip_info = $ip->where($ip_where)->find();
			$cs_info['ipaddress'] = $csip_info['ipaddress'];
		}
		if(!$cs_info || $cs_info['user_id'] != $mid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cs_info['state'] != SD::SUCCESS && $cs_info['state'] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cs_info['free_trial'] == 0){
			return - 114; //不是试用业务，无需转正
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cs_info['product_id']);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		$cs_info['mem'] = $cs_info['memory'] / 1024;
		$cs_info['bandwidth'] = $csip_info['bandwidth'];
		$cs_info['type'] = GD::TID_POSITIVE;
		$cs_info['dqbh'] = $cs_info['area_code'];
		$cs_info['gmqx'] = 1;
		$cloud_price_one = $this->CalculatedPrice($cs_info);
		$cs_info['gmqx'] = 12;
		$cloud_price_Twelve = $this->CalculatedPrice($cs_info);
		/*获取购买期限*/
		//获取续费信息
		$renewals_info[0] = array(
			'product_name' => $cs_info['product_name'],
			'id' => $cs_info['id'],
			'month' => 1,
			'product_price' => $cloud_price_one
		);
		$renewals_info[1] = array(
			'product_name' => $cs_info['product_name'],
			'id' => $cs_info['id'],
			'month' => 12,
			'product_price' => $cloud_price_Twelve
		);
		$total_price[0] = array('price' => $cloud_price_one,'month' => 1);
		$total_price[1] = array('price' => $cloud_price_Twelve,'month' => 12);
		return array_merge($cs_info,array('price_info' => $renewals_info,'total_price' => $total_price)); // 返回该业务详细信息和续费金额给确认续费页面
	}

	/**
	 * 快云服务器转正
	 * @date: 2018年4月27日18:22:02
	 * @author: Guopeng
	 * @param $cs_id
	 * @param $mid
	 * @param $onformal_time
	 * @return int
	 */
	public function cs_onformal($cs_id,$mid,$onformal_time){
		$system = WebSiteConfig(8);
		$is_article = $system["product_cloudserver_onformal_article"];
		$Order = new OrderModel();
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cs_server_where['id'] = ["eq",$cs_id];
		$cs_info = $this->where($cs_server_where)->find();
		$api_access = $cs_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if($cs_info['ip_state'] == 0 && $cs_info['ip_bid'] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cs_info['ip_bid']];
			$csip_info = $ip->where($ip_where)->find();
			$cs_info['ipaddress'] = $csip_info['ipaddress'];
		}
		if(!$cs_info || $cs_info['user_id'] != $mid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cs_info['state'] != SD::SUCCESS && $cs_info['state'] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cs_info['free_trial'] == 0){
			return - 114; //不是试用业务，无需转正
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cs_info['product_id']);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		$cs_info['mem'] = $cs_info['memory'] / 1024;
		$cs_info['bandwidth'] = $csip_info['bandwidth'];
		$cs_info['type'] = GD::TID_POSITIVE;
		$cs_info['dqbh'] = $cs_info['area_code'];
		$cs_info['gmqx'] = $onformal_time;
		// 生成订单表
		// 封装订单表数据
		$dataarray = array(
			"user_id" => $mid,
			"order_type" => SD::ONFORMAL_ORDER, //转正
			"state" => SD::FAILURE_ORDER,
			"ip_address" => $cs_info['ipaddress'],
			"product_type" => $pinfo['product_type_id'],
			"product_id" => $pinfo['id'],
			"product_name" => $pinfo['product_name'],
			"free_trial" => 1, //试用转正
			"order_time" => $onformal_time, //转正时间
			"order_quantity" => 1,
			"business_id" => $cs_info['id'],
			"create_time" => current_date(),
			"area_code" => $cs_info['area_code'], // 4001国内4002香港
			"login_name" => $cs_info['login_name'],
			"complete_time" => current_date(),
			"access" => $api_access
		);
		$cs_info['member_id'] = $mid;
		$order_id = $Order->cloud_order_do_entry($dataarray,$cs_info,SD::ONFORMAL_ORDER);
		if($order_id <= 0){
			return $order_id;
		}
		// 获取订单详情
		$order_info = $Order->order_find($order_id);
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = $pinfo['api_ptype'];
		$tid = GD::TID_RENEWALS;
		$pname = GD::PNAME_CLOUDSERVER_SERVER;
		$bid = $cs_info['api_bid'];
		$yid = $onformal_time;
		$usetype = $system["site_buy_cloud"] + 0;
		if($yid < 6){
			$is_article = "no";
		}
		if($is_article == "yes"){
			$info = "ptype:{$ptype}-tid:73-bid:{$bid}-yid:{$yid}-access:{$api_access}";
		}else{
			$info = "ptype:{$ptype}-tid:{$tid}-bid:{$bid}-yid:{$yid}-access:{$api_access}";
		}
		try{
			if($is_article == "yes"){
				$result = $transaction->cloudserver_onformal_article($ptype,$bid,$yid);
				api_log($mid,$info,$result,$pinfo['product_name']."转正:");
			}else{
				$result = $transaction->cloudserver_onformal($ptype,$bid,$yid);
				api_log($mid,$info,$result,$pinfo['product_name']."转正:");
			}
		}catch(\Exception $e){
			$dataarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"api_id" => $cs_info['api_bid'],
				"order_log" => $order_info['order_log']."--接口调用失败"
			);
			$Order->order_edit($order_id,$dataarray);
			api_log($mid,$info,$e->getMessage(),$pinfo['product_name']."转正失败");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] === 0){
			// 转正成功，修改业务表信息
			$overdue_time  = $xstr['info']['dqsj'];
			$dataarray = array(
				"overdue_time" => $overdue_time,
				"buy_time" => ($cs_info['buy_time'] + $onformal_time),
				"free_trial" => 0
			);
			$up_cloudserver_where['id'] = ["eq",$cs_id];
			if($this->where($up_cloudserver_where)->save($dataarray) !== false){
				// 业务表修改成功，修改订单表
				$dataarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"api_id" => $cs_info['id'],
					"order_log" => $order_info['order_log']."--转正成功"
				);
				$Order->order_edit($order_id,$dataarray);
				if(!empty($csip_info)){
					$arr = array(
						"overdue_time" => $overdue_time,
						"buy_time" => $csip_info['buy_time'] + $onformal_time,
						"free_trial"=> 0
					);
					$up_ip_where['id'] = ["eq",$csip_info['id']];
					if($ip->where($up_ip_where)->save($arr) === false){
						return -12;
					}
				}
				return -1; // 转正成功
			}
		}elseif($xstr['code'] == 8020){
			$info = "ptype:".$ptype."-tid:".$tid."-bid:".$bid."-yid:".$yid;
			try{
				$result = $transaction->cloudserver_onformal($pname,$bid,$yid);
				api_log($mid,$info,$result,$pinfo['product_name']."转正");
			}catch(\Exception $e){
				$dataarray = array(
					"state" => SD::FAILURE_ORDER, // 订单状态失败
					"complete_time" => current_date(),
					"api_id" => $cs_info['api_bid'],
					"order_log" => $order_info['order_log']."--接口调用失败"
				);
				$Order->order_edit($order_id,$dataarray);
				api_log($mid,$info,$e->getMessage(),$pinfo['product_name']."转正失败");
				return -9;
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] === 0){
				// 转正成功，修改业务表信息
				$overdue_time  = $xstr['info']['dqsj'];
				$dataarray = array(
					"overdue_time" => $overdue_time,
					"buy_time" => ($cs_info['buy_time'] + $onformal_time),
					"free_trial" => 0
				);
				$up_cloudserver_where['id'] = ["eq",$cs_id];
				if($this->where($up_cloudserver_where)->save($dataarray) !== false){
					// 业务表修改成功，修改订单表
					$dataarray = array(
						"state" => SD::SUCCESS_ORDER,
						"complete_time" => current_date(),
						"api_id" => $cs_info['id'],
						"order_log" => $order_info['order_log']."--转正成功"
					);
					$Order->order_edit($order_id,$dataarray);
					if(!empty($csip_info)){
						$arr = array(
							"overdue_time" => $overdue_time,
							"buy_time" => $csip_info['buy_time'] + $onformal_time,
							"free_trial"=> 0
						);
						$up_ip_where['id'] = ["eq",$csip_info['id']];
						if($ip->where($up_ip_where)->save($arr) === false){
							return -12;
						}
					}
					return -1; // 转正成功
				}
			}else{
				return $xstr['code'];
			}
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 快云服务器升级展示
	 * @date: 2018年4月27日13:51:04
	 * @author: Guopeng
	 * @param $uid
	 * @param $cs_id
	 * @return array|int
	 */
	public function show_cs_uplevel($uid,$cs_id){
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cs_server_where['id'] = ["eq",$cs_id];
		$cs_info = $this->where($cs_server_where)->find();
		if($cs_info['ip_state'] == 0 && $cs_info['ip_bid'] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cs_info['ip_bid']];
			$csip_info = $ip->where($ip_where)->find();
			$cs_info['ipaddress'] = $csip_info['ipaddress'];
		}
		if(!$cs_info || $cs_info['user_id'] != $uid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cs_info['state'] != SD::SUCCESS && $cs_info['state'] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cs_info['free_trial'] != 0){
			return -100; // 试用业务不能升级
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cs_info['product_id']);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		$cs_info['mem'] = $cs_info['memory'] / 1024;
		$cs_info['bandwidth'] = $csip_info['bandwidth'];
		$cs_info['type'] = GD::TID_RENEWALS;
		$cs_info['dqbh'] = $cs_info['area_code'];
		/*获取剩余期限*/
		$cs_info["month"] = app_month($cs_info["overdue_time"]);
		return array_merge($cs_info); // 返回该业务详细信息和续费金额给确认续费页面
	}

	/**
	 * 快云服务器升级
	 * @date: 2018年4月27日13:51:04
	 * @author: Guopeng
	 * @param $cs_id
	 * @param $uid
	 * @param $data
	 * @return int
	 */
	public function cs_uplevel($cs_id,$uid,$data){
		$Order = new OrderModel();
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cs_server_where['id'] = ["eq",$cs_id];
		$cs_server_where['user_id'] = ["eq",$uid];
		$cs_info = $this->where($cs_server_where)->find();
		$api_access = $cs_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if($cs_info['ip_state'] == 0 && $cs_info['ip_bid'] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cs_info['ip_bid']];
			$csip_info = $ip->where($ip_where)->find();
			$cs_info['ipaddress'] = $csip_info['ipaddress'];
		}
		if(!$cs_info || $cs_info['user_id'] != $uid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cs_info['state'] != SD::SUCCESS && $cs_info['state'] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cs_info['free_trial'] != 0){
			return -100; // 试用业务不能升级
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cs_info['product_id']);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		$cs_info['mem'] = $cs_info['memory'] / 1024;
		$cs_info['bandwidth'] = $csip_info['bandwidth'];
		$cs_info['type'] = GD::TID_UPGRADE;
		$cs_info['dqbh'] = $cs_info['area_code'];
		$cs_info["month"] = app_month($cs_info["overdue_time"]);
		if($data["disk"] < $cs_info['disk'] || $data["memsize"] < $cs_info['mem'] || $data["cpu"] < $cs_info['cpu']){
			return -123; // 升级参数错误
		}
		if($data["disk"] == $cs_info['disk'] && $data["memsize"] == $cs_info['mem'] && $data["cpu"] == $cs_info['cpu']){
			return -123; // 升级参数错误
		}
		//升级参数
		$cs_buy_info['mem'] = $data["memsize"] - $cs_info['memory'] / 1024;
		$cs_buy_info['cpu'] = $data["cpu"] - $cs_info["cpu"];
		$cs_buy_info['disk'] = $data["disk"] - $cs_info["disk"];
		$cs_buy_info['bandwidth'] = 0;
		$cs_buy_info['type'] = GD::TID_UPGRADE;
		$cs_buy_info['dqbh'] = $cs_info['area_code'];
		$cs_buy_info['gmqx'] = $cs_info["month"];
		$cs_buy_info['member_id'] = $uid;
		// 生成订单表
		// 封装订单表数据
		$dataarray = array(
			"user_id" => $uid,
			"order_type" => SD::CHANGE_ORDER, //升级
			"state" => SD::FAILURE_ORDER,
			"ip_address" => $cs_info['ipaddress'],
			"product_type" => $pinfo['product_type_id'],
			"product_id" => $pinfo['id'],
			"product_name" => $pinfo['product_name'],
			"free_trial" => 0, // 不是试用
			"order_time" => $cs_info["month"], // 升级
			"order_quantity" => 1,
			"business_id" => $cs_info['id'],
			"create_time" => current_date(),
			"area_code" => $cs_info['area_code'], // 4001国内4002香港
			"login_name" => $cs_info['login_name'],
			"complete_time" => current_date(),
			"access" => $api_access
		);
		$order_id = $Order->cloud_order_do_entry($dataarray,$cs_buy_info,SD::CHANGE_ORDER);
		if($order_id <= 0){
			return $order_id;
		}
		// 获取订单详情
		$order_info = $Order->order_find($order_id);
		$system = WebSiteConfig(8);
		$usetype = $system["site_buy_cloud"];
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$ptype = $pinfo['api_ptype'];
		$pname = GD::PNAME_CLOUDSERVER_SERVER;
		$tid = GD::TID_UPGRADE;
		$bid = $cs_info['api_bid'];
		$cpucount = $data['cpu'];
		$memory = $data['memsize'];
		$disk = $data['disk'];
		$usetype = $usetype+0;
		$log = "ptype:".$ptype."-pname:".$pname."-tid:".$tid."-bid:".$bid."-cpucount:".$cpucount."-memory:".$memory."-disk:".$disk."-usetype:".$usetype;
		try{
			$result = $transaction->cloudserver_upgrade($ptype,$pname,$bid,$data,$usetype);
			api_log($uid,$log,$result,"会员".$uid."升级".$pinfo['product_name']);
		}catch(\Exception $e){
			$dataarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"api_id" => $cs_info['api_bid'],
				"order_log" => $order_info['order_log']."--接口调用失败"
			);
			$Order->order_edit($order_id,$dataarray);
			api_log($uid,$log,$e->getMessage(),"会员".$uid."升级".$pinfo['product_name']."失败");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			//升级成功，修改业务表信息
			$dataarray = array(
				"cpu" => $cpucount,
				"memory" => $memory*1024,
				"disk" => $disk,
			);
			$up_cloudserver_where['id'] = ["eq",$cs_id];
			if($this->where($up_cloudserver_where)->save($dataarray) !== false){
				// 业务表修改成功，修改订单表
				$dataarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"api_id" => $cs_info['id'],
					"order_log" => $order_info['order_log']."--升级成功"
				);
				$Order->order_edit($order_id,$dataarray);
				return -1; // 升级成功
			}
		}else{
			$dataarray = array(
				"state" => SD::FAILURE_ORDER,
				"complete_time" => current_date(),
				"order_log" => $order_info['order_log']."-扣费成功，调接口失败！"
			);
			$Order->order_edit($order_id,$dataarray);
			return $xstr['code'];
		}
	}

	/**
	 * 获取快云服务器开通进度
	 * @date: 2016年12月2日 上午11:58:05
	 * @author: Lyubo
	 * @param $cs_id
	 * @return int
	 */
	public function get_business_info($cs_id){
		$Order = new OrderModel();
		$uid = session("user_id");
		$where['id'] = ['eq',$cs_id];
		$where['user_id'] = ['eq',$uid];
		$cloudserver_info = $this->where($where)->find();
		$api_access = $cloudserver_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$api_did = $cloudserver_info['api_bid'];//保存在主站的订单编号
		$order_where['api_id'] = ['eq',$api_did];
		$order_where['user_id'] = ['eq',$uid];
		$order_info = $Order->where($order_where)->find();//通过api_bid获取订单信息
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->cloudserver_getinfo(GD::PTYPE_CLOUD_SERVER,GD::PNAME_CLOUDSERVER_SERVER,$api_did,GD::TID_GET_BUSINESS);
			api_log($uid,"ptype:".GD::PTYPE_CLOUD_SERVER."pname:".GD::PNAME_CLOUDSERVER_SERVER."--did:".$api_did."--tid:".GD::TID_GET_BUSINESS,$result,"会员".$uid."获取快云服务器开通进度");
		}catch(\Exception $e){
			$msg = $e->getMessage();
			// 记录操作
			api_log($uid,"ptype:".GD::PTYPE_CLOUD_SERVER."pname:".GD::PNAME_CLOUDSERVER_SERVER."--did:".$api_did."--tid:".GD::TID_GET_BUSINESS,$msg,"会员".$uid."获取快云服务器开通进度失败");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			if($xstr['info']['disk'] == "0"){
				$disk = $xstr['info']['ssddisk'];
			}else{
				$disk = $xstr['info']['disk'];
			}
			$cloudserver_business_arr = ['api_bid' => $xstr['info']['ywbh'],//业务编号
				'free_trial' => '0','create_time' => $xstr['info']['createDate'],//创建时间
				'overdue_time' => $xstr['info']['overDate'],//结束时间
				'cloudserver_user' => $xstr['info']['username'],//快云服务器账号
				'cloudhost_password' => $xstr['info']['password'],//快云服务器密码
				'state' => 1,//默认为1，正常状态
				'nw_ip' => $xstr['info']['nwip'],//内网IP
				'cpu' => $xstr['info']['cpucount'],//CPU
				'memory' => $xstr['info']['memory'],//内存
				'disk' => $disk,//硬盘
				'area_code' => $xstr['info']['server_areacode'],//地区编号
				'input_name' => $xstr['info']['input_name'],//存放操作系统编号
				'os_type' => $xstr['info']['ostype'],//存放操作系统名称
			];
			//判断ip_ywbh是否存在，excep是不存在的标识
			if($xstr['info']['ip_ywbh'] != "excep"){
				$cloudserver_business_ip_arr = ['user_id' => session("user_id"),//用户ID
					'login_name' => session("login_name"),//用户名称
					'product_id' => '227','free_trial' => '0','state' => 1,//默认为1，正常状态
					'api_bid' => $xstr['info']['ip_ywbh'],//IP业务编号
					'product_name' => "快云服务器IP",//默认"快云服务器IP"
					'create_time' => $xstr['info']['createDate'],//创建时间
					'overdue_time' => $xstr['info']['overDate'],//结束时间
					'bandwidth' => $xstr['info']['bandwidth'],//带宽
					'belong_server' => $xstr['info']['ywbh'],//绑定服务器编号
					'area_code' => $xstr['info']['server_areacode'],//IP地区编号
					'ipaddress' => $xstr['info']['ipdz'],//IP地区编号
					"access" => $api_access];
				$cloudserver_business_arr['ip_bid'] = $xstr['info']['ip_ywbh'];
				$ip = M("cloudserver_business_ip");
				$cloudserver_ip_edit = $ip->add($cloudserver_business_ip_arr);
			}else{
				//IP状态：0为绑定成功，1为已绑定未成功，2，未绑定
				$cloudserver_business_arr['ip_state'] = '2';
				$cloudserver_business_arr['ip_bid'] = '0';
			}
			$up_cloudserver['id'] = ["eq",$cs_id];
			$cloudserver_edit = $this->where($up_cloudserver)->save($cloudserver_business_arr);
			if($cloudserver_edit === false){
				$ordet_data['order_log'] = $order_info['order_log']."服务器业务开通成功，业务表修改失败";
				$Order->order_edit($order_info['order_id'],$ordet_data);
				return -103;
			}
			if(!$cloudserver_ip_edit){
				$ordet_data['order_log'] = $order_info['order_log']."ip业务开通成功，业务表修改失败";
				$Order->order_edit($order_info['order_id'],$ordet_data);
				return -103;
			}
			$ordet_data['state'] = SD::STATE_ONLINE_TRAN_SUCCESS;
			$ordet_data['order_log'] = "业务开通成功";
			$ordet_data['business_id'] = $xstr['info']['ywbh'];
			$app = $Order->order_edit($order_info['id'],$ordet_data);
			return -1;
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 快云服务器解绑IP
	 * @date: 2016年12月3日 下午5:58:04
	 * @author: Lyubo
	 * @param $cs_id
	 * @return mixed
	 */
	public function show_cloudserver_info($cs_id){
		return $this->cloudserver_info($cs_id);
	}

	/**
	 * 快云服务器续费展示
	 * @date: 2016年12月4日 下午2:32:00
	 * @author: Lyubo
	 * @param int $uid
	 * @param int $cs_id 业务ID
	 * @return array|int
	 */
	public function show_cloudserver_renewals($uid,$cs_id){
		$product = new ProductModel();
		// 获取快云服务器业务信息
		$cs_server_where["id"] = ["eq",$cs_id];
		$cs_info = $this->where($cs_server_where)->find();
		$bandwidth = $cs_info["bandwidth"];
		if($cs_info["ip_state"] == 0 && $cs_info["ip_bid"] != null){
			$ip = M("cloudserver_business_ip");
			$ip_where["api_bid"] = ["eq",$cs_info["ip_bid"]];
			$csip_info = $ip->where($ip_where)->find();
			$cs_info["ipaddress"] = $csip_info["ipaddress"];
			if($cs_info["bandwidth"] == 0){
				$bandwidth = $csip_info["bandwidth"];
			}
		}
		if(!$cs_info || $cs_info["user_id"] != $uid){
			return -101; // 快云服务器业务信息获取失败
		}
		if($cs_info["state"] != SD::SUCCESS && $cs_info["state"] != SD::OVERDUE){
			return -10; // 业务失效
		}
		if($cs_info["free_trial"] != 0){
			return -100; // 试用业务不能续费
		}
		// 根据产品编号获取产品信息
		$pinfo = $product->get_product($cs_info["product_id"]);
		if(!$pinfo){
			return -2; // 产品信息获取失败
		}
		$cs_info["overdue_month"] = app_month($cs_info["overdue_time"]);
		$cs_info["bandwidth"] = $bandwidth;
		$cs_info["mem"] = $cs_info["memory"] / 1024;
		$cs_info["type"] = GD::TID_RENEWALS;
		$cs_info["dqbh"] = $cs_info["area_code"];
		$cs_info["gmqx"] = 1;
		$cloud_price_one = $this->CalculatedPrice($cs_info);
		$cs_info["gmqx"] = 6;
		$cloud_price_Six = $this->CalculatedPrice($cs_info);
		$cs_info["gmqx"] = 12;
		$cloud_price_Twelve = $this->CalculatedPrice($cs_info);
		$cs_info["gmqx"] = 24;
		$cloud_price_TwentyFour = $this->CalculatedPrice($cs_info);
		$cs_info["gmqx"] = 36;
		$cloud_price_ThirtySix = $this->CalculatedPrice($cs_info);
		$cs_info["gmqx"] = 48;
		$cloud_price_FortyEight = $this->CalculatedPrice($cs_info);
		/*获取购买期限*/
		//获取续费信息
		$renewals_info[0] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 1,
			"product_price" => $cloud_price_one,
			"msg" => ""
		);
		$renewals_info[1] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 6,
			"product_price" => $cloud_price_Six,
			"msg" => ""
		);
		$renewals_info[2] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 12,
			"product_price" => $cloud_price_Twelve,
			"msg" => "（仅需10个月费用即可享受12个月服务）"
		);
		$renewals_info[3] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 24,
			"product_price" => $cloud_price_TwentyFour,
			"msg" => "（仅需20个月费用即可享受24个月服务）"
		);
		$renewals_info[4] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 36,
			"product_price" => $cloud_price_ThirtySix,
			"msg" => "（仅需30个月费用即可享受36个月服务）"
		);
		/*$renewals_info[5] = array(
			"product_name" => $cs_info["product_name"],
			"id" => $cs_info["id"],
			"month" => 48,
			"product_price" => $cloud_price_FortyEight,
			"msg" => "（仅需40个月费用即可享受48个月服务）"
		);*/
		$total_price[0] = array("price" => $cloud_price_one,"month" => 1);
		$total_price[1] = array("price" => $cloud_price_Six,"month" => 6);
		$total_price[2] = array("price" => $cloud_price_Twelve,"month" => 12);
		$total_price[3] = array("price" => $cloud_price_TwentyFour,"month" => 24);
		$total_price[4] = array("price" => $cloud_price_ThirtySix,"month" => 36);
//		$total_price[5] = array("price" => $cloud_price_FortyEight,"month" => 48);
		return array_merge($cs_info,array("renewals_info" => $renewals_info,"total_price" => $total_price,"renewals_price_list" => $renewals_info)); // 返回该业务详细信息和续费金额给确认续费页面
	}

	/**
	 * 解绑快云服务器IP
	 * @date: 2016年12月3日 下午7:14:35
	 * @author: Lyubo
	 * @param $cs_id
	 * @param $cloudserver_ip_id
	 * @param $ip_address
	 * @param $cloudserver_api_bid
	 * @param $cloudserver_ip_bid
	 * @return int|string
	 */
	public function cloudserver_relieve($cs_id,$cloudserver_ip_id,$ip_address,$cloudserver_api_bid,$cloudserver_ip_bid){
		$cloudserver_info = $this->show_cloudserver_info($cs_id);
		$api_access = $cloudserver_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if($cloudserver_info['ipaddress'] != $ip_address){
			return '5016';
		}
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->cloudserver_relieve(GD::PTYPE_CLOUD_SERVER,$cloudserver_api_bid,$cloudserver_ip_bid);
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_api_bid."ipdid:".$cloudserver_ip_bid."--tid:".GD::TID_IP_RELIEVE."--",$result,"快云服务器解绑IP");
		}catch(\Exception $e){
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_api_bid."ipdid:".$cloudserver_ip_bid."--tid:".GD::TID_IP_RELIEVE."--",$result,"快云服务器解绑IP");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			$dataarray = array("belong_server" => '0');
			$arr = array("ip_state" => '2',"ip_bid" => '0');
			$up_where["id"] = ["eq",$cs_id];
			if($this->where($up_where)->save($arr) !== false){
				$ip = M("cloudserver_business_ip");
				$ip_where['id'] = ["eq",$cloudserver_ip_id];
				if($ip->where($ip_where)->save($dataarray) === false){
					return -102;
				}
			}else{
				//表修改失败
				return -102;
			}
			return -1;
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 快云服务器绑定IP
	 * @date: 2016年12月4日 上午11:01:44
	 * @author: Lyubo
	 * @param $cs_id
	 * @param $cloudserver_api_bid
	 * @param $ip_address
	 * @return int|string
	 */
	public function cloudserver_bound($cs_id,$cloudserver_api_bid,$ip_address){
		$cloudserver_ip = M("cloudserver_business_ip");
		$ip_where['ipaddress'] = ["eq",$ip_address];
		$cloudserver_ip_info = $cloudserver_ip->where($ip_where)->find();
		$api_access = $cloudserver_ip_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if(!$cloudserver_ip_info){
			return '5016';//快云服务器，ip不存在
		}
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->cloudserver_bound(GD::PTYPE_CLOUD_SERVER,$cloudserver_api_bid,$cloudserver_ip_info['api_bid']);
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_api_bid."ipdid:".$cloudserver_ip_info['api_bid']."--tid:.".GD::TID_IP_BOUND."--",$result,"快云服务器绑定IP");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_api_bid."ipdid:".$cloudserver_ip_info['api_bid']."--tid:".GD::TID_IP_BOUND."--",$message,"快云服务器绑定IP失败");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == '0'){
			$dataarray = array("ip_state" => '1',"ip_bid" => $cloudserver_ip_info['api_bid'],);
			$where["id"] = $cs_id;
			if($this->where($where)->save($dataarray) !== false){
				//修改服务器表成功
				return -1;
			}
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 获取IP绑定进度
	 * @date: 2016年12月4日 下午12:06:49
	 * @author: Lyubo
	 * @param $cs_id
	 * @param $ip_bid
	 * @return int|string
	 */
	public function ip_progress($cs_id,$ip_bid){
		$ip = M("cloudserver_business_ip");
		$ip_where["api_bid"] = ["eq",$ip_bid];
		$cloudserver_where['id'] = ["eq",$cs_id];
		$cloudserver_ip_info = $ip->where($ip_where)->find();
		$cloudserver_info = $this->where($cloudserver_where)->find();
		$api_access = $cloudserver_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		if(empty($cloudserver_ip_info)){
			return '5016';//快云服务器，ip不存在
		}
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->cloudserver_getip(GD::PTYPE_CLOUD_SERVER,$cloudserver_info['api_bid'],$ip_bid);
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_info['api_bid']."ipdid:".$ip_bid."--tid:".GD::TID_GET_BUSINESS,$result,"获取IP绑定进度");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),"ptype:".GD::PTYPE_CLOUD_SERVER."--bid:".$cloudserver_info['api_bid']."ipdid:".$ip_bid."--tid:".GD::TID_GET_BUSINESS,$message,"获取IP绑定进度");
			return -9;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == '0'){
			$dataarray = array("ip_state" => '0');
			$arr = array("belong_server" => $cloudserver_info["api_bid"]);
			$up_cloudserver_where['id'] = ["eq",$cs_id];
			$up_cloudserver_ip_where["api_bid"] = ["eq",$ip_bid];
			if($this->where($up_cloudserver_where)->save($dataarray) !== false){
				if($ip->where($up_cloudserver_ip_where)->save($arr) === false){
					//IP表修改失败
					return -102;
				}
			}else{
				//服务器表修改失败
				return -102;
			}
			return -1;
		}else{
			return $xstr['code'];
		}
	}

	/**
	 * 获取未开通业务
	 * @date: 2016年12月6日 下午5:54:37
	 * @author: Lyubo
	 * @param $cloudserver_info
	 * @return array
	 */
	public function get_not_open($cloudserver_info){
		$business_info = [];
		$i = 0;
		foreach($cloudserver_info as $key => $val){
			if($val['state'] == 5){
				$business_info[$i++] = $val['yid'];
			}
		}
		return $business_info;
	}

	/**
	 *快云服务器实名关联认证
	 * 2018-10-16
	 * @param: $bid，已认证业务id
	 * @param: $info，未认证业务
	 * gcf
	 */
	public function guanLian($bid,$info){
		$infos='';
		$data['ptype']='self';
		$data['pname']='cloudserver';
		$data['tid']=68;
		$data['bid']=$bid;
		$data['connect_bid']=$info['api_bid'];
		$infos.='ptype:'.$data['ptype']."-pname:".$data['pname'].'-tid:'.$data['tid']."-bid:".$data['bid']."-connect_bid:".$data['connect_bid'];
		$api_access=$this->where(array('id'=>clearXSS($info['id'])))->find();
		$agent = new AgentAide(1,$api_access['access']);
		$transaction = $agent->servant;
		try{
			$result = $transaction->guanlian_certify($data);
			api_log(session("user_id"),$infos,$result,"快云服务器实名关联认证，业务编号：[".$info['api_bid'].' 关联 '.$bid.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$infos,$message,"快云服务器实名关联认证，业务编号：[".$info['api_bid'].' 关联 '.$bid.']');
			return -9;
		}

		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*查看关联业务在代理平台是否有认证记录，若有则被关联业务也要生成认证记录，没有则不生成*/
			$ren_log=M('certify_log')->where(array('api_bid'=>$bid))->find();
			if($ren_log['id']){
				$certify_log['user_id']=session('user_id');
				$certify_log['certify_time']=date('Y-m-d H:i:s');
				$certify_log['check_status']=1;
				$certify_log['idCart']=$ren_log['idcart'];
				$certify_log['product']=$info['product_name'];
				$certify_log['pb_id']=$info['id'];
				$certify_log['api_bid']=$info['api_bid'];
				$certify_log['phone']=$ren_log['phone'];
				$certify_log['contactname']=$ren_log['contactname'];
				$certify_log['comptype']=$ren_log['comptype'];
				$certify_log['mark']="关联认证审核通过，关联业务".$bid;
				M('certify_log')->add($certify_log);
				$this->where(array('id'=>$info['id']))->save(array('authentication'=>1));
			}
			return -1;
		}else{
			return $xstr["code"];
		}
	}


	/**
	 * 快云服务器实名认证
	 * 2018-09-17
	 * gcf
	 * */

	public function certify($data,$binfo){
		$info='';
		$arrdata['ptype']=$ptype="self";//产品类型
		$arrdata['pname']=$pname="cloudserver"; //产品
		$arrdata['tid']=$tid="66";//交易编号
		$arrdata['bid']=$bid=$binfo['api_bid'];//业务编号
		$arrdata['mobile']=$mobile=clearXSS($data['mobile']);//固话号码（企业认证）、手机（个人认证）
		$arrdata['applyName']=$applyName=clearXSS($data['applyName']);//申请人/企业名称
		$arrdata['idCart']=$idCart=clearXSS($data['idCart']);//身份证号码/营业执照号码
		$arrdata['compType']=$compType=clearXSS($data['compType']);//认证类型（1、个人 2企业）
		$info.="ptype:".$ptype."--pname:".$pname."--tid:".$tid."--bid:".$bid."--mobile:".$mobile."--applyName:".$applyName."--idCart:".$idCart."--compType:".$compType;

		$idcart='/(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/';//身份证号
		$yyCart='/^[A-Za-z0-9\-]{1,30}$/';//营业执照
		$mobile='/^13[0-9]{1}[0-9]{8}$|15[0-9]{1}[0-9]{8}$|18[0-9]{1}[0-9]{8}$|17[0-9]{1}[0-9]{8}$|16[0-9]{1}[0-9]{8}$/';//手机号
		$phone='/^(0(10|21|22|23|[1-9][0-9]{2})(-|))?[0-9]{7,8}$/';//固话

		if($arrdata['compType']==1){
			if(!preg_match($mobile,$arrdata['mobile'])){
				$this->setError("请填写正确的个人手机号");
				return false;
			}
			if(!preg_match($idcart,$arrdata['idCart'])){
				$this->setError("请填写正确的身份证号");
				return false;
			}
		}
		if($arrdata['compType']==2){
			$regDWMC = "/^(([\x{4e00}-\x{9fa5}]+\（[\x{4e00}-\x{9fa5}]+\）[\x{4e00}-\x{9fa5}]*)|([\x{4e00}-\x{9fa5}])){6,30}$/u";
			if(!preg_match($regDWMC,str_replace(" ","",$arrdata['applyName']))){

				$this->setError("请填写公司名称6-30个字符");
				return false;
			}

			if(!preg_match($phone,$arrdata['mobile'])){
				$this->setError("请填写正确的企业固话");
				return false;
			}

			if(!preg_match($yyCart,$arrdata['idCart'])){
				$this->setError("请填写正确的营业执照编号");
				return false;
			}
		}

		if($compType==1){
			/*个人认证需要传参 联系人 ==申请人  */
			$arrdata['contactname']=$contactname=$applyName;//联系人
			//取得上传的图片信息
			if(empty($_FILES["idCard"]["tmp_name"])){
				$this->setError("手持身份证人像面未上传");
				return false;
			}elseif(empty($_FILES["idCardBm"]["tmp_name"])){
				$this->setError("手持身份证国徽面未上传");
				return false;
			}

			if($_FILES["idCard"]["size"] > 5*1024*1024){ // 设置图片上传大小
				$this->setError("手持身份证人像面不能大于5M");
				return false;
			}elseif($_FILES["idCardBm"]["tmp_name"] > 5*1024*1024){
				$this->setError("手持身份证国徽面不能大于5M");
				return false;
			}

			$img_type = array('jpg','png','jpeg');
			foreach($_FILES as $fkey => $fvalue){
				if(!in_array(explode("/",$fvalue["type"])[1],$img_type)){
					$this->setError("非法图像文件！");
					return false;
				}
			}
			$base64_img = [];
			foreach($_FILES as $fkey => $fvalue){
				 $img = $fvalue["tmp_name"];
				 $image_data = fread(fopen($img,'r'),filesize($img));
				 $base64_img[$fkey] = base64_encode($image_data);
			}

			if(empty($base64_img)){
				$this->setError("未获取到上传扫描件");
				return false;
			}

			$arrdata['applyIdImg']=$applyIdImg=$base64_img['idCard'];//身份证正面/营业执照图片（转换为BASE64位格式字符串）
			$arrdata['imageIDcart']=$imageIDcart=$base64_img['idCardBm'];//身份证反面（个人专用）（转换为BASE64位格式字符串）
			$arrdata['imageName']=$imageName=$_FILES["idCard"]['name'];//图片名称 图片名称后缀为jpg、png
			$arrdata['imageIDcartName']=$imageIDcartName=$_FILES["idCardBm"]['name']; //身份证反面名称（个人专用）图片名称后缀为jpg、png

		}
		if($compType==2){
			$arrdata['contactname']=$contactname=clearXSS($data['contactname']);//联系人
			//取得上传的图片信息
			if(empty($_FILES["idCard"]["tmp_name"])){
				$this->setError("营业执照图片未上传");
				return false;
			}

			if($_FILES["idCard"]["size"] > 1023*1024){ // 设置图片上传大小
				$this->setError("营业执照图片不能大于1M");
				return false;
			}

			if(!empty($_FILES["idCardBm"]["tmp_name"])){
				if($_FILES["idCardBm"]["tmp_name"] > 1023*1024){
					$this->setError("手持身份证人像面不能大于1M");
					return false;
				}
			}



			$img_type = array('jpg','png','jpeg');
			foreach($_FILES as $fkey => $fvalue){
				if(!in_array(explode("/",$fvalue["type"])[1],$img_type)){
					$this->setError("非法图像文件！");
					return false;
				}
			}
			$base64_img = [];
			foreach($_FILES as $fkey => $fvalue){
				$img = $fvalue["tmp_name"];
				$image_data = fread(fopen($img,'r'),filesize($img));
				$base64_img[$fkey] = base64_encode($image_data);
			}

			if(empty($base64_img)){
				$this->setError("未获取到上传扫描件");
				return false;
			}

			$arrdata['applyIdImg']=$applyIdImg=$base64_img['idCard'];//身份证正面/营业执照图片（转换为BASE64位格式字符串）
			$arrdata['imageName']=$imageName=$_FILES["idCard"]['name'];//图片名称 图片名称后缀为jpg、png
			//$arrdata['imageIDcart']=$imageIDcart=$base64_img['idCardBm'];//身份证反面（个人专用）（转换为BASE64位格式字符串）
			//$arrdata['imageIDcartName']=$imageIDcartName=$_FILES["idCardBm"]['name']; //身份证反面名称（个人专用）图片名称后缀为jpg、png
		}
		if($compType==1){
			$info.="--contactname:".$contactname."--imageName:".$imageName."--imageIDcartName:".$imageIDcartName;
		}else{
			$info.="--contactname:".$contactname."--imageName:".$imageName;
		}

		$api_access=$this->where(array('id'=>clearXSS($data['cs_id'])))->find();

		$agent = new AgentAide(1,$api_access['access']);
		$transaction = $agent->servant;
		 try{
			$result = $transaction->csname_certify($arrdata);
			api_log(session("user_id"),$info,$result,"快云服务器实名认证，业务编号：[".$arrdata['bid'].']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"快云服务器实名认证，业务编号：[".$arrdata['bid'].']');
			return -9;
		}
		//var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*实名接口调用成功，生成实名记录,并修改代理平台上的实名状态为审核中*/
			$certify_log['user_id']=session('user_id');
			$certify_log['certify_time']=date('Y-m-d H:i:s');
			$certify_log['check_status']=0;
			$certify_log['idCart']=$arrdata['idCart'];
			$certify_log['product']=$binfo['product_name'];
			$certify_log['pb_id']=$binfo['id'];
			$certify_log['api_bid']=$binfo['api_bid'];
			$certify_log['phone']=$arrdata['mobile'];
			$certify_log['contactname']=$arrdata['contactname'];
			$certify_log['comptype']=$arrdata['compType'];
			$certify_log['mark']="审核时间1-3个工作日";
			M('certify_log')->add($certify_log);
			M('cloudserver_business')->where(array('id'=>$binfo['id']))->save(array('authentication'=>2));
			return -1;
		}else{

			return $xstr["code"];
		}


	}



}