<?php
namespace Frontend\Model;

use Common\Data\StateData as SD;
use Think\Model;
use Think\Page;

class InvoiceModel extends Model{
	protected $trueTableName = "agent_member_invoice";

	public function conver_par(){
		$date = request();
		$where["user_id"] = array("eq",session("user_id"));
		$select = $date["select"];
		if(!empty($date["id"])){
			$where["id"] = array("eq",$date["id"]+0);
		}elseif(!empty($select)){
			$map["payable"] = array("like","%{$select}%");
			$map["_logic"] = "OR";
			$map["id"] = array("eq",$select);
			$where['_complex'] = $map;
		}
		return $where;
	}

	/**
	 * 添加发票申请记录
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @param: $member_id
	 * @param: $balance   余额
	 * @param: $purchases 消费总额
	 * @return bool
	 */
	public function add_invoice(){
		$data = request();
		$uid = session("user_id");
		$login_name = session("login_name");
		$financial = new FinancialModel();
		$where = $financial->conver_par();
		$member_account_info = $financial->account_info($where);
		$xfze = $member_account_info["purchases"];
		$save["fp_type"] = $data["fp_type"]+0;//发票类型
		$save["kj_type"] = $data["kj_type"]+0;//开具类型1：企业,2：个人
		$save["payable"] = $data["payable"];//发票抬头
		$save["taxpayer_num"] = $data["taxpayer_num"];//纳税人识别号
		$save["money"] = $data["money"]+0;//发票金额
		$save["cost_type"] = $data["cost_type"];//费用类别
		$save["name"] = $data["name"];//收件人姓名
		$save["phone"] = $data["phone"];//收件人电话
		$save["email"] = $data["email"];//邮箱
		$save["msg"] = $data["msg"];//留言
		$regTN = "/^([A-Z\d]){15,20}$/";
		if($save["fp_type"] === 2){
			$save["kj_type"] = 1;
			$save["comp_addr"] = $data["comp_addr"];//注册地址
			$save["comp_mobile"] = $data["comp_mobile"];//联系电话
			$save["comp_bank"] = $data["comp_bank"];//开户银行
			$save["comp_bankcard"] = $data["comp_bankcard"];//银行卡账号
			if(!preg_match($regTN,$save["taxpayer_num"]) && in_array(strlen($save["taxpayer_num"]),array(15,18,20))){
				$return["state"] = false;
				$return["msg"] = "纳税人识别号格式错误！";
				return $return;
			}
			$regCA = "/^[\x{4e00}-\x{9fa5}0-9A-Z]{5,200}$/u";
			if(!preg_match($regCA,$save["comp_addr"])){
				$return["state"] = false;
				$return["msg"] = "注册地址格式错误！";
				return $return;
			}
		}elseif($save["fp_type"] === 1){
			if($save["kj_type"] === 1){
				if(!preg_match($regTN,$save["taxpayer_num"]) && in_array(strlen($save["taxpayer_num"]),array(15,18,20))){
					$return["state"] = false;
					$return["msg"] = "纳税人识别号格式错误！";
					return $return;
				}
			}elseif($save["kj_type"] === 2){
				if($save["taxpayer_num"] != "" && !preg_match($regTN,$save["taxpayer_num"]) && in_array(strlen($save["taxpayer_num"]),array(15,18,20))){
					$return["state"] = false;
					$return["msg"] = "纳税人识别号格式错误！";
					return $return;
				}
			}else{
				$return["state"] = false;
				$return["msg"] = "请选择发票开具类型！";
				return $return;
			}
		}else{
			$return["state"] = false;
			$return["msg"] = "请选择发票类型！";
			return $return;
		}
		if($save["money"] <= 0){
			$return["state"] = false;
			$return["msg"] = "请填写发票金额！";
			return $return;
		}
		if($save["money"] >= $xfze){
			$return["state"] = false;
			$return["msg"] = "发票金额不得超过最大消费金额！";
			return $return;
		}
		$save["user_id"] = $uid;
		$save["login_name"] = $login_name;
		$save["state"] = 2;
		$save["create_time"] = current_date();
		$res = $this->add($save);
		if($res !== false){
			$return["state"] = true;
			return $return;
		}else{
			$return["state"] = false;
			$return["msg"] = "提交发票申请失败！";
			return $return;
		}
	}

	/**
	 * 获取会员发票信息
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @return array|bool
	 */
	public function my_invoice(){
		$data = request();
		$pagnum = $data["pagnum"] ? $data["pagnum"] : "10";//每页显示条数
		$where = $this->conver_par();
		$order = "DESC";
		$info = $this->get_list($where,$pagnum,$order);
		if($info == false){
			$return["state"] = false;
			$return["msg"] = $this->error;
		}else{
			$return["state"] = true;
			$return["info"] = $info;
		}
		return $return;
	}

	/**
	 * 取消发票申请
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @return array|bool
	 */
	public function invoice_cancel(){
		$data = request();
		$uid = session("user_id");
		$id = $data["id"] + 0;
		$info = $this->where(array("id"=>$id,"user_id"=>$uid))->find();
		if(!$info){
			$return["state"] = false;
			$return["msg"] = "该申请不存在！";
			return $return;
		}
		$res = $this->where(array("id"=>$id))->save(array("state"=>0,"msg"=>"-取消申请"));
		if($res === false){
			$return["state"] = false;
			$return["msg"] = "数据更新失败！";
			return $return;
		}else{
			$return["state"] = true;
			$return["info"] = "取消成功！";
			return $return;
		}
	}

	/**
	 * 获取会员发票信息
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @param $where
	 * @param int $per_page
	 * @return array|bool
	 */
	public function get_list($where,$per_page = 10,$order = "DESC"){
		$info = [];
		if($where){
			$sum = $this->paging($where,$per_page);
			$data = $this->queryBuilder($where,$order)->limit($sum["page"]->firstRow.",".$sum["page"]->listRows)->select();
			$info["count"] = $sum["count"];
			$info["show"] = $sum["page"]->show();
			//对自带thinkphp分页进行替换
			$show = str_replace("<div>","",$info["show"]);
			$show = str_replace("</div>","",$show);
			$show = str_replace("span","a",$show);
			$info["page_show"] = $show;
			$info["list"] = $data;
			return $info;
		}else{
			$this->error = "查询条件为空";
			return false;
		}
	}

	/**
	 * 获取带条件的总记录数
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @param $where
	 * @param string $order
	 * @return mixed
	 */
	function queryBuilder($where,$order = "DESC"){
		$info = $this->where($where)->order("create_time ".$order);
		return $info;
	}

	/**
	 * 公共分页
	 * @date: 2019年6月25日16:52:53
	 * @author: GuoPeng
	 * @param $where
	 * @param int $per_page
	 * @return array
	 */
	public function paging($where,$per_page = 10){
		$sumpage = [];
		$count = $this->queryBuilder($where)->count();
		$Page = new Page($count,$per_page);// 实例化分页类 传入总记录数和每页显示的记录数
		$Page->setConfig("prev","上一页");
		$Page->setConfig("next","下一页");
		$Page->setConfig("first","首页");
		$Page->setConfig("last","尾页");
		$request = request();
		//分页跳转的时候保证查询条件
		foreach($request as $key => $val){
			$Page->parameter[$key] = urlencode($val);
		}
		$sumpage["page"] = $Page;
		$sumpage["count"] = $count;
		return $sumpage;
	}

}