<?php
namespace Frontend\Model;

use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;
use Common\Data\StateData as SD;
use Frontend\Model\BusinessModel;
use Think\Image;
use Think\Upload;

class SslModel extends BusinessModel{
    protected $trueTableName = "agent_ssl_business";

    public function conver_par(){
        $date = request();
        $where["bs.user_id"] = array("eq",session("user_id"));
        $select = clearXSS(I("post.select"));
        if(!empty($select)){
            $map["bs.business_id"] = array("like","%$select%");
            $map["_logic"] = "OR";
            $map["bs.domain_name"] = array("like","%$select%");
            $map["_logic"] = "OR";
            $map["bs.product_name"] = array("like","%$select%");
            $map["_logic"] = "OR";
            $map["bs.beizhu"] = array("like","%$select%");
            $where["_complex"] = $map;
        }
        return $where;
    }

    /**
     * 计算ssl证书价格
     * @时间: 2019年8月22日15:50:13
     * @author: GuoPeng
	 * @param $data
	 * @return int
	 */
    public function get_price($data){
		$pid = $data["pid"];
		$ymgs = $data["ymgs"];
		$tpgs = $data["tpgs"];
		$month = $data["month"];
		$price_info = M("product_price")->where(array("product_id"=>$pid,"month"=>$month))->select();
		$step = $add_step = $current_price = $dymgs = $tp_price = 0;
		foreach($price_info as $val){
			if($val["api_type"] == 0){
				$current_price = $val["product_price"];
			}
			if($val["api_type"] == 1){
				$step = $val["product_price"];
			}
			if($val["api_type"] == 2){
				$add_step = $val["product_price"];
			}
			if($val["api_type"] == 3){
				$tp_price = $val["product_price"];
			}
		}
        if($pid == 321){
			if($tpgs == 1){
				$price = $tp_price * $tpgs;
			}else if($tpgs > 1){
				$price = $tp_price * $tpgs + $current_price;
			}else if($ymgs > 1){
				$dymgs = $ymgs - 3;
				if($dymgs < 0){
					$dymgs = 0;
				}
				$price = $step + $add_step * $dymgs;
			}else{
				$price = $current_price * $ymgs;
			}
		}else{
			if($tpgs > 0){
				$price = ($current_price * 3 - 6) * $tpgs;
			}else if($ymgs > 1){
				$dymgs = $ymgs - 2;
				if($dymgs < 0){
					$dymgs = 0;
				}
				$price = $step + $add_step * $dymgs;
			}else{
				$price = $current_price;
			}
		}
		$user = new MemberModel();
		$uid = session("user_id");
		$user_level = $user->get_user_level($uid,20);
		$discount = $user_level["discount"];
		if($discount <= 0){
			$discount = 1;
		}
		$price = $price * $discount;
        return $price;
    }

    /**
     * 购买/试用ssl
     * @date: 2019年8月21日13:50:19
     * @author: GuoPeng
     * @return int
     */
    public function buy(){
		$data = request(true);
        $uid = session("user_id");
        $pid = $data["product_id"] + 0;
        $free_trial = $data["free_trial"] + 0;
        $ymgs = $data["multi_domain"] + 0;
        $tpgs = $data["global_domain"] + 0;
        $month = $data["month"] + 0;
		$product = new ProductModel();
		$pinfo = $product->where(array("id"=>$pid))->find();//获取产品信息
		if(!$pinfo){
			$return["status"] = false;
			$return["msg"] = "交易失败：产品编号错误！";
			return $return;
		}
		if($pinfo["product_state"] == 0){
			$return["status"] = false;
			$return["msg"] = "交易失败：该产品已停止销售，请换购！";//产品编号错误
			return $return;
		}
		if(strpos($pinfo["stage"],"2") === false){
			$return["status"] = false;
			$return["msg"] = "交易失败：该产品已停止销售，请换购！";//产品编号错误
			return $return;
		}
		if($pid == 228){
			$return["status"] = false;
			$return["msg"] = "交易失败：该产品已停止销售，请换购！";//产品编号错误
			return $return;
		}
		if($month != 12 && $month != 24){
			$return["status"] = false;
			$return["msg"] = "交易失败：购买时长错误！";
			return $return;
		}
		if($tpgs > 0){
			$tpgs = 1;
			$ymgs = 0;
			$dymzsgs = 0;
		}else{
			$tpgs = 0;
			if($ymgs < 1){
				$ymgs = 1;
			}
			$dymzsgs = $ymgs - 1;
		}
		if($pid == 321){
			if($ymgs == 2){
				$ymgs = 3;
			}
		}
		$buy_info = [
			"pid" => $pid,
			"month" => $month,
			"ymgs" => $ymgs,
			"tpgs" => $tpgs
		];
		$price = $this->get_price($buy_info);
		if($price <= 0){
			$return["status"] = false;
			$return["msg"] = "交易失败：价格计算错误！";
			return $return;
		}
        $api_config = WebSiteConfig(2);//获取网站配置
        $access = $api_config["api_access"] + 0;
        $access = $access ? $access : 1;
        // 封装订单参数信息
        $save = array(
			"user_id" => $uid,
			"order_type" => 0,//购买
			"state" => 0,//失败状态
            "product_type" => 20,
            "product_id" => $pid,
            "product_name" => $pinfo["product_name"],
            "free_trial" => $free_trial, // 购买或者试用
            "order_time" => $month,
			"order_quantity" => 1,
			"charge" => $price,
			"create_time" => current_date(),
            "complete_time" => current_date(), // 完成时间
            "ip_address" => $dymzsgs.",".$tpgs,//多域名，通配证书
            "area_code" => 4001,
            "order_log" => "[购买][{$pinfo["product_name"]}][1个][{$month}个月]",
            "access" => $access
        );
        //执行录入订单、购买方法
        $Order = new OrderModel();
        $res = $Order->ssl_order_do_entry($save,$pinfo);
        if(!$res["status"]){
            return $res;
        }
		$oid = $res["msg"];
		$oinfo = $Order->order_find($oid);
		$agent = new AgentAide(1,$access);
        $transaction = $agent->servant;
		if($pid == 321){
			$pname = "comodo.posit";
			if($tpgs > 0){
				$pname = "comodo.wild";
			}elseif($dymzsgs > 0){
				$pname = "comodo.multi";
			}
			$log = "ptype:csafessl-pname:{$pname}-tid:1-yid:{$month}-cplb:104-dymzsgs:{$dymzsgs}-dfwqzs:{$tpgs}";
			try{
				$result = $transaction->ssl_comodo_buy($pname,$month,$dymzsgs,0,$tpgs);
				api_log($uid,$log,$result,"SSL-Comodo证书购买");
			}catch(\Exception $e){
				// 调用接口试用失败修改订单表
				$order_data = array(
					"complete_time" => current_date(),
					"order_log" => $oinfo["order_log"]."[接口调用失败]",
				);
				$Order->order_edit($oid,$order_data);
				api_log($uid,$log,$e->getMessage(),"SSL-Comodo证书购买失败");
				$return["status"] = false;
				$return["msg"] = "交易失败：接口调用失败！";
				return $return;
			}
			$xstr = json_decode($result,true);
			if($xstr["code"] === 0){
				$xstr = $xstr["info"];
				if($xstr["code"] === 1){
					$ddh = $xstr["result"]["ddbh"];
					$pid = $xstr["result"]["pid"];
					$gid = $xstr["result"]["gid"];
					$order_data = array(
						"api_id" => $ddh,
						"business_id" => $pid,
						"api_ip_id" => $gid,
						"create_time" => $xstr["result"]["cjsj"],
						"state" => SD::PAYMENT_ORDER  //订单状态已付款
					);
					$res = $Order->order_edit($oid,$order_data);
					if($res === false){
						$return["status"] = true;
						$return["msg"] = "交易成功：订单更新失败！";
						return $return;
					}else{
						$return["status"] = true;
						$return["msg"] = "交易成功：您可以在[会员中心-我的订单]查看订单信息！";
						return $return;
					}
				}else{
					// 调用接口购买/试用失败,调用接口试用失败修改订单表
					$order_data = array(
						"complete_time" => current_date(),
						"order_log" => $oinfo["order_log"]."[接口调用失败:{$xstr["message"]}",
					);
					$Order->order_edit($oid,$order_data);
					$return["status"] = false;
					if(isset($xstr["message"])){
						$return["msg"] = "接口调用失败！";
					}else{
						$return["msg"] = "接口调用失败：".$xstr["message"];
					}
					return $return;
				}
			}else{
				// 调用接口购买/试用失败,调用接口试用失败修改订单表
				$order_data = array(
					"complete_time" => current_date(),
					"order_log" => $oinfo["order_log"]."[接口调用失败:code-{$xstr["code"]}",
				);
				$Order->order_edit($oid,$order_data);
				$return["status"] = false;
				$return["msg"] = business_code($xstr["code"]);
				return $return;
			}
		}else{
			$log = "ptype:ssl-pname:{$pinfo["api_name"]}-tid:1-yid:{$month}-dymzsgs:{$dymzsgs}-dfwqzs:{$tpgs}";
			try{
				$result = $transaction->ssl_buy(GD::PTYPE_SSL,$pinfo["api_name"],$dymzsgs,0,$tpgs,$month);
				api_log($uid,$log,$result,"SSL证书购买");
			}catch(\Exception $e){
				// 调用接口试用失败修改订单表
				$order_data = array(
					"complete_time" => current_date(),
					"order_log" => $oinfo["order_log"]."[接口调用失败]",
				);
				$Order->order_edit($oid,$order_data);
				api_log($uid,$log,$e->getMessage(),"SSL证书购买失败");
				$return["status"] = false;
				$return["msg"] = "交易失败：接口调用失败！";
				return $return;
			}
			$xstr = json_decode($result,true);
			if($xstr["code"] === 0){
				// 调用接口购买/试用成功
				$ddh = $xstr["info"]["ddh"];
				$ywbh = $xstr["info"]["ywbh"];
				$order_data = array(
					"api_id" => $ddh,
					"business_id" => $ywbh,
					"complete_time" => current_date(),
					"state" => SD::PAYMENT_ORDER  // 订单状态已付款
				);
				$res = $Order->order_edit($oid,$order_data);
				if($res === false){
					$return["status"] = true;
					$return["msg"] = "交易成功：订单更新失败！";
					return $return;
				}else{
					$return["status"] = true;
					$return["msg"] = "交易成功：您可以在[会员中心-我的订单]查看订单信息！";
					return $return;
				}
			}else{
				// 调用接口购买/试用失败,调用接口试用失败修改订单表
				$order_data = array(
					"complete_time" => current_date(),
					"order_log" => $oinfo["order_log"]."[接口调用失败:code-{$xstr["code"]}",
				);
				$Order->order_edit($oid,$order_data);
				$return["status"] = false;
				$return["msg"] = business_code($xstr["code"]);
				return $return;
			}
		}
    }

    /************************************************************************************/
    /**
	 * 获取业务的状态
     * @author: GuoPeng
     * @param $where
     * @return mixed
     */
    function get_ssl_state($where){
        $fields = "bs.id as yid,bs.user_id,bs.login_name,bs.business_id,bs.product_id,bs.product_name,bs.create_time,bs.overdue_time,bs.buy_time,bs.state,bs.free_trial,bs.mail_state,bs.domain_name,bs.root_domain,bs.encrypt,bs.registrant,bs.mobile,bs.mail,bs.fill,bs.images,bs.validates,bs.multi_domain,bs.params,bs.open_step,p.product_type_id,pt.api_ptype,p.api_name,bs.access";
        $ssl = $this->queryBuilder($where,$fields,"DESC",GD::PTYPE_SSL)->find();
        return $ssl;
    }

    /**
     * SSL开通
     * @date: 2017年3月9日 上午10:21:07
     * @author: GuoPeng
     * @param: $order_id,$member_id
     * @return array
     */
    public function ssl_open($order_id,$member_id){
        $Order = new OrderModel();
        $product = new ProductModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        if(!$oinfo){
            $result_inf["code"] = -13; // 订单不存在或订单状态错误
            return $result_inf;
        }
        if($oinfo["state"] != SD::PAYMENT_ORDER){
            if($oinfo["state"] == SD::SUCCESS_ORDER){
                $result_inf["code"] = -124; // 该订单已经开通
                return $result_inf;
            }
            if($oinfo["state"] == SD::FAILURE_ORDER){
                $result_inf["code"] = -125; // 订单开通失败
                return $result_inf;
            }
        }
        if($oinfo["user_id"] != $member_id){
            return -101; // 业务不存在或不属于该会员
        }
        $product_info = $product->get_product($oinfo["product_id"]); // 获取订单产品信息
        if(!$product_info){
            return -2; // 产品获取失败
        }
        $business_info = array(
            "user_id" => $member_id,"business_id" => $oinfo["business_id"],
            "login_name" => $oinfo["login_name"],"product_id" => $product_info["id"],
            "product_name" => $product_info["product_name"],"create_time" => current_date(),
            "buy_time" => $oinfo["order_time"],"state" => 11,"free_trial" => $oinfo["free_trial"],
            "open_step" => 1,"params" => $oinfo["ip_address"],//SSL购买参数以逗号分隔，第一位代表多域名，第二位代表通配证书，第三位代表多服务器
            "note_appended" => "会员编号:".$member_id."开通".$product_info["product_name"]."订单编号：".$order_id,
            "access" => $api_access
        );
        if(!$this->add($business_info)){
            return -103; // 业务表插入失败
        }
        $yw_id = $this->getLastInsID(); // 获取业务ID
        $arr = array(
            "state" => SD::WAIT_ORDER,
			//"business_id"=> $yw_id,
            "note_appended" => "业务开通中！",
        );
        $Order->order_edit($order_id,$arr);
        return $yw_id;
    }

    /**
     * 查询域名是否绑定
     * @author: GuoPeng
     * @param $domain
     * @return mixed
     */
    public function checkDomain($domain){
        $where["domain_name"] = array("like","%$domain%");
        $ssl_info = $this->where($where)->field("domain_name")->find();
        return $ssl_info;
    }

    /**
     * ssl开通第一步-绑定域名
     * @author: GuoPeng
     * @return bool
     */
    public function ssl_open_bind(){
        $open_info = request();
        $order_id = $open_info["order_id"] + 0;
        $Order = new OrderModel();
        $ssl = new SslModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        $yw_id = $open_info["yw_id"] + 0;
        $uid = session("user_id");
        $where["bs.user_id"] = $uid;
        $where["bs.id"] = $yw_id;
        $ssl_info = $ssl->get_ssl_state($where);
        if(!$oinfo && !$ssl_info){
            $this->setError("订单业务信息错误！");
            return false;
        }
        if(empty($open_info["domain"])){
            $this->setError("请输入您要绑定的域名，然后进行下一步！");
            return false;
        }
        $ptype = $ssl_info["api_ptype"];
        $did = $oinfo["api_id"];
        $domain = implode(",",$open_info["domain"]);
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        try{
            $result = $transaction->bdDomain($ptype,$did,$progress = 1,$domain);
            api_log("user_id".$ssl_info["user_id"],"ptype:".$ptype."--did:".$did."--domain:".$domain,$result,"OV/EV开通第一步：绑定域名");
        }catch(\Exception $e){
            api_log("user_id".$ssl_info["user_id"],"ptype:".$ptype."--did:".$did."--domain:".$domain,$e->getMessage(),"OV/EV开通第一步：绑定域名-接口调用失败");
            $this->setError(-9);
            return false;
        }
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($xstr["info"]["status"] == 0){
                $dataarray = array(
                    "domain_name" => $domain,"open_step" => 2,
                );
                $where1["id"] = $yw_id;
                if($this->where($where1)->save($dataarray)){
                    return true; //成功
                }else{
                    $this->setError("绑定域名失败！");
                    return false; //失败
                }
            }else{
                $this->setError($xstr["info"]["error"]);
                return false; //失败
            }
        }else{
            // 调用接口获取根域名失败
            $this->setError($xstr["code"]);
            return false;
        }
    }

    /**
     * ssl开通第二步-填写资料
     * @author: GuoPeng
     * @return bool
     */
    public function ssl_fill_info(){
        $fill_info = request();
        $order_id = $fill_info["order_id"] + 0;
        $Order = new OrderModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        $yw_id = $fill_info["yw_id"] + 0;
        $uid = session("user_id");
        $where["bs.user_id"] = $uid;
        $where["bs.id"] = $yw_id;
        $ssl_info = $this->get_ssl_state($where);
        if(!$oinfo && !$ssl_info){
            $this->setError("订单业务信息错误！");
            return false;
        }
        $ptype = $ssl_info["api_ptype"];
        $did = $oinfo["api_id"];
        $progress = 2;
        $data["applyName"] = clearXSS($fill_info["p_name"]);
        $data["email"] = clearXSS($fill_info["p_email"]);
        $data["mobile"] = $fill_info["p_phone"] + 0;
        $data["QQ"] = empty($fill_info["p_qq"]) ? $fill_info["p_qq"] : $fill_info["p_qq"] + 0;
        $data["compType"] = $fill_info["c_type"] + 0;
        $data["compName"] = clearXSS($fill_info["c_name"]);
        $data["compEmail"] = clearXSS($fill_info["c_email"]);
        $data["compPhone"] = $fill_info["c_phone"];
        $preg_email = '/^[a-zA-Z0-9.!#$%&\'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/';
        $preg_phone = '/^1((3[0-9])|(4[57])|(5[0-35-9])|(6[0-9])|(7[0135678])|(8[0-9]))\d{8}$/';
        $preg_name = '/^[\x{4e00}-\x{9fa5}]{2,4}$/u';
        if(!preg_match($preg_email,$data["email"])){
            $this->setError("email格式错误！");
            return false;
        }
        if(!preg_match($preg_phone,$data["mobile"])){
            $this->setError("手机号码格式错误！");
            return false;
        }
        if(!preg_match($preg_name,$data["applyName"])){
            $this->setError("姓名格式错误！");
            return false;
        }
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        $input = "ptype:".$ptype."-did:".$did."-progress".$progress;
        try{
            $result = $transaction->fillinfo($ptype,$did,$progress,$data);
            api_log($ssl_info["user_id"],$input,$result,"OV/EV开通第二步：填写资料");
        }catch(\Exception $e){
            api_log($ssl_info["user_id"],$input,$e->getMessage(),"OV/EV开通第二步：填写资料-接口调用失败");
            $this->setError(-9);
            return false;
        }
        $fill = json_encode($data);
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($xstr["info"]["status"] == 0){
                $dataarray = array(
                    "open_step" => 3,"registrant" => $data["applyName"],"mail" => $data["email"],
                    "mobile" => $data["mobile"],"fill" => $fill,
                );
                $where1["id"] = $yw_id;
                if($this->where($where1)->save($dataarray) !== false){
                    return true; //成功
                }else{
                    $this->setError(-102);
                    return false;
                }
            }else{
                $this->setError($xstr["info"]["error"]);
                return false; //失败
            }
        }else{
            // 调用接口获取根域名失败
            $this->setError($xstr["code"]);
            return false;
        }
    }

    /**
     * ssl DV开通
     * @author: GuoPeng
     * @return bool
     */
    public function ssl_dv_open(){
        $fill_info = request();
        $order_id = $fill_info["order_id"] + 0;
        $Order = new OrderModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        $yw_id = $fill_info["yw_id"] + 0;
        $uid = session("user_id");
        $where["bs.user_id"] = $uid;
        $where["bs.id"] = $yw_id;
        $ssl_info = $this->get_ssl_state($where);
        if(!$oinfo || !$ssl_info){
            $this->setError("订单信息错误！");
            return false;
        }
        if(empty($fill_info["domain"])){
            $this->setError("未绑定域名");
            return false;
        }
        $domains = implode(",",$fill_info["domain"]);
        $ptype = $ssl_info["api_ptype"];
        $did = $oinfo["api_id"];
        $progress = 1;
        $data["applyName"] = $applyName = clearXSS($fill_info["p_name"]);
        $data["email"] = $email = clearXSS($fill_info["p_email"]);
        $data["mobile"] = $mobile = $fill_info["p_phone"] + 0;
//      $keytype = $fill_info["p_keytype"]+0;
        $preg_email = '/^[a-zA-Z0-9.!#$%&\'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/';
        $preg_phone = '/^1((3[0-9])|(4[57])|(5[0-35-9])|(6[0-9])|(7[0135678])|(8[0-9]))\d{8}$/';
        $preg_name = '/^[\x{4e00}-\x{9fa5}]{2,4}$/u';
        if(!preg_match($preg_email,$email)){
            $this->setError("email格式错误！");
            return false;
        }
        if(!preg_match($preg_phone,$mobile)){
            $this->setError("手机号码格式错误！");
            return false;
        }
        if(!preg_match($preg_name,$applyName)){
            $this->setError("姓名格式错误！");
            return false;
        }
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        try{
            $result = $transaction->bdDomain($ptype,$did,$progress,$domains,$applyName,$email,$mobile);
            api_log($ssl_info["user_id"],"ptype:".$ptype."--did:".$did."--ymbd:".$domains."--name:".$applyName."--mail:".$email."--tel:".$mobile,$result,"DV开通");
        }catch(\Exception $e){
            api_log($ssl_info["user_id"],"ptype:".$ptype."--did:".$did."--ymbd:".$domains."--name:".$applyName."--mail:".$email."--tel:".$mobile,$e->getMessage(),"DV开通-接口调用失败");
            $this->setError(-9);
            return false;
        }
        $fill = json_encode($data);
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($xstr["info"]["status"] == 0){
                $dataarray = array(
                    "state" => 6,"open_step" => 6,"domain_name" => $domains,"registrant" => $applyName,"mail" => $email,
                    "mobile" => $mobile,
                    //"encrypt" => $keytype,
                    "fill" => $fill,
                );
                $where1["id"] = $yw_id;
                if($this->where($where1)->save($dataarray)){
                    return true; //成功
                }else{
                    $this->setError(-102);
                    return false;
                }
            }else{
                $this->setError($xstr["info"]["error"]);
                return false; //失败
            }
        }else{
            // 调用接口获取根域名失败
            $this->setError($xstr["code"]);
            return false;
        }
    }

    /**
     * ssl开通第三步-上传资料
     * @author: GuoPeng
     * @return bool
     */
    public function ssl_upload_info(){
        $upload_info = request();
        $order_id = $upload_info["order_id"] + 0;
        $Order = new OrderModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        $yw_id = $upload_info["yw_id"] + 0;
        $uid = session("user_id");
        $where["bs.user_id"] = $uid;
        $where["bs.id"] = $yw_id;
        $ssl_info = $this->get_ssl_state($where);
        if(!$oinfo && !$ssl_info){
            $this->setError("订单业务信息错误！");
            return false;
        }
        $ptype = $ssl_info["api_ptype"];
        $did = $oinfo["api_id"];
        $progress = 3;
        //取得上传的图片信息
        if(empty($_FILES["letterImg"]["tmp_name"])){
            $this->setError("OV,EV授权书扫描件未上传");
            return false;
        }elseif(empty($_FILES["applyIdImg"]["tmp_name"])){
            $this->setError("身份证扫描件未上传");
            return false;
        }
        if(strpos($oinfo["api_name"],"ev") !== false){
            if(empty($_FILES["busiLicenceImg"]["tmp_name"])){
                $this->setError("营业执照扫描件未上传");
                return false;
            }elseif(empty($_FILES["billImg"]["tmp_name"])){
                $this->setError("发票扫描件未上传");
                return false;
            }
        }
        if($_FILES["letterImg"]["size"] > 300 * 1024){ // 设置图片上传大小
            $this->setError("OV,EV授权书扫描件不能大于300KB");
            return false;
        }elseif($_FILES["applyIdImg"]["tmp_name"] > 300 * 1024){
            $this->setError("身份证扫描件不能大于300KB");
            return false;
        }
        if(strpos($oinfo["api_name"],"ev") !== false){
            if($_FILES["busiLicenceImg"]["tmp_name"] > 300 * 1024){
                $this->setError("营业执照扫描件不能大于300KB");
                return false;
            }elseif($_FILES["billImg"]["tmp_name"] > 300 * 1024){
                $this->setError("发票扫描件不能大于300KB");
                return false;
            }
        }
        $img_type = array("jpg","gif","png","jpeg");
        foreach($_FILES as $fkey => $fvalue){
            if(!in_array(explode("/",$fvalue["type"])[1],$img_type)){
                $this->setError("非法图像文件！");
                return false;
            }
        }
        $base64_img = [];
        foreach($_FILES as $fkey => $fvalue){
            $img = $fvalue["tmp_name"];
            $image_data = fread(fopen($img,"r"),filesize($img));
            $base64_img[$fkey] = base64_encode($image_data);
        }
        if(empty($base64_img)){
            $this->setError("未获取到上传扫描件");
            return false;
        }
        // 上传文件
        $upload = new Upload();// 实例化上传类
        $upload->maxSize = 300 * 1024;// 设置附件上传大小
        $upload->exts = array("jpg","gif","png","jpeg");// 设置附件上传类型
        $upload->rootPath = "./Uploads/"; // 设置附件上传根目录
        $upload->savePath = ""; // 设置附件上传（子）目录
        $images = $upload->upload();
        if(!$images){// 上传错误提示错误信息
            $this->setError("上传错误");
            return false;
        }
        if(!isset($images["letterImg"])){
            $this->setError("OV,EV授权书扫描件上传错误");
            return false;
        }elseif(!isset($images["applyIdImg"])){
            $this->setError("身份证扫描件上传错误");
            return false;
        }
        if(strpos($oinfo["api_name"],"ev") !== false){
            if(!isset($images["busiLicenceImg"])){
                $this->setError("营业执照扫描件上传错误");
                return false;
            }elseif(!isset($images["billImg"])){
                $this->setError("发票扫描件上传错误");
                return false;
            }
        }
        $image = new Image();
        $data = [];
        foreach($images as $ikey => $ivalue){
            $info = "Uploads/".$ivalue["savepath"].$ivalue["savename"];
            //添加图片水印
            $image->open("./".$info)
                  ->water("./Public/frontend/images/apply-logo.png",Image::IMAGE_WATER_NORTHWEST,0)
                  ->save("./".$info);
            $data[$ikey] = $info;
        }
        if(!isset($images["letterImg"]) || !isset($images["applyIdImg"])){
            $this->setError("非法图像文件！");
            return false;
        }
        if(strpos($oinfo["api_name"],"ev") !== false){
            if(!isset($images["busiLicenceImg"]) || !isset($images["billImg"])){
                $this->setError("非法图像文件！");
                return false;
            }
        }
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        try{
            $result = $transaction->uploadinfo($ptype,$did,$progress,$base64_img);
            api_log($ssl_info["user_id"],"ptype:".$ptype."--bid:".$did."--progress:".$progress,$result,"OV/EV开通第三步：上传资料");
        }catch(\Exception $e){
            api_log($ssl_info["user_id"],"ptype:".$ptype."--bid:".$did."--progress:".$progress,$e->getMessage(),"OV/EV开通第三步：上传资料-接口调用失败");
            $this->setError(-9);
            return false;
        }
        $imgs = json_encode($data);
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($xstr["info"]["status"] == 0){
                $where1["id"] = $yw_id;
                $dataarray = array(
                    "open_step" => 4,"images" => $imgs
                );
                if($this->where($where1)->save($dataarray)){
                    return true;
                }else{
                    $this->setError(-102);
                    return false;
                }
            }else{
                $this->setError($xstr["info"]["error"]);
                return false; //失败
            }
        }else{
            // 调用接口失败
            $this->setError($xstr["code"]);
            return false;
        }
    }

    /**
     * ssl开通第四步-验证资料
     * @author: GuoPeng
     * @return bool
     */
    public function ssl_user_validate(){
        $validate_info = request(true);
        $order_id = $validate_info["order_id"] + 0;
        $Order = new OrderModel();
        $oinfo = $Order->order_find($order_id);
        $api_access = $oinfo["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        $uid = session("user_id");
        $yw_id = $validate_info["yw_id"] + 0;
        $where["bs.id"] = $yw_id;
        $where["bs.user_id"] = $uid;
        $ssl_info = $this->get_ssl_state($where);
        if(!$oinfo && !$ssl_info){
            $this->setError("订单业务信息错误！");
            return false;
        }
        $ptype = $ssl_info["api_ptype"];
        $did = $oinfo["api_id"];
        $progress = 4;
        $data["compName"] = clearXSS($validate_info["compName"]);
        $data["applyName"] = clearXSS($validate_info["applyName"]);
        $data["idnum"] = $validate_info["idnum"];
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        try{
            $result = $transaction->userValidate($ptype,$did,$progress,$data);
            api_log($ssl_info["user_id"],"ptype:".$ptype."--bid:".$did."--progress".$progress,$result,"OV/EV开通第四步：用户验证");
        }catch(\Exception $e){
            api_log($ssl_info["user_id"],"ptype:".$ptype."--bid:".$did."--progress".$progress,$e->getMessage(),"OV/EV开通第四步：用户验证-接口调用失败");
            $this->setError(-9);
            return false;
        }
        $validate = json_encode($data);
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($xstr["info"]["status"] == 1){
                $dataarray = array(
                    "validates" => $validate,"open_step" => 5
                );
                $where1["id"] = $yw_id;
                if($this->where($where1)->save($dataarray)){
                    return true; //成功
                }else{
                    $this->setError(-102);
                    return false;
                }
            }else{
                $this->setError($xstr["info"]["error"]);
                return false; //失败
            }
        }else{
            // 调用接口获取根域名失败
            $this->setError($xstr["code"]);
            return false;
        }
    }

    /**
     * 获取未开通业务
     * @author: GuoPeng
     * @param $ssl_info
     * @param $state
     * @return array
     */
    public function get_not_open($ssl_info,$state){
        $business_info = [];
        $i = 0;
        foreach($ssl_info as $key => $val){
            if($val["state"] == $state){
                $business_info[$i++] = $val["yid"];
            }
        }
        return $business_info;
    }

    /**
     * 获取ssl订单开通状态
     * @author: GuoPeng
     * @param $ssl_id
     * @return int
     */
    public function get_business_info($ssl_id){
        $Order = new OrderModel();
        $member_id = session("user_id");
        $where["id"] = ["eq",$ssl_id];
        $where["user_id"] = ["eq",$member_id];
        $ssl_info = $this->where($where)->find();
        $api_access = $ssl_info["access"] + 0;
        $api_access = $api_access ? $api_access : 1;
        if(empty($ssl_info)){
            $this->setError(-10);
            return false;
        }
        $order_where["business_id"] = ["eq",$ssl_info["business_id"]];
        $order_where["user_id"] = ["eq",$member_id];
        $oinfo = $Order->where($order_where)->find();//通过api_bid获取订单信息
        if(empty($oinfo)){
            $this->setError(-13);
            return false;
        }
        $ptype = GD::PTYPE_SSL;
        $did = $oinfo["api_id"];
        $tid = GD::TID_GET_SSL_BUSINESS;
        $agent = new AgentAide(1,$api_access);
        $transaction = $agent->servant;
        try{
            $result = $transaction->ssl_getinfo($ptype,$did,$tid);
            api_log($member_id,"ptype:".$ptype."--did:".$did."--tid:".$tid,$result,"会员".$member_id."获取SSL开通进度");
        }catch(\Exception $e){
            // 记录操作
            api_log($member_id,"ptype:".$ptype."--did:".$did."--tid:".$tid,$e->getMessage(),"会员".$member_id."获取SSL开通进度失败");
            $this->setError(-9);
            return false;
        }
        $xstr = json_decode($result,true);
        if($xstr["code"] == 0 && $xstr["code"] !== null){
            if($ssl_info["product_id"] == 229){
                if($xstr["info"]["progress"] != 3){
                    $this->setError("业务正在开通中");
                    return 0; //失败
                }
            }else{
                if($xstr["info"]["progress"] != 6){
                    $this->setError("业务正在开通中");
                    return 0; //失败
                }
            }
            $ssl_business_arr = [
                "create_time" => $xstr["info"]["createDate"],//创建时间
                "overdue_time" => $xstr["info"]["overDate"],//结束时间
                "state" => 1,//默认为1，正常状态
            ];
            $up_ssl["id"] = ["eq",$ssl_id];
            $ssl_edit = $this->where($up_ssl)->save($ssl_business_arr);
            if($ssl_edit === false){
                $ordet_data["order_log"] = $oinfo["order_log"]."ssl开通成功，业务表修改失败";
                $ordet_data["note_appended"] = "业务开通成功,业务表修改失败！";
                $Order->order_edit($oinfo["order_id"],$ordet_data);
                $this->setError(-103);
                return false;
            }
            $ordet_data["state"] = SD::STATE_ONLINE_TRAN_SUCCESS;
            $ordet_data["order_log"] = "业务开通成功";
            $ordet_data["note_appended"] = "业务开通成功！";
            $app = $Order->order_edit($oinfo["id"],$ordet_data);
            return true;
        }else{
            $this->setError($xstr["code"]);
            return false;
        }
    }

	/**
	 * SSL-Comodo证书开通
	 * @date: 2019年8月23日11:52:43
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function comodo_open(){
		$uid = session("user_id");
		$data = request();
		$type = $data["type"] + 0;
		$oid = $data["order_id"];
		$Order = new OrderModel();
		$oinfo = $Order->order_find($oid);
		if(!$oinfo){
			$return["status"] = false;
			$return["msg"] = "失败-订单不存在！";
			return $return;
		}
		if($oinfo["user_id"] != $uid){
			$return["status"] = false;
			$return["msg"] = "失败-订单不属于该会员！";
			return $return;
		}
		if($oinfo["state"] == 1){
			$return["status"] = false;
			$return["msg"] = "失败-该订单已经开通！";
			return $return;
		}
		if($oinfo["state"] != 6 && $oinfo["state"] != 2){
			$return["status"] = false;
			$return["msg"] = "失败-订单状态错误！";
			return $return;
		}
		$pid = $oinfo["product_id"];
		if($pid == 321){
			if($type == 1){
				if($oinfo["state"] == 6){
					$res = $this->comodo_save();
					return $res;
				}else{
					$return["status"] = false;
					$return["msg"] = "失败-开通步骤错误1！";
					return $return;
				}
			}elseif($type == 2){
				if($oinfo["state"] == 2){
					if($oinfo["system_type"] == 2){
						$res = $this->comodo_confirm();
						return $res;
					}else{
						$return["status"] = false;
						$return["msg"] = "失败-开通步骤错误2！";
						return $return;
					}
				}else{
					$return["status"] = false;
					$return["msg"] = "失败-开通步骤错误2！";
					return $return;
				}
			}elseif($type == 3){
				if($oinfo["state"] == 2){
					if($oinfo["system_type"] == 3){
						$res = $this->comodo_validate();
						if($res["status"] == true){
							$res = $this->comodo_getdown();
						}
						return $res;
					}else{
						$return["status"] = false;
						$return["msg"] = "失败-开通步骤错误3！";
						return $return;
					}
				}else{
					$return["status"] = false;
					$return["msg"] = "失败-开通步骤错误3！";
					return $return;
				}
			}elseif($type == 4){
				if($oinfo["state"] == 2){
					if($oinfo["system_type"] == 4){
						$res = $this->comodo_getdown();
						return $res;
					}elseif($oinfo["system_type"] == 3){
						$return["status"] = false;
						$return["msg"] = "请先验证域名！";
						return $return;
					}else{
						$return["status"] = false;
						$return["msg"] = "失败-开通步骤错误4！";
						return $return;
					}
				}else{
					$return["status"] = false;
					$return["msg"] = "失败-开通步骤错误4！";
					return $return;
				}
			}else{
				$return["status"] = false;
				$return["msg"] = "失败-开通步骤错误5！";
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "失败-订单产品类型错误！";
			return $return;
		}
	}

	/**
	 * SSL-Comodo证书开通-保存信息
	 * @date: 2019年8月23日11:52:43
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function comodo_save(){
		$uid = session("user_id");
		$data = request(true);
		$oid = $data["order_id"];
		$Order = new OrderModel();
		$oinfo = $Order->order_find($oid);
		$info["domain"] = $domain = $data["domain"];//绑定域名
		$info["yzlx"] = $yzlx = $data["yzlx"];//验证类型（dns：DNS验证，file：网站验证）
		$info["email"] = $email = $data["email"];
		$info["tel"] = $tel = $data["tel"];
		$info["xing"] = $xing = $data["xing"];
		$info["ming"] = $ming = $data["ming"];
		$info["password"] = $password = $data["password"];
		if($yzlx != "dns" && $yzlx != "file"){
			$return["status"] = false;
			$return["msg"] = "失败-验证类型错误！";
			return $return;
		}
		$preg_domain = "/^[A-Za-z0-9][A-Za-z0-9-]{0,62}.([A-Za-z0-9-]+.)*[a-zA-Z]{2,6}$/";
		$ymlx = explode(",",$oinfo["ip_address"]);
		$domain_arr = explode(",",$domain);
		$multi_domain = $ymlx[0];
		$global_domain = $ymlx[1];
		if($multi_domain == 0 && $global_domain == 0){
			if(count($domain_arr) > 1){
				$return["status"] = false;
				$return["msg"] = "失败-单域名证书只能填写一个域名！";
				return $return;
			}
			if(!preg_match($preg_domain,$domain)){
				$return["status"] = false;
				$return["msg"] = "失败-域名格式错误！";
				return $return;
			}
		}
		if($multi_domain != 0){
			$multi_domain = $ymlx[0] + 1;
			if(count($domain_arr) > $multi_domain){
				$return["status"] = false;
				$return["msg"] = "失败-最多填写{$multi_domain}个域名！";
				return $return;
			}
			foreach($domain_arr as $val){
				if(!preg_match($preg_domain,$val)){
					$return["status"] = false;
					$return["msg"] = "失败-域名格式错误2！";
					return $return;
				}
			}
		}
		if($global_domain != 0){
			if(count($domain_arr) > $global_domain){
				$return["status"] = false;
				$return["msg"] = "失败-最多填写{$global_domain}个域名！";
				return $return;
			}
			foreach($domain_arr as $val){
				if(substr($val,0,2) != "*."){
					$return["status"] = false;
					$return["msg"] = "失败-域名格式错误，通配型绑定域名请在域名前加“*.”！";
					return $return;
				}
				if(!preg_match($preg_domain,substr($val,2))){
					$return["status"] = false;
					$return["msg"] = "失败-域名格式错误3！";
					return $return;
				}
			}
		}
		$preg_email = '/^[a-zA-Z0-9.!#$%&\'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/';
		$preg_tel = '/^1((3[0-9])|(4[57])|(5[0-35-9])|(6[0-9])|(7[0135678])|(8[0-9]))\d{8}$/';
		$preg_name = '/^[a-zA-Z]{2,14}$/';
		$preg_psd = '/^(?=.*[a-zA-Z])(?=.*\d)[a-zA-Z\d]{6,25}$/';
		if(!preg_match($preg_email,$email)){
			$return["status"] = false;
			$return["msg"] = "失败-email格式错误！";
			return $return;
		}
		if(!preg_match($preg_tel,$tel)){
			$return["status"] = false;
			$return["msg"] = "失败-手机号码格式错误！";
			return $return;
		}
		if(!preg_match($preg_name,$xing) || !preg_match($preg_name,$ming)){
			$return["status"] = false;
			$return["msg"] = "失败-姓名格式错误！";
			return $return;
		}
		if(!preg_match($preg_psd,$password)){
			$return["status"] = false;
			$return["msg"] = "失败-密码格式错误（6-25位数字+密码）！";
			return $return;
		}
		$did = $oinfo["api_id"];
		$access = $oinfo["access"] + 0;
		$access = $access ? $access : 1;
		$agent = new AgentAide(1,$access);
		$transaction = $agent->servant;
		$log = "ptype:csafessl-pname:saveinfo-tid:2-domain:{$domain}-did:{$did}-input_name:{$yzlx}-ownerXing:{$xing}-ownerMing:{$ming}-ownerTelN:{$tel}-ownerEmail:{$email}-password:{$password}-access:{$access}";
		try{
			$result = $transaction->comodo_save_ssl($did,$domain,$yzlx,$xing,$ming,$tel,$email,$password);
			api_log($uid,$log,$result,"SSL-Comodo证书开通（保存信息）");
		}catch(\Exception $e){
			api_log($uid,$log,$e->getMessage(),"SSL-Comodo证书开通（保存信息）失败-接口调用失败");
			$return["status"] = false;
			$return["msg"] = "失败-接口调用失败！";
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] === 0){
			$xstr = $xstr["info"];
			if($xstr["code"] === 1){
				$info["entry"] = explode(",",$xstr["result"]["entry"]);
				$info["context"] = $xstr["result"]["context"];
				$info["ymbd"] = $xstr["result"]["ymbd"];
				$fname = str_replace(".txt","",strrchr($info["entry"][0],"/"));
				$fcontent = $info["context"];
				$res = $this->download_file($fname,$fcontent);
				$info["dfile"] = $res;
				$dataarray = array(
					"state" => 2,  //订单状态已付款
					"system_type" => 2,
					"root_domain" => json_encode($info),
					"order_log" => $oinfo["order_log"]."[保存信息成功]",
				);
				if($Order->order_edit($oid,$dataarray) === false){
					$return["status"] = false;
					$return["msg"] = "成功-订单信息更新失败！";
					return $return;
				}else{
					$return["msg"] = "成功！";
					$return["status"] = true;
					return $return;
				}
			}else{
				$return["status"] = false;
				if(isset($xstr["message"])){
					$return["msg"] = "接口调用失败！";
				}else{
					$return["msg"] = "接口调用失败：".$xstr["message"];
				}
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "失败-".business_code($xstr["code"]);
			return $return;
		}
	}

	/**
	 * 生成下载压缩包
	 * @时间: 2019年9月3日16:48:52
	 * @author: GuoPeng
	 * @return bool
	 */
	public function download_file($fname,$fcontent){
		//下载目录，如果没有就创建./Update
		$path = getcwd().DS."Update";
		if(!is_dir($path)){
			mkdir($path,0755,true);
		}
		$path .= DS."SSL_Check_Domain_File";
		if(!is_dir($path)){
			mkdir($path,0755,true);
		}
		$path .= DS.$fname;
		if(!is_dir($path)){
			mkdir($path,0755,true);
		}
		//压缩包文件名
		$zip_file_path = $path.DS."ssl_.zip";
		if(is_file($zip_file_path)){
			$file = "/Update/SSL_Check_Domain_File/{$fname}/ssl_.zip";
			return $file;
		}
		$file = $path.DS.".well-known";
		if(!is_dir($file)){
			mkdir($file,0755,true);
		}
		$file .= DS."pki-validation";
		if(!is_dir($file)){
			mkdir($file,0755,true);
		}
		$file .= DS."{$fname}.txt";
		file_put_contents($file,$fcontent);
		//不存在临时文件就创建
		file_put_contents($zip_file_path,'');
		//建立压缩文件句柄
		$zip = new \PclZip($zip_file_path);
		$added_files = [
			realpath($path.DS."/.well-known")
		];
		//开始备份
		$nums = $zip->create($added_files,PCLZIP_OPT_REMOVE_PATH,realpath($path));
		if($nums === 0){
			$this->info = $zip->errorInfo(true);
			return false;
		}
		rmdir($path.DS.".well-known");
		$file = "/Update/SSL_Check_Domain_File/{$fname}/ssl_.zip";
		return $file;
	}

	/**
	 * SSL-Comodo证书开通-确认信息
	 * @date: 2019年8月23日11:52:43
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function comodo_confirm(){
		$uid = session("user_id");
		$data = request();
		$oid = $data["order_id"];
		$Order = new OrderModel();
		$oinfo = $Order->order_find($oid);
		$did = $oinfo["api_id"];
		$bid = $oinfo["business_id"];
		$access = $oinfo["access"] + 0;
		$access = $access ? $access : 1;
		$agent = new AgentAide(1,$access);
		$transaction = $agent->servant;
		$log = "ptype:csafessl-pname:checkcomodoauth-tid:2-did:{$did}-bid:{$bid}-access:{$access}";
		try{
			$result = $transaction->comodo_confirm_ssl($did,$bid);
			api_log($uid,$log,$result,"SSL-Comodo证书开通（确认信息）");
		}catch(\Exception $e){
			api_log($uid,$log,$e->getMessage(),"SSL-Comodo证书开通（确认信息）失败-接口调用失败");
			$return["status"] = false;
			$return["msg"] = "失败-接口调用失败！";
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] === 0){
			$xstr = $xstr["info"];
			if($xstr["code"] === 1){
				$dataarray = array(
					"state" => 2,  //订单状态已付款
					"system_type" => 3,
					"order_log" => $oinfo["order_log"]."[确认信息成功]",
				);
				if($Order->order_edit($oid,$dataarray) === false){
					$return["status"] = false;
					$return["msg"] = "成功-订单信息更新失败！";
					return $return;
				}else{
					$return["status"] = true;
					$return["msg"] = "成功-确信息成功！";
					return $return;
				}
			}else{
				$return["status"] = false;
				if(isset($xstr["message"])){
					$return["msg"] = "接口调用失败！";
				}else{
					$return["msg"] = "接口调用失败：".$xstr["message"];
				}
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "失败-".business_code($xstr["code"]);
			return $return;
		}
	}

	/**
	 * SSL-Comodo证书开通-证书验证
	 * @date: 2019年8月23日11:52:43
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function comodo_validate(){
		$uid = session("user_id");
		$data = request();
		$oid = $data["order_id"];
		$Order = new OrderModel();
		$oinfo = $Order->order_find($oid);
		$bid = $oinfo["business_id"];
		$access = $oinfo["access"] + 0;
		$access = $access ? $access : 1;
		$agent = new AgentAide(1,$access);
		$transaction = $agent->servant;
		$log = "ptype:csafessl-pname:checkcomodo-tid:2-bid:{$bid}-access:{$access}";
		try{
			$result = $transaction->comodo_validate_ssl($bid);
			api_log($uid,$log,$result,"SSL-Comodo证书开通（证书验证）");
		}catch(\Exception $e){
			api_log($uid,$log,$e->getMessage(),"SSL-Comodo证书开通（证书验证）失败-接口调用失败");
			$return["status"] = false;
			$return["msg"] = "失败-接口调用失败！";
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] === 0){
			$xstr = $xstr["info"];
			if($xstr["code"] === 1){
				$dataarray = array(
					"state" => 2,  //订单状态成功
					"system_type" => 4,  //订单状态成功
					"order_log" => $oinfo["order_log"]."[证书验证成功]",
				);
				if($Order->order_edit($oid,$dataarray) === false){
					$return["status"] = false;
					$return["msg"] = "成功-订单信息更新失败！";
					return $return;
				}else{
					$return["status"] = true;
					$return["msg"] = "验证通过";
					return $return;
				}
			}else{
				$return["status"] = false;
				if(isset($xstr["message"])){
					$return["msg"] = "接口调用失败！";
				}else{
					$return["msg"] = "接口调用失败：".$xstr["message"];
				}
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "失败-".business_code($xstr["code"]);
			return $return;
		}
	}

	/**
	 * SSL-Comodo证书-下载证书
	 * @date: 2019年8月23日11:52:43
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function comodo_getdown(){
		$uid = session("user_id");
		$data = request();
		$oid = $data["order_id"];
		$Order = new OrderModel();
		$oinfo = $Order->order_find($oid);
		$where["business_id"] = $oinfo["business_id"];
		$where["root_domain"] = $oinfo["api_ip_id"];
		$where["user_id"] = $uid;
		$where["product_id"] = $oinfo["product_id"];
		$ssl_binfo = $this->where($where)->find();
		//查询业务是否正在开通中
		if($ssl_binfo){
			$Order->order_edit($oid,["state" => 1,"system_type" => 5]);
			$fill = json_decode($ssl_binfo["fill"],true);
			$info["address"] = $fill["add"];
			$info["psd"] = $fill["psd"];
			$return["status"] = true;
			$return["msg"] = "";
			$return["info"] = $fill;
			return $return;
		}
		$bid = $oinfo["business_id"];
		$access = $oinfo["access"] + 0;
		$access = $access ? $access : 1;
		$agent = new AgentAide(1,$access);
		$transaction = $agent->servant;
		$log = "ptype:csafessl-pname:getdowncomodocert-tid:2-bid:{$bid}-access:{$access}";
		try{
			$result = $transaction->comodo_getdown_ssl($bid);
			api_log($uid,$log,$result,"SSL-Comodo证书证书下载");
		}catch(\Exception $e){
			api_log($uid,$log,$e->getMessage(),"SSL-Comodo证书证书下载失败-接口调用失败");
			$return["status"] = false;
			$return["msg"] = "失败-接口调用失败！";
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] === 0){
			$xstr = $xstr["info"];
			if($xstr["code"] === 1){
				$finfo = json_decode($oinfo["root_domain"],true);
				$fill["filename"] = $xstr["result"]["filename"];
				$fill["add"] = $xstr["result"]["message"];
				$fill["psd"] = $xstr["result"]["password"];
				$create_time = current_date();
				$overdue_time = add_dates($create_time,$oinfo["order_time"]);
				$business_info = array(
					"user_id" => $uid,
					"business_id"=> $oinfo["business_id"],
					"root_domain"=> $oinfo["api_ip_id"],
					"login_name" => $oinfo["login_name"],
					"product_id" => $oinfo["product_id"],
					"product_name" => $oinfo["product_name"],
					"create_time" => $create_time,
					"overdue_time" => $overdue_time,
					"buy_time" => $oinfo["order_time"],
					"state" => 1,
					"free_trial" => $oinfo["free_trial"],
					"open_step" => 6,
					"params" => $oinfo["ip_address"],//SSL购买参数以逗号分隔，第一位代表多域名，第二位代表通配证书，第三位代表多服务器
					"note_appended" => "{$oinfo["product_name"]}开通成功，订单编号：{$oid}",
					"access" => 11,
					"domain_name" => $finfo["domain"],
					"registrant" => $finfo["name"],
					"mobile" => $finfo["tel"],
					"mail" => $finfo["email"],
					"fill" => json_encode($fill),
				);
				if($this->add($business_info) === false){
					$return["status"] = false;
					$return["msg"] = "失败-业务生成失败，请重试！";
					return $return;
				}
				$info["address"] = $xstr["result"]["message"];
				$info["psd"] = $xstr["result"]["password"];
				$dataarray = array(
					"state" => 1,  //订单状态成功
					"system_type" => 5,
					"order_log" => $oinfo["order_log"]."[证书下载地址获取成功]",
				);
				if($Order->order_edit($oid,$dataarray) === false){
					$return["status"] = false;
					$return["msg"] = "成功-订单信息更新失败！";
					$return["info"] = $info;
					return $return;
				}else{
					$return["status"] = true;
					$return["msg"] = "成功！";
					$return["info"] = $info;
					return $return;
				}
			}else{
				$return["status"] = false;
				if(isset($xstr["message"])){
					$return["msg"] = "接口调用失败！";
				}else{
					$return["msg"] = "接口调用失败：".$xstr["message"];
				}
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "失败-".business_code($xstr["code"]);
			return $return;
		}
	}
}