/** Created by 123456 on 2019/3/12. */
/**
 * 展示信息弹窗
 * @param title
 * @param content
 * @param func
 * @param param
 */
function ShowAlert(content,func,param,title){
    title = title || "温馨提示";
    layer.open({
        title: [title,'background-color:#009de0;color:rgb(255, 255, 255);border-radius:3px;'],
        anim: 'up',
        content: content,
        style: 'font-size:18px;border-radius:3px;',
        shadeClose:false,
        btn: ['确认'],
        yes: function(index){
            if(func){
                if(param){
                    func.call(this,param);
                }else{
                    func.call(this);
                }
            }
            layer.close(index);
        }
    });
}

/**
 * 无按钮展示信息弹窗
 * @param content
 * @param title
 */
function ShowMsg(content,title){
    title = title || "温馨提示";
    layer.open({
        title: [title,'background-color:#009de0;color:rgb(255, 255, 255);border-radius:3px;'],
        anim: 'up',
        content: content,
        style: 'font-size:18px;border-radius:3px;',
        shadeClose:false
    });
}

/**
 * 等待信息弹窗
 * @param content
 */
function ShowWaitMsg(content){
    content = content || "加载中";
    layer.msg(content,{icon:16,shade: 0.5,style:'font-size:18px;border-radius:3px;',time:0,shadeClose:true});
}

/**
 * 确认提示弹窗
 * @param content
 * @param func
 * @param param
 * @param title
 */
function ShowConfirm(content,func,param,title){
    title = title || "温馨提示";
    layer.open({
        title: [title,'background-color:#009de0;color:rgb(255, 255, 255);border-radius:3px;'],
        anim: 'up',
        content: content,
        style: 'font-size:18px;border-radius:3px;',
        btn: ["确认","取消"],
        yes: function(index){
            if(func){
                if(param){
                    func.call(this,param);
                }else{
                    func.call(this);
                }
            }
            layer.close(index);
        }
    });
}

/**
 * 关闭上一个弹窗
 */
function CloseMsg(){
    layer.closeAll(layer.index);
}

/**
 * 关闭所有弹窗
 */
function CloseAllMsg(){
    layer.closeAll();
}

/**
 * 跳转
 * @param url
 */
function ToPage(url){
    url = url || document.URL;
    window.location.href = url;
}